2019-03-31  Araki Ken  <arakiken@users.sf.net>

	* 3.8.8 released.
	  (tag "rel-3_8_8")

	* configure.in, mlterm.spec, main/version.h.in,
	  mlterm.c, android/jni/version.h:
	  updated for 3.8.8.

	* doc/en/PROTOCOL, man/mlterm.1: Updated.

2019-03-31  Araki Ken  <arakiken@users.sf.net>

	* gtk/README, libvterm/README: Updated.

	* vte.c:
	  - vte_terminal_set_colors() resets fg or bg color if 'foreground'
	    or 'background' argument is NULL and palette_size is 0.
	  - vte_set_test_flags(), vte_terminal_get_color_background_for_draw()
	    and vte_regex_substitute() symbols are added.

2019-03-29  Araki Ken  <arakiken@users.sf.net>

	* beos.cpp, sdl2/ui_display.c: Wheel mouse is supported.

2019-03-28  Araki Ken  <arakiken@users.sf.net>

	* fb/ui_font.c: xfont->height is calculated by face->height instead of
	  face->max_advance_height.

	* sdl2/ui_display.c: SDL_WINDOWEVENT_EXPOSED is processed.

2019-03-26  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, README.ja, etc/main, etc/main.ja: Updated.

	* ui_font_manager.c:
	  - The default value of min_font_size is changed from 6 to 1.
	  - The default value of max_font_size is changed from 30 to 100.

	* vt_pty_mosh.cpp: If select() in watch_ptys() fails, loop continues.

	* ui_event_source.c: Whether errno of select() is EINTR is checked.

	* ui_event_source-cocoa.m: Whether errno of select() is EAGAIN or EINTR
	  is checked.

2019-03-25  Araki Ken  <arakiken@users.sf.net>

	* README.android, README.sdl2, doc/en/README.ssh, doc/ja/README.ssh,
	  README.ja, etc/main, etc/main.ja, man/mlterm.1: Updated.

	* beos.cpp, sdl2/ui_display.c: Drag&Drop is supported.

	* cocoa.m: Command+Drag&Drop starts scp.

	* wayland/ui.h, wayland/ui_display.c: Shift+Drag&Drop start scp.

	* encodefilter/configure.in, encodefilter/module/Makefile.in:
	  ef_jis_property.lo is forcibly linked to libmef_jajp.so

	* bl_conf_io.c, im_iiimf_aux.c, daemon.c, vt_termcap.c: The return value
	  of bl_file_get_line() is regarded as NULL-terminated string.

	* bl_file.[ch]: bl_file_get_line() returns NULL-terminated string.

	* libctl/vt_iscii.c: ISCII tables except hindi.table are excluded.

2019-03-24  Araki Ken  <arakiken@users.sf.net>

	* sdl2/ui_display.c:
	  - KMOD_GUI => CommandMask in get_mod_state().
	  - SDL_KEYDOWN event in poll_event() calls ui_window_receive_event()
	    if state is CommandMask.

	* sdl2/ui.h: CommandMask is added.

	* ui_display_freebsd.c: All 8 bits of keymap.key[code].spcl are checked.

	* servman/Makefile.in, libotl/Makefile.in, libtype/Makefile.in:
	  INSTALL_OPT is removed.

2019-03-23  Araki Ken  <arakiken@users.sf.net>

	* Androkd.mk: Compiling error is fixed.

	* main.c: main_loop_final() is always called at exit.

	* bl_config.h.in: '#undef HAVE_STDINT_H' is added.

	* baselib/configure.in: The existence of stdlib.h is checked.

2019-03-22  Araki Ken  <arakiken@users.sf.net>

	* configure.in: @UTMP_CFLAGS@ in vtemu/Makefile.in is replaced.

	* ui.h, ui_window.c:
	  - UI_RESIZE event type is added.
	  - If UI_RESIZE event is received, clear_margin_area() is called.

	* beos.cpp: 'width' and 'height' of MLWindow::FrameResized(),
	  MLWindow::ResizeTo() and MLView::ResizeTo() are treated as
	  'right - left' and 'bottom - top'.

2019-03-21  Araki Ken  <arakiken@users.sf.net>

	* sdl2/ui_display.c: Compiling error is fixed.

	* main-con.c, console/ui_display.c:
	  Whether IMAXBEL is defined or not is checked.

	* */Makefile.in: -lX11 is removed.

	* configure.in:
	  - "-lX11" is set to X_LIBS if X is found.
	  - utmp is checked and INSTALL_OPT is set after executing ./configure
	    at subdirs.

	* c_sixel.c:
	  Segfault in handling errors in load_sixel_from_data() is fixed.

2019-03-20  Araki Ken  <arakiken@users.sf.net>

	* ui_window.c: expose() exposes all screen even if
	  win->update_window_flag is 0 and force_expose is 1.

	* beos.cpp, beos.h:
	  - force_expose is added to arguments of draw_screen().
	  - force_expose is added to arguments of view_update().

	* configure.in: "gui" => "$gui"

2019-03-19  Araki Ken  <arakiken@users.sf.net>

	* ui_simple_sb_view.c: Drawing down side shade is fixed.

	* bl_unistd.c: __bl_setenv() considers 'overwrite' argument.

2019-03-18  Araki Ken  <arakiken@users.sf.net>

	* java/Makefile.in: Updated to Java 10 or later.

	* mlterm.c: Compiling error is fixed.

2019-03-17  Araki Ken  <arakiken@users.sf.net>

	* vt_pty_ssh.c: If libssh2_userauth_list() returns NULL but no error
	  happens, authentication is skipped.

	* README.ja: Updated.

	* im_iiimf_aux.c: Compiling error is fixed.

	* bl_util.[ch]: bl_base64_encode() is removed.

2019-03-17  Araki Ken  <arakiken@users.sf.net>

	* beos.cpp: Conflicting Control+a with B_HOME etc is fixed.

	* ui.h: 0xe0000 mask is set for XK_Home etc.

	* vt_util.[ch]: Removed.

	* bl_util.c:
	  - Added.
	  - bl_hex_decode(), bl_hex_encode() and bl_base64_decode() are moved
	    from vt_util.[ch].
	  - bl_hls_to_rgb() is moved from c_sixel.c.
	  ^ bl_rgb_to_hls() is moved from vt_parser.c (rgb_to_hls()).
	  - bl_get_user_name() is added.

	* bl_config.h.in: '#undef HAVE_GETPWUID' is added.

	* src/Makefile.in: bl_util.o is added to COMOBJ.

	* baselib/configure.in: The existence of getpwuid is checked.

2019-03-16  Araki Ken  <arakiken@users.sf.net>

	* bl_locale.c, mef.c, im_skk.c, im_wnn.c, mc_font.c, mc_radio.c,
	  ui_font_ft.c, ui_screen.c, ui_shortcut.c, win32/ui_font.c,
	  xlib/ui_font.c, vt_iscii.c, vt_shape_bidi.c, vt_char_encoding.c,
	  vt_termcap.c: Some array declarations are formatted.

2019-03-16  Araki Ken  <arakiken@users.sf.net>

	* ui_event_source-cocoa.m: If vt_check_sig_child() returns true,
	  ui_event_source_process() exits on cocoatouch.

	* vt_term_manager.[ch]:
	  vt_check_sig_child() is compiled if __APPLE__ is defined.

	* ef_euccn_parser.c: ef_get_ucs_property() is removed.

	* ef_jis_property.[ch]: 'size' is removed from arguments of
	  ef_get_jisx0208_1983_property() and ef_get_jisx0213_2000_1_property().

	* ef_jisx0208_1983_property.[ch], ef_jisx0213_2000_property.[ch]
	  => ef_jis_property.[ch]

	* ef_ucs4_jisx0213.c: ef_map_ucs4_to_jisx0213_2000_1() calls
	  ef_get_jisx0213_2000_1_property().

	* ef_ucs4_jisx0208.c: ef_map_ucs4_to_jisx0208_1983() calls
	  ef_get_jisx0208_1983_property().

	* encodefilter/module/Makefile.in: @EF_JIS_PROP_LO@ is added in linking libmef_jajp.la

	* encodefilter/configure.in: EF_JIS_PROP_LO is defined if
	  $allow_undefined_flag is "unsupported".

2019-03-16  Araki Ken  <arakiken@users.sf.net>

	* ui_event_source.c: If vt_check_sig_child() returns true,
	  receive_next_event() exits on Haiku.

	* vt_term_manager.[ch]: vt_check_sig_child() is added.

	* beos.cpp: Whether uiwindow is NULL or not is checked in
	  MLView::{Draw|KeyDown|MouseDown|MouseMoved|MouseUp}().

2019-03-16  Araki Ken  <arakiken@users.sf.net>

	* beos.cpp: beos_dialog_{password|okcancel|alert}() are implemented.

	* vt_pty_ssh.c: Compiling error on Haiku is fixed.

2019-03-14  Araki Ken  <arakiken@users.sf.net>

	* beos.cpp: MLView::cur_font, buttons and messenger are initialized.

2019-03-13  Araki Ken  <arakiken@users.sf.net>

	* beos.cpp:
	  - MLView::messenger is deleted in set_input_focus().
	  - Not only MLView::Draw() but also KeyDown(), MouseDown(), MouseMoved()
	    and MouseUp() check ((ui_screen_t*)uiwindow)->term.

2019-03-12  Araki Ken  <arakiken@users.sf.net>

	* beos.cpp: BRect::right and BRect::bottom are obtained by subtracting
	  1 from BRect:left + width and BRect::top + height.

	* c_sixel.c: Memory allocation is fixed.

	* ui_im_status_screen.c: "\x1b[?7l" is output to the status line.

	* ui_event_source.c: additional_fds is processed on SDL2.

	* beos/ui_imagelib.c: Unused code is removed.

	* beos.cpp: Segfault by unexpected NULL or non-NULL value of
	  MLView::messenger when a focused view is changed in inputting with ime.

2019-03-10  Araki Ken  <arakiken@users.sf.net>

	* beos/ui_imagelib.c: load_file() processes pic_mod.

	* beos.cpp, beos.h: beos_get_bits() is added.

2019-03-10  Araki Ken  <arakiken@users.sf.net>

	* ControlSequences, README.cocoa, README.cocoatouch: Updated.

	* ui_shortcut.c: The default value of INSERT_SELECTION is changed from
	  Shift+Insert to Command+v on MacOSX and iOS.

	* vt_parser.c: CSI ? 1010 h, CSI ? 1010 l, CSI ? 1034 h, CSI ? 1034 l,
	  CSI ? 1036 h and CSI ? 1036 l are supported.

	* quartz/ui_event_source-cocoa.m: Added.

	* quartz/ui_event_source.c: Removed.

	* ui_screen.c: preedit() which is set to ui_window_t::preedit is added.

	* sdl2/ui_display.c: update_ime_text() is moved to preedit() in ui_screen.c.

	* uitoolkit/Makefile.in: ui_event_source.o is moved from OBJ1 to OBJ2_*,
	  and ui_event_source-cocoa.o is added to OBJ2_quartz.

	* cocoa.[hm], cocoatouch.m:
	  - update_ime_text() is moved to preedit() in ui_screen.c.
	  - Almost all codes in monitor_pty() is moved to ui_event_source_process().
	  - cocoa_add_fd() and cocoa_remove_fd() are integrated to
	    ui_event_source_add_fd() and ui_event_source_remove_fd().

	* beos.cpp:
	  - update_ime_text() is moved to preedit() in ui_screen.c.
	  - beos_resize_image() is implemented.

	* */ui.h: UIWINDOW_SUPPORTS_PREEDITING is added.

2019-03-09  Araki Ken  <arakiken@users.sf.net>

	* ui_layout.c: term->next[0] and term->next[1] are destroyed before
	  destroying term in window_destroyed_intern().

	* ui_event_source.c: beos_lock() and beos_unlock() are called on Haiku.

	* quartz/ui_window.c: IS_XSCREEN() => IS_UISCREEN()

	* beos/ui_window.c:
	  window_dealloc() (which exits the current thread and never returns) is
	  placed at the end of ui_window_final().

	* beos/ui_display.c: ui_window_final() is moved after updating
	  disp->num_roots and disp->roots.

	* beos.cpp, beos.h:
	  - B_INPUT_METHOD_EVENT is processed in MLView::MessageReceived().
	  - beos_lock(), beos_unlock(), view_lock(), view_unlock(), window_lock()
	    and window_unlock() are added.
	  - LockLooperWithTimeout() is replaced by {window|view}_lock() in
	    MLWindow::Foo() and MLView::Bar()
	  - update_ime_text() is added.
	  - window_get_position() is implemented.
	  - window_get_orphan() is added for input method window.
	  - widow_move_resize() is removed and window_move() is added.

	* ui.h: XIM_SPOT_IS_LINE_TOP is defined.

2019-03-05  Araki Ken  <arakiken@users.sf.net>

	* doc/en/README.beos: Added.

	* configure.in: The value of INSTALL_OPT is always "-m 755" on BeOS (Haiku).

	* main-beos.cpp: "extern char *global_args" is removed.

	* beos.cpp:
	  - UI_KEY_FOCUS_IN event is triggered when BView::MakeFocus() is called.
	  - "char *global_args" is removed.

	* ui_main_config.c: The default value of "use_login_shell" option is
	  changed from 0 to 1 on BeOS (Haiku).

	* vt_pty.h: OPEN_PTY_ASYNC is always defined on BeOS (Haiku).

2019-03-04  Araki Ken  <arakiken@users.sf.net>

	* ui_screen_manager.c: Using uninitialized value is fixed.

	* ui_event_source.c: vt_get_all_terms() is called every time
	  in select() loop.

	* ui_imagelib.c:
	  - resize() is replaced by beos_resize_image().
	  - ui_destroy_image() is implemented.

	* beos.cpp, beos.h:
	  - view_visual_bell() and beos_load_image() are implemented.
	  - view_destroy_image() and beos_resize_image() are added.

	* configure.in, main/Makefile.in: BEOS_LIBS is removed.

2019-03-03  Araki Ken  <arakiken@users.sf.net>

	* main_loop.c: bl_alloca_garbage_collect() is called at the end of
	  main_loop_final().

	* gdiplus.cpp, beos.cpp: alloca() is removed.

	* vt_str_alloca() => vt_str_alloca() + vt_str_init().

	* vt_str.[ch]: __vt_str_init() is removed and vt_str_alloca() doesn't call it.

	* bl_arg_str_to_array() => bl_argv_alloca() + bl_arg_str_to_array().

	* bl_args.[ch]: bl_arg_str_to_array() is separated to
	  bl_argv_alloca() and bl_arg_str_to_array() in order not to
	  use alloca() in arguments of a function.

	* bl_sig_child.[ch]:
	  bl_sig_child_{init|suspend|resume}() => bl_sig_child_{start|stop}()

	* bl_conf.[ch]: char* => const char*

	* bl_def.h: #include <stdint.h> to check SIZE_MAX on Haiku R1 Beta1.

	* bl_str.c: bl_str_dup() => __bl_str_dup()

	* bl_str_alloca_dup() => alloca() + strcpy()

	* bl_men.h: bl_str_alloca_dup() is removed.

	* The return value of some functions is changed from int to void.

	* ui_screen_manager.c:
	  close_screen() calls close_screen_intern() directly.

	* beos.cpp, beos.h:
	  - MLView::SetFont() is added.
	  - MLWindow::Quit() is added.
	  - MLWindow::WindowActivated() and MLWindow::FrameResized() use
	    LockLooperWithTimeout() - UnlockLooper().
	  - view_set_clip(), view_unset_clip(), window_set_title() and beos_beep()
	    are implemented.
	  - view_draw_string() supports font->double_draw_gap.
	  - is_italic and is_bold are added to arguments of beos_create_font().
	  - beos_font_get_advance() supports characters >= 0x80.

	* beos/ui_font.c:
	  - ui_font_new() processes size_attr.
	  - ui_calculate_char_width() supports proportional fonts and
	    considers font->is_var_col_width.

	* beos/ui_window.c:
	  - need_pointer_motion_mask() is removed.
	  - window_dealloc() is placed at the end of ui_window_final() because
	    BWindow::Quit() in window_dealloc() exits the current thread.

	* beos/ui.h: XFontStruct::bfont is renamed to XFontStruct::fid.

	* uitoolkit/beos: Added. (The previous commit failed to add it.)

2019-02-23  Araki Ken  <arakiken@users.sf.net>

	* uitoolkit/beos: Added.

	* main/main-beos.cpp: Added.

	* configure.in: --with-gui=beos is added.

	* main/Makefile.in, uitoolkit/Makefile.in, skk/Makefile.in, kbd/Makefile.in:
	  *_beos are added.

	* ui.h: beos is added.

	* encodefilter/src/Makefile.in: MAJOR is changed from 2 to 3.

	* baselib/src/Makefile.in: MAJOR is changed from 1 to 2.

	* baselib/configure.in: The case of "$host_os" = "haiku" is supported.

	* delete (which is reserved keyword of C++) => destroy

	* quartz/cocoa.[hm], cocoatouch.m: The returned value of
	  cocoa_clipboard_own() is changed from int to void.

2019-02-17  Araki Ken  <arakiken@users.sf.net>

	* xlib/ui_window.c: Segfault in showing an input method window is fixed.

2019-02-09  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1: Typo is fixed.

	* wayland/ui_display.c: cache_damage_h() and cache_damage_v() works
	  if rotate_display = right.

	* sdl2/ui_display.c: ui_window_update_all() is called
	  if SDL_WINDOWEVENT_SIZE_CHANGED is received.

2019-02-04  Araki Ken  <arakiken@users.sf.net>

	* ui_draw_str.c: 'vt_char_cols == 0' => vt_char_is_zerowidth().

	* vt_char.[ch]: vt_char_is_zerowidth() is added.

	* vt_line_bidi.c: set_visual_modified() checks visual order properly.

	* vt_bidi.c: 'bidi_mode = BIDI_ALWAYS_LEFT' instead of
	  'fri_type == FRIBIDI_TYPE_LTR' for DEC_SPECIAL characters.

2019-01-27  Araki Ken  <arakiken@users.sf.net>

	* cocoa.m: CGLayer is used if MacOSX is 10.14 or later.
	  (See http://twitter.com/Cj_bc_sd/status/1088111309223161857)

	* cocoatouch.m: CGContextSetBlendMode(kCGBlendModeCopy) is added.

	* lex.split.c: Logging to stdout is removed.

	* bl_dlfcn_dl.c: Compiling warning is fixed.

2019-01-24  Araki Ken  <arakiken@users.sf.net>

	* README.indic: Updated.

	* etc/*font*: ISCII_* except ISCII_TAMIL are activated.

	* libind/Makefile.in: tamil.o is not built.

2019-01-20  Araki Ken  <arakiken@users.sf.net>

	* ui_font_ft.c:
	  - A font name which contains "-" is not passed to FcNameParse().
	  - FT_ENCODING_APPLE_ROMAN is not set for ISCII in xft_font_open() and
	    cairo_font_open().
	  - "drawn_x +=" => "drawn_x =" in show_text().
	  - Unexpected increment of a counter is fixed in ui_window_draw_string32().

	* ui_window_cairo.c:
	  - show_iscii() is added to show ISCII characters.
	  - flush_glyphs() is called when font->size_attr == DOUBLE_WIDTH.

	* ui_window_xft.c:
	  ui_window_xft_draw_string8() shows iscii characters by
	  FC_Get_Char_Index() and XftDrawGlyphs().

2019-01-15  Araki Ken  <arakiken@users.sf.net>

	* vt_line_bidi.c: If vt_bidi() returns 0 or less value and base_was_trl
	  is true, vt_line_set_modified_all(line) is called.

	* vt_bidi.c: If size == 0, return 0 instead of 1.

	* terminaldisplayinit.cc: Code formatting.

2019-01-14  Araki Ken  <arakiken@users.sf.net>

	* vt_config_menu.[ch], vt_parser.[ch], vt_pty.[ch], vt_pty_intern.h,
	  vt_pty_mosh.c, vt_pty_ssh.c, vt_term.[ch]:
	  vt_pty_ptr_t -> vt_pty_t *

2019-01-13  Araki Ken  <arakiken@users.sf.net>

	* README.mosh: Updated.

	* ui_event_source.c, ui_screen.c:
	  'vt_term_get_slave_fd() == -1' => 'vt_term_get_pty_mode() == PTY_SSH'

	* ui_main_config.c: If bl_get_lang() is not only "ja" but also
	  "Japanese" (on win32api), the default value of "col_size_of_width_a"
	  option is 2 instead of 1.

	* vt_term.[ch]: vt_term_get_slave_fd() is added.

	* vt_pty_mosh.cpp:
	  - If the value of "MOSH_AWIDTH" environmental variable is "2",
	    wcwidth() returns 2 for ambiguous width characters.
	  - win32api locale is changed to *nix locale as follows before sending
	    it to mosh-server.
	    Japanese.Japan => ja_JP.UTF-8
	    Chinese.Taiwan => zh_TW.UTF-8
	    Chinese.Hong Kong SAR => zh_HK.UTF-8
	    Chinese.China => zh_CN.UTF-8
	    Korean.Korea => ko_KR.UTF-8
	  - PTY_MOSH is set.

	* vt_config_menu.c:
	  - is_mosh is removed from vt_config_menu_t.
	  - config_menu->is_mosh is replaced by vt_pty_get_mode() == PTY_MOSH.

	* vt_parser.c:
	  - vt_parser_set_pty() modifies col_size_of_width_a if pty is mosh.
	  - set_col_size_of_width_a() does nothing if pty is mosh.

	* vt_pty_ssh.c: PTY_SSH is set.

	* vt_pty_pipewin32.c: PTY_PIPE is set.

	* vt_pty_unix.c: PTY_LOCAL is set.

	* vt_pty_intern.h: mode is added to vt_pty_t.

	* vt_pty.[ch]:
	  - vt_pty_mode_t is added.
	  - vt_pty_get_mode() is added.

2019-01-12  Araki Ken  <arakiken@users.sf.net>

	* README.mosh: Updated.

2019-01-10  Araki Ken  <arakiken@users.sf.net>

	* vt_pty_ssh.c: vt_pty_ssh_set_pty_read_trigger() is added.

	* libptyssh/vt_pty_ssh.c: vt_pty_set_pty_read_trigger() is renamed to
	  vt_pty_ssh_set_pty_read_trigger().

	* vt_pty_mosh.cpp:
	  - 'static pthread_cond_t event_cond' is added to synchronize
	    the main thread and watch_ptys thread.
	  - wcwidth(), convert_utf8_to_ucs() and convert_ucs_to_utf8() are
	    added for terminal.cc, terminaloverlay.cc, parser.cc and
	    terminalframebuffer.h on win32.
	  - use_loopback() and unuse_loopback() support win32.
	  - Select of mosh-x.x.x/src/util/select.h is replaced by
	    select(2).
	  - final() calls unuse_loopback().
	  - vt_pty_mosh_set_pty_read_trigger() is added.

	* libptymosh/Makefile.in: select.o is removed from OBJ.

	* configure.in:
	  - If --with-mosh is specified on win32, ssh2 and mosh features are
	    built as modules.
	  - PKG_CHECK_MODULES(protobuf) is added.

	* version.h: 3.8.6 -> 3.8.7

2019-01-03  Araki Ken  <arakiken@users.sf.net>

	* libptymosh/Makefile.in: -lncursesw is removed.

	* libptymosh/terminaldisplayinit.cc: Added.

	* vt_pty_mosh.cpp: Warn if the value of "termtype" option is "kterm" or
	  "mlterm" which doesn't support bce.

2019-01-03  Araki Ken  <arakiken@users.sf.net>

	* vt_pty_mosh.cpp: read_pty() is called within at least 500 msec to
	  show notification message such as "Last contact N seconds ago.".

	* README.android: The way of building mlterm for android is added.

2019-01-02  Araki Ken  <arakiken@users.sf.net>

	* doc/en/README.mosh: Added.

	* vt_pty_mosh.cpp:
	  - 'Overlay::OverlayManager *overlay' is added to vt_pty_mosh_t.
	  - The returned value of pty_mosh->display.open() is always returned
	    to the caller of read_pty().
	  - If the value of TERM environmental variable is not "xterm",
	    "rxvt", "kterm, "Eterm" or "screen", setenv("TERM", "xterm") forcibly
	    in order to enable to set window or icon title by OSC 0-2.
	  - MOSH_PREDICTION_DISPLAY environmental variable is supported.

	* ui_layout.c: When parent->next[0] or parent->next[1] is set,
	  parent->separator_x or parent->separator_y is also set.

2019-01-02  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, README.ja, PROTOCOL: Updated.

	* ui_main_config.c: "local_echo_wait" / --lew option is added.

	* vt_parser.[ch]:
	  - vt_set_local_echo_wait() is added.
	  - "local_echo_wait" is added to OSC 5379-5383.

2018-12-31  Araki Ken  <arakiken@users.sf.net>

	* vt_config_menu.c:
	  - vt_pty_set_use_loopback() => vt_pty_{ssh|mosh}_set_use_loopback()
	  - is_mosh is added to vt_config_menu_t.

	* vt_pty.h: If USE_MOSH is defined, ssh2 specific functions are concealed

	* vt_pty_ssh.c: vt_pty_set_use_loopback() => vt_pty_ssh_set_use_loopback()

	* vt_pty_mosh.c: vt_pty_mosh_set_use_loopback() is added.

	* libptymosh/vt_pty_mosh.cpp:
	  - USE_LIBSSH2 and USE_MOSH are defined explicitly.
	  - vt_pty_mosh_set_use_loopback() is added.
	  - Dead lock is fixed in watch_ptys().
	  - If pty_mosh->initialized is false, pty_mosh->display.open() is
	    called in read_pty().
	  - vt_pty_t::slave is -2 instead of -1 to distinguish from ssh.
	  - Calculation of vt_pty_t::child_pid is fixed.

	* winrs.rs: The size of "Protocol" group box is fixed.

	* servman/main.c, servman/servman.rc:
	  - mosh protocol (IDD_MOSH) is supported.
	  - "://" is not regarded as a separator of path.

2018-12-29  Araki Ken  <arakiken@users.sf.net>

	* README.console, README.ja: Updated.

	* console/ui_display.c:
	  - The default value of dither_id is changed from BUILTIN_XTERM16 to BUILTIN_XTERM256.
	  - CSI?8452h or CSI?8452l is output.
	  - CSI?1;1;0S (XTCOLREQ) is output and the response of it is parsed in
	    receive_stdin_event() or ui_display_output_picture().

	* vt_parser.c: Typo is fixed.

2018-12-28  Araki Ken  <arakiken@users.sf.net>

	* console/ui_window.c: copy_area() checks if width == 0 or height == 0.

	* c_sixel.c: Rare segfault case is fixed.

	* */ui_imagelib.c: Pipe from mlterm to mlimgloader is removed.

	* console/ui_display.c: ui_display_output_picture() calls
	  sixel_dither_set_pixelformat() every time.

2018-12-23  Araki Ken  <arakiken@users.sf.net>

	* vt_pty_mosh.cpp:
	  - "C.UTF-8" locale (which is the default value on cygwin) is ignored.
	  - Error message of locale setting by mosh-server is output.

	* bl_locale.c: If setlocale() fails, setlocale() is called again with
	  the previous locale.

	* configure.in: vtemu/libptymosh is placed after vtemu/libptyssh in
	  MAKE_DIRS and OUTPUT_FILES.

2018-12-23  Araki Ken  <arakiken@users.sf.net>

	* etc/key, mlterm.1, README.ja: Updated.

	* ui_screen.c: "%s" in "exesel:..." is replaced by selected strings.

2018-12-22  Araki Ken  <arakiken@users.sf.net>

	* vt_edit.c: If the size of a window decreases and some characters on it
	  disappear, it is cleared and all characters on it are scrolled out.

	* ui_window.c: total_min_{width|height}() doesn't consider
	  RIGHT_MARGIN and BOTTOM_MARGIN.

	* ui_layout.c: If the size of a root window becomes smaller than the
	  size of each child window, modify_separator() returns "total / 2".

2018-12-21  Araki Ken  <arakiken@users.sf.net>

	* README, README.ja: Updated.

	* vt_pty.c: vt_pty_new() calls vt_pty_mosh_new() instead of vt_pty_ssh_new()
	  if 'host' contains "mosh://".

	* vt_pty_ssh.c: read_pty() calls bl_trigger_sig_child() only if
	  libssh2_channel_read() returns 0 or less value.
	  (If libssh2_channel_eof() returns true and libssh2_channel_read() > 0,
	   bl_trigger_sig_child() is not called.)
	  This change is for mosh.

	* win32/ui_connect_dialog.[ch], winrs.rs: IDD_MOSH is added.

	* bl_path.c: bl_parse_uri() recognizes "mosh://".

	* configure.in: --with-mosh option is added.

	* vtemu/libptymosh: Added.

	* vt_parser.c: get_vtmode() returns 3 (permanently set) for
	  DECPCCM, DECATCUM and DECATCBM.

2018-11-23  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c: Fix segfault by "CSI 21 t".
	  (https://sourceforge.net/p/mlterm/mailman/message/36472061/)

2018-11-18  Araki Ken  <arakiken@users.sf.net>

	* README.ja: Minor fixes.

	* mlconfig/po/*.po: Updated.

	* fb/ui_font.c, ui_font_ft.c: FcNameParse() is used.

	* ui_font_config.c: Parsing ';' and ',' for backward compatibility is fixed.

2018-11-05  Araki Ken  <arakiken@users.sf.net>

	* android/jni/ui_display.c: Even if the cursor moves slightly,
	  long click is assumed to continue.

	* version.h: 3.8.7 -> 3.8.7post

2018-10-27  Araki Ken  <arakiken@users.sf.net>

	* 3.8.7 released.
	  (tag "rel-3_8_7")

	* configure.in, mlterm.spec, main/version.h.in,
	  mlterm.c, android/jni/version.h:
	  updated for 3.8.7.

	* README, man/mlterm.1, libvterm/README, gtk/README, mlcc.1: Updated.

	* ui_font_config.c: ui_customize_font_file() resets font_config->font_name_table
	  if *value is '\0'.

2018-10-13  Araki Ken  <arakiken@users.sf.net>

	* ui_layout.c: The position of calling update_normal_hints() is fixed.

2018-10-12  Araki Ken  <arakiken@users.sf.net>

	* README, PROTOCOL, README.win32, README.ja, etc/main, etc/main.ja,
	  gtk/README, man/mlterm.1: Updated.

	* ui_screen.c: The restriction of the range of screen->underline_offset
	  is mostly eliminated.

	* ui_layout.c: total_hint_size() sets sizehint_flag of ui_screen_t and
	  ui_scrollbar_t.

	* ui_window.h, */ui_window.c:
	  - ui_sizehint_flag_t is added.
	  - ui_sizehint_flag is added to ui_window_t.
	  - total_min_{width|height}() and total_{width|height}_inc() use sizehint_flag.

	* vt_parser.c:
	  "switch" is available for the value of "col_size_of_width_a" of OSC 5379.

2018-09-23  Araki Ken  <arakiken@users.sf.net>

	* README.android, README.cocoatouch: Updated.

	* ui_screen.c: Minor changes about flick scrolling.

	* ui_font_manager.c: The default value of 'max_font_size' is changed from 40 to 50.

	* android/jni/ui_display.c: long_press_count == 15 (instead of 20) opens menu.

	* android/jni/ui_event_source.c:
	  - ((ui_screen_t*)win)->is_preediting is set in update_ime_text().
	  - need_resize() considers bottom margin correctly.

	* cocoa.m, cocoatouch.m, android/jni/ui_event_source.c, sdl2/ui_display.c:
	  If both preedit_text and cur_preedit_text are non-NULL and same value,
	  update_ime_text() does nothing.

2018-09-17  Araki Ken  <arakiken@users.sf.net>

	* Makefile.in: 'test' target is added for bitbucket pipelines.

2018-09-16  Araki Ken  <arakiken@users.sf.net>

	* README.console: Updated.

	* ui_screen.c: The place where enter_backscroll_mode() is called is moved.

2018-09-13  Araki Ken  <arakiken@users.sf.net>

	* ui_screen.c: Segfault on Android in scrolling by flick is fixed.

2018-09-11  Araki Ken  <arakiken@users.sf.net>

	* cocoa/lipo.sh, mlterm-ios.app/Info.plist: Added.

	* ui_scrollbar.c: sb->current_row is reset in window_resized.

	* ui_screen.[ch]:
	  - grab_scroll is added to ui_screen_t.
	  - bs_scroll_upward() and bs_scroll_downward() are swapped in flick scrolling.

	* cocoatouch.m: Function keys are ingored in insertText().

	* android/jni/ui_event_source.c, cocoa.m, cocoatouch.m, sdl2/ui_display.c:
	  If vt_term_is_backscrolling() is true, update_ime_text() does nothing.

2018-09-09  Araki Ken  <arakiken@users.sf.net>

	* README.cocoatouch: Updated.

	* cocoatouch.m:
	  - AppDelegate_{iPhone|iPad} => AppDelegate
	  - UIWindow is manually allocated in AppDelegate::application().
	  - keyCommands() is implemented.

	* mlterm-cocoa.m: AppDelegate class is specified in calling UIApplicationMain().

	* mlterm-icon.app/mlterm-Info.plist, Makefile: Added.

	* mlterm-icon.app/Info.plist, MainWindow_{iPad|iPhone}.{nib|xib}: Removed.

2018-09-06  Araki Ken  <arakiken@users.sf.net>

	* configure.in: -mios-simulator-version-min option is added to $CC
	  on iOS SDK 5.0 or later.

	* cocoa/build-iossim43.sh: Renamed from build-iossim.sh

	* cocoa/build-ios43.sh: Renamed from build-ios.sh

	* cocoa/build-iossim71.sh, mlterm-ios.app/MainWindow_{iPad|iPhone}.xib: Added.

	* cocoatouch.m, vt_pty_unix.c: Minor fixes.

2018-09-03  Araki Ken  <arakiken@users.sf.net>

	* ui_screen.c: Right key scrolls upward and left key scrolls downward
	  in scrolling mode.

2018-09-02  Araki Ken  <arakiken@users.sf.net>

	* README.android, doc/en/PROTOCOL: Updated.

	* ui_screen.[ch]:
	  - 'size' is added to arguments of bs_scroll_{up|down}ward().
	  - bs_{half_}page_{up|down}ward() are defined as macros instead of functions.
	  - flick_time, flick_y and autoscroll_count are added to ui_screen_t if
	    FLICK_SCROLL is defined.
	  - If screen->autoscroll_count != 0, idling() scrolls screen.
	  - "autoscroll" is added to ui_screen_exec_cmd().

	* */ui.h: FLICK_SCROLL which enables auto scrolling by flick is defined on
	  Android and iOS.

	* android/jni/ui_display.c:
	  - long_press_count == 20 (instead of 10) opens menu.
	  - The are of double click to show software keyboard is changed.
	  - Long press at the lower right corner instead of the entire screen
	    shows context menu.

	* android/jni/ui_event_source.c:
	  clock_gettime() is called to check if ui_display_idling() should be called.

	* cocoatouch.m: longpress.minimumPressDuration = 2.0.

2018-09-01  Araki Ken  <arakiken@users.sf.net>

	* ui_window.c, ui_screen_manager.c: Hack to keep window size is fixed.

	* main-cocoa.m: Application class instead of UIApplication is used.

	* cocoatouch.m:
	  - UITextInput protocol is implemented.
	  - Application class derived from UIApplication is added to receive all
	    keyboard input events.
	  - viewDidMoveToWindow => didMoveToWindow.

	* vt_pty_unix.c: Hack for iOS 4.3 is added.

2018-08-28  Araki Ken  <arakiken@users.sf.net>

	* doc/en/README.cocoatouch: Added.

	* main/Makefile.in: -framework Foundation -framework Cocoa => @COCOA_LIBS@

	* uitoolkit/Makefile.in: cocoa.o => @COCOAOBJ@

	* configure.in:
	  - --with-ios-sdk and --with-ios-arch are added.
	  - If --with-ios-sdk option is specified, COCOA_TOUCH macro is defined.

	* cocoa/build-ios.sh, build-iossim.sh, install-ios.sh, mlterm-ios.app: Added.

	* ui_screen_manager.c: New pty is opened in pty_closed() if pty is closed
	  and there is no pty.

	* main-cocoa.m, quartz/ui_font.c, ui_im_status_screen-cocoa.m,
	  quartz/ui_imagelib.c, quartz/ui_window.c: CocoaTouch is supported.

	* cocoatouch.m: Added.

	* cocoa.m: [super becomeFirstResponder] is called in becomeFirstResponder().

	* ui_main_config.c: The default value of type_engine option is always
	  TYPE_XCORE on platforms except xlib.

	* im_uim.c: Compiling error is fixed.

	* baselib/configure.in: Following checks are executed only if $host = $build.
	  AC_RUNIFELSE(posix_openpt), AC_TRY_RUN(calloc).

2018-08-04  Araki Ken  <arakiken@users.sf.net>

	* mc_font.c:
	  - gtkxlfdsel.c is included if GDK_WINDOWING_X11 is defined regardless
	    USE_<PLATFORM> macro defined by mlterm.
	  - select_xlfd_font() is called only if mc_get_gui() == "xlib".

	* main.c: char *gui; => const char *gui;

	* configure.in, tool/mlconfig/Makefile.in: XLFDSEL_OBJ is removed.

2018-08-03  Araki Ken  <arakiken@users.sf.net>

	* im_uim.c: uim_scm_is_initialized() is used to check if uim_init()
	  has been called.

2018-07-31  Araki Ken  <arakiken@users.sf.net>

	* doc/en/README.fb, doc/ja/README.fb: Updated.

	* fb/ui_display_freebsd.c: PS2 mouse (/dev/psm0) and PC98 bus mouse
	  (/dev/mse0) are supported.

	* fb/ui_display.c: put_image_124bpp() is tuned up.

2018-07-23  Araki Ken  <arakiken@users.sf.net>

	* c_sixel.c: Sixel graphics extension which "sayaka --ormode on" outputs
	  is supported. (Disabled by default. #define SIXEL_ORMODE enables it.)

2018-07-22  Araki Ken  <arakiken@users.sf.net>

	* c_sixel.c: Sixel graphics extension and option1 of
	  https://github.com/kmiya-culti/RLogin/issues/22#issue-341758598
	  are supported.

	* vt_parser.c: Return value of CSI?1;Pa;PvS is changed from CSI?1;0;256S to
	  CSI?1;0;1024S.

	* MLTermPty.c: It is possible to load libgcc_s_sjlj-1.dll.

	* bl_pty_streams.c: #define __XSI_VISIBLE 600 forcibly for cygwin.
	  (see /usr/include/cygwin/stdlib.h)

	* uitoolkit/Makefile.in, servman/Makefile.in:
	  i686-w64-mingw32-windres.exe is used instead of windres.exe if $CC is
	  i686-w64-mingw32-gcc.exe.

	* aclocal.m4, ltmain.sh: Updated for Cygwin/x86_64.

	* configure.in:
	  - $host="msys" is supported.
	  - PKG_CHECK_MODULES(libssh2) is used instead of AC_CHECK_LIB(libssh2_init).
	  - AM_GLIB_GNU_GETTEXT is used instead of AM_GNU_GETTEXT.

	* mlconfig/po/Makefile.in.in: Simplified.

	* mlconfig/po/ChangeLog, LINGUAS, Makevars, Rules-quot, en@boldquot.header,
	  en@quot.header, insert-header.sin, quot.sed: Removed.

	* win32/mlterm.manifest: Added.

	* ui_screen.c:
	  - Hack for "microsoft-edge:" is added to shortcut_str().
	  - permit_exec_cmd() which checks ~/.mlterm/execlist to determine whether
	    "mlclient -e cmd" is permitted is added.

2018-07-02  Araki Ken  <arakiken@users.sf.net>

	* c_sixel.c:
	  - The number of palettes which load_sixel_from_data() supports is up to 1024.
	  - The palette number #1024 or greater is regarded as 15 bit RGB.

2018-06-30  Araki Ken  <arakiken@users.sf.net>

	* fb/ui_imagelib.c: SIXEL_PALETTES_SIZE is used.

	* c_sixel.c:
	  - load_sixel_from_data() supports a maximum of up to 65536 palettes.
	  - SIXEL_PALETTES_SIZE macro is defined.

2018-06-17  Araki Ken  <arakiken@users.sf.net>

	* configure.in: m17nlib is checked by PKG_CHECK_MODULES().

	* mc_im.c: libim-*-sdl2.so is supported if gui is "sdl2".

	* ef_ucs_property.table: Updated to Unicode 11.0.0 (UnicodeData.txt and
	  EastAsianWidth.txt)

	* mlconfig/main.c: mc_im_init() is called in main() first of all.

	* mc_im.[ch]: mc_im_init() which calls get_im_info() is added.

2018-06-14  Araki Ken  <arakiken@users.sf.net>

	* win32/ui_connect_dialog.c: HOMEPATH environmental variable is ensured
	  before executing servman.exe.

	* version.h: 3.8.6 -> 3.8.6post

2018-06-12  Araki Ken  <arakiken@users.sf.net>

	* 3.8.6 released.
	  (tag "rel-3_8_6")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.8.6.

	* man/mlterm.1: Updated.

2018-06-12  Araki Ken  <arakiken@users.sf.net>

	* ui_screen_manager.c:
	  open_pty_intern() assumes that ui_connect_dialog() doesn't change
	  arguments except uri.

	* win32/ui_connect_dialog.c:
	  dialog_proc() checks selected_ssh_privkey before 'if (default_server)'.

	* xlib/ui_connect_dialog.c:
	  ui_connect_dialog() doesn't change 'pass' arguments if it fails.

	* android/jni/ui_connect_dialog.c:
	  ui_connect_dialog() doesn't set values to arguments except uri
	  if ui_display_show_dialog() fails.

2018-06-10  Araki Ken  <arakiken@users.sf.net>

	* xlib/ui_window.c: Compiling error is fixed.

	* gtk/Makefile.in: @LPOBL@ and @LMEF@ are used.

	* configure.in: contrib/scrollbar is copied to gui/ if multiple values separated
	  by ',' is specified as the value of --with-gui option.

	* libtype/Makefile.in:
	  LPOBL=${top_builddir}/baselib/src/libpobl.la => LPOBL=@LPOBL@

2018-06-09  Araki Ken  <arakiken@users.sf.net>

	* MLActivity.java:
	  - "SCP" is added to the context menu.
	  - onCreateDialog(2) creates SCP dialog.

	* android/jni/ui_event_source.c:
	  - Type of 'cmd' argument of Java_mlterm_native_1activity_MLActivity_execCommand()
	    is changed from jint to jstring.
	  - Java_mlterm_native_1activity_MLActivity_isSSH() is added.

	* libptyssh/vt_pty_ssh.c: Hack for libssh2_scp_send().

	* vt_pty_ssh.c: ~/.mlterm/scp directory is automatically created.

2018-06-09  Araki Ken  <arakiken@users.sf.net>

	* MLActivity.java: "Priv Key" entry is added to the connection dialog.

	* android/jni/ui_display.[ch]:
	  'char *privkey' is added to ui_display_show_dialog().

	* android/jni/ui_connect_dialog.c:
	  - 'char **privkey' is added to arguments of ui_connect_dialog().
	  - 'jstring privkey' is added to arguments of
	    Java_mlterm_native_1activity_MLActivity_dialogOkClicked().

	* vt_pty_ssh.c:
	  The default value of privkey and pubkey is changed from
	  /sdcard/.ssh/id_rsa(.pub) to /sdcard/.mlterm/id_rsa(.pub).

2018-06-07  Araki Ken  <arakiken@users.sf.net>

	* win32/ui_connect_dialog.c: DnD to "PrivKey" entry is supported.

2018-06-05  Araki Ken  <arakiken@users.sf.net>

	* ui_screen_manager.c:
	  ui_connect_dialog() can modify the value of main_config.private_key.

	* vt_pty_ssh.c: ssh_connect() passes NULL to libssh2_userauth_publickey_fromfile()
	  as 'publickey' argument.

	* winrs.rs: "PrivKey" entry is added.

	* win32/ui_connect_dialog.c:
	  - get_window_text() returns UTF-8 or MB text.
	  - set_window_text() which converts UTF-8 string to WCHAR* and calls
	    SetWindowTextW() is added.

	* ui_connect_dialog.h, */ui_connect_dialog.c:
	  - 'char **privkey' is added to arguments of ui_connect_dialog().
	  - IDD_SSH_PRIVKEY is added.

2018-06-02  Araki Ken  <arakiken@users.sf.net>

	* ui_draw_str.c: bg_xcolor is added to arguments of draw_picture(), and
	  if bg_xcolor is not NULL, ui_window_fill_with() is used instead of
	  ui_window_clear().

	* ui_screen.c: xterm_get_picture_data() uses vt_term_get_bce_ch() instead
	  of vt_sp_ch().

	* vt_parser.c: put_char() uses vt_term_get_bce_ch() instead of vt_sp_ch()
	  in dealing with DRCS-SIXEL.

	* vt_edit.h, vt_screen.h, vt_term.h:
	  vt_{edit|screen|term}_get_bce_ch() is added.

	* ui_screen.c, vt_parser.h: CS_BOX is added to vt_cursor_style_t, and is
	  used to draw an unfocused cursor or a cursor on a picture.

2018-06-01  Araki Ken  <arakiken@users.sf.net>

	* servman/main.c, servman.rc:
	  - IDM_XXX and IDD_XXX are changed from 1-28 to 101-128.
	  - Message dialog to confirm whether to save to a configration file is shown
	    if window is closed.
	  - Message dialog to confirm whether to really delete an entry is shown.
	  - Whether the edited name of a directory or an entry is valid or not is checked.

	* drcssixel/test.c: 2 sixel graphics are output.

2018-05-29  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, README.ja, en/README.win32, ja/README.win32,
	  etc/main, etc/main.ja: Updated.

	* configure.in: tool/servman is added to OUTPUT_FILES and MAKE_DIRS
	  if $gui is "win32".

	* ui_main_config.[ch], ui_screen_manager.c:
	  - "server_list" option is removed.
	  - ui_main_config_add_to_server_list() is removed.

	* */ui_connect_dialog.[ch]:
	  - sv_list is removed from arguments of ui_connect_dialog().
	  - IDD_LIST is removed.

	* win32/ui_connect_dialog.[ch]:
	  - ui_connect_dialog() executes "servman.exe" if 'default_server'
	    argument is NULL or "?".
	  - IDD_LIST is removed.

	* winrs.rs: "List" combo box is removed.

	* tool/servman/*: Added.

	* ui_screen.c: Underline style cursor is shown on pictures.

	* main_loop.c:
	  -foo-*- as the value of "default_font" option is renamed to
	  -foo-*-iso10646-1 in applying it to "ISO10646_UCS4_1" font.

	* ui_font.c:
	  - XLoadQueryFont() and related code are collected to load_xfont_intern().
	  - AddStyleName in XLFD is always specified.

	* vt_config_menu.c: CREATE_NO_WINDOW => 0 in CreateProcess().

2018-05-23  Araki Ken  <arakiken@users.sf.net>

	* drcssixel.c: Fix http://twitter.com/ttdoda/status/998852239505604608

2018-05-12  Araki Ken  <arakiken@users.sf.net>

	* ui_display.c: dialog_cb() returns 1 or -1.

	* otf.c: Compiling error (when BL_DEBUG is defined) is fixed.

2018-05-10  Araki Ken  <arakiken@users.sf.net>

	* vte.c: Compiling error is fixed.

2018-05-07  Araki Ken  <arakiken@users.sf.net>

	* vt_screen.h: vt_screen_{set|get}_last_column_flag() are added.

	* vt_parser.[ch]:
	  - is_auto_wrap is removed from vt_storage_states_t, and last_column_flag is added.
	  - If restore_cursor() is called before save_cursor(), the cursor is moved
	    to the home position and all character attributes are turned off.
	  - CSI Ps1;Ps2;... t (Ps1 = 7, 11, 13, 14, 15, 16, 18, 19, 20, 21, 24) is accepted.

	* vt_edit.[ch]:
	  - vt_edit_{set|get}_last_column_flag() is added.
	  - scroll_upwrad_region() checks CURSOR_IS_INSIDE_HMARGIN().

	* vt_cursor.[ch]: is_saved flag is removed from vt_cursor_t.

2018-05-05  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, doc/ja/README.ja, etc/main, etc/main.ja: Updated.

	* ui_layout.c: key_pressed() calls ui_screen_t::key_pressed only if it is not NULL.

	* ui_main_config.[ch]: --rv / rv_color option is added.

	* ui_screen.c:
	  - "rv_color" is added to OSC 5379 and 5380.
	  - xterm_get_display_size() and xterm_lock_keyboard() are added.

	* ui_color_manager.[ch]: _REVERSE_COLOR is added to ui_color_manager_t::sys_colors.

	* vt_color.[ch]:
	  - VT_REVERSE_COLOR is added.
	  - prase_conf() calls vt_get_color_rgba() instead of vt_color_parse_rgb_name()
	    to get rgb of a specified value if color_name is not "rgb:...".

	* vt_parser.[ch]:
	  - ALT_COLOR_REVERSE is added to vt_alt_color_mode_t.
	  - put_char() considers ALT_COLOR_REVERSE.
	  - flush_buffer() doesn't clear buffer->last_ch if buffer->filled_len == 0.
	  - get_cell_size(), report_cell_size() and report_display_size() are added.
	  - resize() resizes a screen to the width or height of the display if width
	    or height argument is 0.
	  - width or height argument of resize() not to resize a screen is changed
	    from 0 to -1.
	  - get_fgbg_rgb(), get_special_color_name(), change_fgbg_color() and
	    reset_color_rgb() are added.
	  - get_rgb() returns RGB of alt colors.
	  - change_color_rgb() and change_special_color() support multiple parameters
	    separated by ';'.
	  - change_special_color() supports '?' which queries current setting.
	  - report_status() reports DECSCA status.
	  - get_vtmode() returns 4 (permanently reset) for GATM, SRTM, VEM, HEM,
	    PUM, FEAM, FETM, MATM, TTM, SATM, TSM and EBM.
	  - lock_keyboard is added to vt_xterm_event_listener_t, and KAM uses it
	    instead of vt_parser->pty_hook.pre_write = NULL.
	  - soft_reset() resets DECSC and DECSASD.
	  - full_reset() resets DECCOLM, tab stops, CSI>T and CSI>t.
	  - CSI 15 t, CSI 16 t and CSI 19 t are supported.
	  - The response strings of OSC 20 and OSC 21 are fixed.

	* vt_screen.[ch]:
	  - vt_screen_saved_cursor_to_home() is added.
	  - vt_screen_use_{normal|alternative}_edit() keeps the cursor position.
	  - vt_screen_set_status_line(screen, 1) moves the cursor position to home.

	* vt_edit.[ch]:
	  - vt_edit_set_{hv}margin() don't call vt_edit_goto(edit, 0, 0).
	  - vt_edit_set_hmargin() behaves same as vt_edit_set_vmargin() if beg or end
	    argument is -1.
	  - vt_edit_saved_cursor_to_home() is added.

	* vt_pty.c: pty->hook->pre_write is always non-NULL value if pty->hook is non-NULL.

	* vt_cursor.h: vt_saved_cursor_to_home() is added.

2018-04-27  Araki Ken  <arakiken@users.sf.net>

	* vt_screen.[ch]: vt_screen_get_checksum() is added.

	* vt_parser.[ch]:
	  - save_cursor() stores is_protected, is_relative_origin and is_auto_wrap, then
	    restore_cursor() restores them.
	  - OSC 4 returns "OSC ... ST" instead of "OSC ... BEL".
	  - The default values are set if 5, 6 and 7th parameters of DECCRA are omitted.
	  - The default value of Pch of DECFRA is '%'. (compat with xterm)

	* vt_edit.[ch]:
	  - apply_relative_origin() checks whether col/row/num_cols/num_rows
	    are within screen or not if edit->is_relative_origin is false.
	  - Corruption of vt_edit_delete_cols() if DECLRMM is fixed.
	  - vt_edit_scroll_leftward() is fixed.
	  - vt_edit_set_use_hmargin() ignores -1 value of 'use' argument.
	  - vt_edit_get_checksum() is added.

	* xlib/ui_font.c: If cairo_set_ot_font() fails, font->ot_font_not_found = 1.

	* hb.c: hb_ot_layout_has_substitution() is checked.

2018-04-21  Araki Ken  <arakiken@users.sf.net>

	* ui_scrollbar.c: If win->is_mapped is false, window_exposed() does nothing.

	* ui_im_{candidate|status}_screen.c, ui_screen.c: ui_window_flush() is called.

	* ui_window.[ch]: ui_window_flush() which works for cairo is added.

	* ui_window_cairo.c:
	  - Drawn glyphs are cached until cairo_flush() is called.
	  - ui_window_draw_string32() calls cairo_flush() if str argument is NULL.

	* mc_opentype.c: Compiling error is fixed if gtk+ version is less than 2.14.0.

2018-04-13  Araki Ken  <arakiken@users.sf.net>

	* vtetypebuiltins.c: vte_text_blink_mode_get_type() is added.

	* vte.c: vte_terminal_unselect_all(), vte_terminal_set_bold_is_bright(),
	  vte_terminal_get_bold_is_bright(), vte_terminal_set_cell_width_scale(),
	  vte_terminal_get_cell_width_scale(), vte_terminal_set_cell_height_scale(),
	  vte_terminal_get_cell_height_scale(), vte_terminal_set_text_blink_mode()
	  and vte_terminal_get_text_blink_mode() are added.

	* xlib/ui_color.c: ui_load_rgb_xcolor() considers alpha if depth == 32
	  and alpha < 0xff.

2018-04-01  Araki Ken  <arakiken@users.sf.net>

	* README.ja: Updated.

	* vt_pty.c: S_IFCHR of fstat() is used instead of ptsname().

	* ui_imagelib.c: If ui_display_is_changeable_cmap() returns true,
	  load_sixel_from_data_sharepalette() is not called.

	* fb/ui.h, fb/ui_display.c, ui_display_freebsd.c:
	  M_PC98_EGC640x400 on FreeBSD(98) is supported.

	* configure.in:
	  - Missing " is added.
	  - -DPC98 is added to GUI_CFLAGS if sysctl machdep.ispc98 returns 1.

2018-03-15  Araki Ken  <arakiken@users.sf.net>

	* ui_virtual_kbd.c: Compiling error is fixed.

	* vt_parser.c: "N%" is supported in OSC 1337.

	* configure.in: It is possible to specify multiple values for --with-gui option.
	  (e.g. --with-gui=xlib,sdl2,wayland,fb,console)

2018-03-12  Araki Ken  <arakiken@users.sf.net>

	* ui_screen.c: xterm_get_picture_data() places image at the center of the
	  specified width and height if keep_aspect is true.

	* xlib/ui_imagelib.c:
	  - ui_imagelib_load_file() modifies *width and *height if keep_aspect is true.
	  - width and height of ui_imagelib_loada_file() are never NULL.

	* fb/ui_imagelib.c, console/ui_imagelib.c:
	  ui_imagelib_load_file() modifies *width and *height if keep_aspect is true.

2018-03-11  Araki Ken  <arakiken@users.sf.net>

	* ui_window_cairo.c: Memory leak of surface is fixed.

	* ui_font_ft.c: Double free when XftFontOpenPattern() succeeds is fixed.

	* ui_picture.[ch]: 'int keep_aspect' is added to arguments of ui_load_inline_picture().

	* ui_imagelib.h, */ui_imagelib.c:
	  'int keep_aspect' is added to arguments of ui_imagelib_load_file().

	* gdiplus.c, gdk-pixbuf.c, none.c:
	  mlimgloader [window id] [width] [height] [src file] ([dst file]|-c)
	  => mlimgloader [window id] [width] [height] [src file] (pixmap|stdout|[dst file]) -a

	* vt_parser.[ch], ui_screen.c: 'int keep_aspect' is added to arguments of
	  vt_xterm_event_listener_t::get_picture_data.

	* mlcc/main.c: The value type of "use_anti_alias" option is changed from
	  bool to string.

	* configure.in: 'libvterm' directory is copied to fb/ if --with-gui=fb,xlib

	* version.h: 3.8.5 -> 3.8.5post

2018-03-07  Araki Ken  <arakiken@users.sf.net>

	* 3.8.5 released.
	  (tag "rel-3_8_5")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.8.5.

	* README, README.sdl2, README.wayland, README.ja,
	  README.tate, PROTOCOL, man/mlterm.1:
	  Updated.

2018-03-06  Araki Ken  <arakiken@users.sf.net>

	* gtk/vte.c: vte_terminal_copy_clipboard_format() is added.

	* README.ja, mlterm.1: Updated.

	* vt_logs.[ch]:
	  - The value of 'logsize' option is automatically changed to 'unlimited'
	    if it is over 65535.
	  - VT_LOG_SIZE_UNIT is defined.

2018-03-04  Araki Ken  <arakiken@users.sf.net>

	* cocoa/install.sh: libotl.so -> libotl-quartz.so

	* cocoa.m: Compiling error is fixed.

	* MLActivity.java:
	  - showDialog() => showConnectDialog()
	  - showMessage() is added.

	* android/jni/ui_display.c: bl_dialog_set_callback(dialog_cb) is added.

2018-03-03  Araki Ken  <arakiken@users.sf.net>

	* libotl/Makefile.in, otl.h: Library name is changed from libotl to
	  libotl-win32 on win32api and to libotl-quartz on MacOSX/Cocoa in order
	  to coexist with libotl for sdl2.

	* fb/ui_font.c: get_cached_xfont() checks xfont->is_aa

2018-03-03  Araki Ken  <arakiken@users.sf.net>

	* vt_shape.c: vt_shape_ot_layout() does nothing for a character whose
	  charset is PICTURE_CHARSET.

	* sdl2/ui_display.c: Not only SDL_DestroyCond but also SDL_CondSignal()
	  is called in ui_display_close().

	* fb/ui_window.c: Fix illegal memory access in draw_string_intern().

	* sdl2/ui_imagelib.c: exec_mlimgloader() is added, and it works on win32api.

	* mlfc/main.c: FONTCONFIG_PATH environmental variable is set.

	* configure.in, registobmp/main.c: If SDL_ttf is not found, registobmp is
	  compiled without it.

2018-02-28  Araki Ken  <arakiken@users.sf.net>

	* vt_ot_layout.c: If 5 or more same usascii characters are repeated,
	  vt_ot_layout() doesn't call vt_ot_layout_shape().

	* ui_font.c: init_fontconfig() initializes FONTCONFIG_PATH environmental
	  variable if USE_WIN32API is defined.

	* mlfc/main.c: Compiling error is fixed.

2018-02-25  Araki Ken  <arakiken@users.sf.net>

	* ui_screen_manager.c: "No fonts" error message is shown by bl_dialog()
	  instead of bl_msg_printf().

	* sdl2/ui_display.c: Falling into infinite sleep in select() is fixed.

	* syswminfo.c: syswminfo_is_thread_safe() returns 0 on cocoa.

	* cocoa.m: create_dialog() checks if the current thread is main thread or not.

	* configure.in: It is possible to use fontconfig on SDL2/win32.

2018-02-25  Araki Ken  <arakiken@users.sf.net>

	* ui_shortcut.c: Control+F* shortcut keys => Command+F* on SDL2 / MacOSX.

	* sdl2/ui_display.c: SDL_DisplayMode::refresh_rate > 0 is checked before
	  calculating vsync_interval_msec.

	* inputmethod/*/Makefile.in: @SDL2_CFLAGS@ is added to include <SDL.h> from
	  ui.h correctly.

	* configure.in: Either AC_CHECK_HEADER(hb-ft.h) or AC_CHECK_HEADER(hb-coretext.h"
	  is executed if harfbuzz is enabled.

	* cocoa/install-sdl2.sh: Added.

2018-02-24  Araki Ken  <arakiken@users.sf.net>

	* sdl2/ui_display.c: SDL_CondSignal() is called after processing pty events.

2018-02-24  Araki Ken  <arakiken@users.sf.net>

	* README.fb, README.sdl2, README.wayland, README.win32: Updated.

	* sdl2/ui_display.c: init_display() specifies x and y position of SDL_Window.

2018-02-24  Araki Ken  <arakiken@users.sf.net>

	* sdl2/ui_display.c: pthread is replaced by SDL_thread.

	* fb/ui_connect_dialog.c: ui_get_opened_displays() is called instead of
	  ui_display_receive_next_event() on SDL2.

	* syswminfo.[ch]: Added.

	* MLTerm.java: MessageBox is removed from startMLTerm().

	* MLTermApplet.java: MessageBox is removed from run().

	* ConfirmDialog.java: 'boolean okcancel' is added to show().

	* MLTermPty.c: dialog_callback() supports BL_DIALOG_ALERT.

2018-02-22  Araki Ken  <arakiken@users.sf.net>

	* vt_term.c: "Failed to open pty" message is shown if vt_pty_new() fails.

	* sdl2/ui_display.c: bl_dialog_set_callback(dialog_cb) is added.

	* bl_util.h:
	  - K_{MAX|MIN} => BL_{MAX|MIN}
	  - BL_SWAP() is added.

2018-02-21  Araki Ken  <arakiken@users.sf.net>

	* sdl2/ui_display.c: Minor fixes.

2018-02-20  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_display.c:
	  ui_display_rotate() does nothing after a display is opened.

	* sdl2/ui_display.c:
	  - disp->display->resizing = 1 in ui_display_resize(), and
	    disp->display->resizing = 0 in SDL_WINDOWEVENT_SIZE_CHANGED.
	  - ui_display_rotate() does nothing after a display is opened.

	* sdl2/ui_window.c: If win->disp->display->resizing is 1, ui_window_resize()
	  does nothing.

	* sdl2/ui.h: 'resizing' is added to Display.

2018-02-19  Araki Ken  <arakiken@users.sf.net>

	* sdl2/ui_window.c, sdl2/ui_display.c: Copy&paste with the use of
	  SDL_{Get|Set|Has}ClipboardText() is supported.

	* configure.in: Minor fixes.

2018-02-18  Araki Ken  <arakiken@users.sf.net>

	* sdl2/ui_display.[ch]:
	  - The timing of calling present_displays() is fixed.
	  - SDL_WINDOWEVENT_FOCUS_{GAINED|LOST} events are processed.
	  - ui_display_resize(), ui_display_move(), ui_display_set_maximized()
	    and ui_display_set_title() are implemented.

	* wayland/ui_display.[ch]:
	  - 'int flag' is added to arguments of ui_display_set_maximized().

	* sdl2/ui_window.c:
	  #if defined(USE_WAYLAND) || defined(USE_SDL2)
	  => #ifndef MANAGE_ROOT_WINDOWS_BY_MYSELF

2018-02-18  Araki Ken  <arakiken@users.sf.net>

	* sdl2/ui_display.c: SDL_TEXTEDITING event is processed, and preediting
	  text is shown.

	* vt_term.h, vt_parser.c: vt_term_preedit() is always compiled.

	* mlconfig/Makefile.in: Typo of LIBS2_win32 is fixed.

2018-02-18  Araki Ken  <arakiken@users.sf.net>

	* README, doc/{ja,en}/README.win32: Updated.

	* sdl2/ui_display.c:
	  - XKeyEvent::str and XKeyEvent::parser are set in poll_event().
	  - ui_display_logical_to_physical_coordinates() applies the position
	    of SDL_Window.

	* sdl2/ui_window.c:
	  ui_window_get_str() processes XKeyEvent::str and XKeyEvent::parser.

	* sdl2/ui.h: str and parser are added to XKeyEvent.

	* im_fcitx.c: ui_im_status_screen is used on sdl2.

2018-02-17  Araki Ken  <arakiken@users.sf.net>

	* doc/en/README.win32: Updated.

	* mlimgloader/Makefile.in: LIBS2_sdl2_gdiplus is added.

	* mlconfig/Makefile.in: bindir=@bindir@ is added.

	* mlterm-menu/Makefile.in: Typo is fixed.

	* sdl2/ui.h: <SDL.h> => <SDL2/SDL.h> (for inputmethod/*)

	* configure.in:
	  - PKG_PATH_TOOL(pkg-config) => PKG_CHECK_TOOL(pkg-config)
	    (This makes it unnecessary to specify an absolute path.)
	  - "tr -d '\r'" is removed.
	  - MLIMGLOADER_LIBS=gdiplus if $have_gdiplus = "yes" but $gui != "win32"

2018-02-16  Araki Ken  <arakiken@users.sf.net>

	* libptyssh/vt_pty_ssh.c, vt_pty.h: vt_pty_ssh_set_pty_read_trigger()
	  is renamed to vt_pty_set_pty_read_trigger().

	* vt_pty_pipewin32.c: PostThreadMessage(main_tid, WM_APP, 0, 0) is replaced
	  by (*trigger_pty_read)().

	* main.c, win32/ui_display.c: main_tid = GetCurrentThreadID() is moved
	  from main() to ui_display_open().

2018-02-16  Araki Ken  <arakiken@users.sf.net>

	* README, README.ja: Updated.

	* doc/en/README.sdl2: Added.

	* */Makefile.in: Target, flags or library for SDL2 is added.

	* configure.in: --with-gui=sdl2 is supported.

	* uitoolkit/sdl2: Added.

	* vt_pty.h, vt_pty_ssh.c: vt_pty_ssh_set_pty_read_trigger() is added.

	* ui_display.h, win32/ui_display.c, sdl2/ui_display.c:
	  ui_display_trigger_pty_read() is added if USE_WIN32API is defined.

	* ui_draw_str.c: xcore_draw_str() supports SDL2.

	* fb/ui_window.c:
	  draw_string_intern() doesn't call ui_display_get_pixel() as possible
	  even if -otl option is enabled.

	* fb/ui_imagelib.c:
	  mlimgloader is not executed if USE_WIN32API is defined.

	* fb/ui_font.c:
	  mmap and munmap are invalidated if USE_WIN32API is defined.

	* ui_event_source.c, win32/ui_display.c:
	  SetTimer() is called from ui_event_source.c to win32/ui_display.c.

	* ui_event_source.c: USE_WIN32API => NO_DISPLAY_FD

	* */ui.h: NO_DISPLAY_FD macro is defined (or undefined).

2018-02-03  Araki Ken  <arakiken@users.sf.net>

	* ui_draw_str.c, ui_font_cache.[ch], ui_font_manager.c,
	  ui_im_{candidate|status}_screen.c, ui_screen.c: xfont => uifont

	* fb/ui_window.c: Compiling error is fixed.

	* Android.mk: ui_emoji.c is added.

2018-01-30  Araki Ken  <arakiken@users.sf.net>

	* ui_window.c: 'is_var_col_width' argument is added to draw_string()
	  to distinguish it in drawing glyphs of true type fonts.

	* ui_font.c:
	  - IS_PROPORTIONAL() => HAS_POSITION_INFO_BY_GLYPH()
	  - enable_position_info_by_glyph() which adds 3 bytes position info
	    to each glyph.
	  - Position info is stored at the begining of glyph array instead of
	    at the end.

	* ui_font.h: 'y' argument of ui_get_bitmap_line() is changed to
	  'offset_bytes' (== y * xfont->glyph_width_bytes)

2018-01-27  Araki Ken  <arakiken@users.sf.net>

	* README.ja, man/mlterm.1, doc/en/PROTOCOL: Updated.

	* ui_screen.c: "emoji_path" is added to OSC 5379, 5380 and 5381.

	* ui_picture.c: ui_load_inline_picture() doesn't check if path exists.
	  (The caller should do it.)

	* ui_main_config.c: --emoji / emoji_path option is added.

	* ui_emoji.[ch]: Added.

	* c_imagelib.c: gdk_pixbuf_new_from_otf() which reads emoji fonts such as
	  NotoColorEmoji.ttf is added if USE_FREETYPE_EMOJI is defined.

	* vt_parser.c: Not only U+1F1000-1F6FF but also U+1F900-1F9FF characters
	  are treated as emoji.

	* fb/ui_font.c: Whether face->units_per_EM is 0 or not is checked.

	* win32/ui_font.c: Compiling error is fixed.

2018-01-20  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c:
	  - Searching unicode_noconv_areas, full_width_areas and half_width_areas
	    is improved.
	  - auto_detect_count => num_auto_detect_encodings

	* vt_char.c: Searching unicode_areas in vt_char_set() is improved.

2018-01-14  Araki Ken  <arakiken@users.sf.net>

	* PROTOCOL, README.ja, mlterm.1, etc/main, etc/main.ja: Updated.

	* ui_screen_manager.c:
	  "main_config.encoding = vt_term_get_encoding(screen->term)" is moved before
	  create_term_intern() in open_pty().

	* mc_char_width.c, mlconfig/po/*.po:
	  - "Set full width\nareas manually" is changed to "Add full width areas".
	  - "Add half width areas" button is added.

	* vt_parser.[ch]:
	  - vt_set_half_width_areas() is added.
	  - The char width of EF_AWIDTH property is determined in modify_ucs_property()
	    (called from vt_convert_to_internal_ch()) instead of put_char().
	  - "unicode_half_width_areas" is added to OSC 5379, 5380 and 5381.

	* ui_main_config.c: --halfwidth / "unicode_half_width_areas" option is added.

2018-01-13  Araki Ken  <arakiken@users.sf.net>

	* README.fb, README.comb: Updated.

	* doc/en/README.w3m: Removed.

	* vterm.c: Typo is fixed.

	* drcssixel/DRCS-SIXEL-v2: Moved from doc/en.

	* drcssixel/drcssixel.c, drcssixel/test.c: Added.

2018-01-10  Araki Ken  <arakiken@users.sf.net>

	* c_sixel.c: Memory allocation is improved.

2018-01-09  Araki Ken  <arakiken@users.sf.net>

	* ui_im_status_screen.c: If USE_STATUS_LINE is defined, DECSSDT/DECSASD
	  is used to show status characters.

2018-01-07  Araki Ken  <arakiken@users.sf.net>

	* ui_picture.c: cleanup_inline_pictures() checks DRCS-SIXEL.

	* vt_drcs.h: vt_drcs_has_picture() is added.

	* vt_pty.c: vt_pty_new_with() doesn't call vt_config_menu_init() if pty is NULL.

	* quartz/ui_imagelib.c: ui_imagelib_load_file() resizes a loaded image.

2018-01-06  Araki Ken  <arakiken@users.sf.net>

	* gdiplus.cpp: Sixel graphics is resized to specified width and height.

	* vt_parser.c: Minor fixes.

2018-01-06  Araki Ken  <arakiken@users.sf.net>

	* DRCS-SIXEL-v2: Updated.

	* vt_parser.c:
	  - define_drcs_picture() is added.
	  - "Pan;Pad;Ph;Pv is processed in receiving DRCS-Sixel sequence, and
	    image pieces is scaled according to Pcmw/Pcmh and Ph/Pv.

	* vterm.c: "Pan;Pad;Ph;Pv is output unless DRCS_SIXEL=old environmental
	  variable is defined.

2018-01-03  Araki Ken  <arakiken@users.sf.net>

	* DRCS-SIXEL-v2: Updated.

	* ui_font_config.c: ui_font_config_dump() outputs "_FULLWIDTH".

	* vterm.c: Pcmw and Pcmh in DECDLD are correctly set.

2018-01-02  Araki Ken  <arakiken@users.sf.net>

	* DRCS-SIXEL-v2, libvterm/README: Updated.

	* vterm.c: Adjusting vterm->drcs_charset and vterm->drcs_plane is placed
	  before DRCS-SIXEL sequence is output.

2018-01-01  Araki Ken  <arakiken@users.sf.net>

	* DRCS-SIXEL-v2: Updated.

	* vterm.c: col_size_of_width_a is 1 if locale is ja_XX.XX.

2017-12-31  Araki Ken  <arakiken@users.sf.net>

	* DRCS-SIXEL-v2: Updated.

	* vterm.c:
	  - q"%d;%d;%d;%d in sixel to be sent to terminal emulator as DRCS-Sixel is
	    skipped.
	  - 0x30-0x3f is accepted as vterm->drcs_charset.
	  - "DRCS_SIXEL_VERSION" environmental varaible is dropped and "DRCS_SIXEL=old"
	    is used.

	* vt_parser.c:
	  - 0x30-0x3f character set is accepted for drcs.
	  - Sixel sequence (in DRCS) which doesn't contain 'q' is accepted.
	  - "drcs_sixel_version" is dropped and "old_drcs_sixel" is added to OSC 5379-5381.

	* vt_drcs.[ch]: 0x30-0x3f character set is accepted.

	* ef_charset.h: The range of CS96SB_ID() is changed from 0x40-0x7e to 0x30-7e
	  to handle drcs correctly.

2017-12-31  Araki Ken  <arakiken@users.sf.net>

	* DRCS-SIXEL-v2: Updated.

	* vt_parser.c: 'font->pic_num_cols > 0' => vt_drcs_is_picture()

	* vt_drcs.[ch]:
	  - The position of 'return 0' is fixed.
	  - vt_drcs_is_picture() is added.

2017-12-30  Araki Ken  <arakiken@users.sf.net>

	* vterm.c: cell->attrs.reverse is set in vterm_screen_get_cell().

	* vt_parser.c: DRCS-Sixel is enclosed by #ifndef NO_IMAGE ... #endif.

2017-12-30  Araki Ken  <arakiken@users.sf.net>

	* vterm.c: xterm_get_picture_data() rejects files except sixel.

2017-12-30  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c: If vt_parser->pty is NULL or not is checked in write_loopback()
	  because vt_term_write_loopback() in open_pty_intern() in ui_screen_manager.c
	  can be called when vt_parser->pty is NULL in connecting to ssh server.

	* vterm.c: default_fg and default_bg are the same as original libvterm.

2017-12-30  Araki Ken  <arakiken@users.sf.net>

	* vterm.c, ui_screen.c: RLogin way of calculating the number of columns
	  of sixel graphics image is changed from 'width / col_width' to
	  '(width + 1) / col_width'.

	* doc/en/DRCS-SIXEL-v2: Added.

2017-12-29  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.[ch], ui_screen.c: Unless ENABLE_OSC5379PICTURE is defined,
	  "show_picture" and "add_frame" are removed from OSC 5379.

	* vterm.c, ui_screen.c:
	  RLogin way of calculating the number of columns and rows of sixel
	  graphics image is changed from ({width|height} + 1) / col_{width|height}
	  to {width|height} / col_{width|height}.

	* c_sixel.c: char* => const char*

	* ef_iso2022_parser.[ch], ef_utf{16|32}_conv.[ch]:
	  The tyep of return value of ef_iso2022_parser_init_func() and
	  ef_utf{16|32}_conv_use_bom() is changed from int to void.

2017-12-25  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c:
	  - save_sixel_or_regis() is added.
	  - DRCS-Sixel sequence which rlogin originally supports is processed.
	  - If OSC 5379;drcs_sixel_version=2, cols and rows of DRCS-Sixel image
	    are rounded up.

	* vt_drcs.[ch]:
	  - vt_drcs_add_picture() and vt_drcs_get_picture() are added.
	  - 'vt_drcs_t *drcs' is added to arguments of vt_drcs_get_font(),
	    vt_drcs_final() and vt_drcs_final_full().

	* ui_screen.c, ui_screen_manager.c:
	  xterm_get_picture_data() returns num_cols_small and num_rows_small.

	* vterm.c:
	  - write_to_stdout() is added.
	  - xterm_get_picture_data() returns num_cols_small and num_rows_small.
	  - If the value of "DRCS_SIXEL_VERSION" environmental variable is "2",
	    num_cols and num_rows are rounded up.
	  - vt_convert_drcs_to_unicode_pua() and vt_convert_unicode_pua_to_drcs()
	    processes following extension.
	    U+10XXZZ (0x40 <= 0xXX <= 0x7E, 0xA0 <= 0xZZ <= 0xFF)
	    => ESC - SP <\xXX> <\xYY>

	* encodefilter/src/Makefile.in: MAJOR.MINOR 1.0 => 2.0

	* ef_charset.h: The range of CS94SB_ID() is changed from 0x40-0x6f to 0x40-0x7e
	  to handle drcs correctly.

2017-12-19  Araki Ken  <arakiken@users.sf.net>

	* vterm.c: Sixel graphics is supported with the use of sixel extension of
	  DRCS of rlogin.

	* mlterm.[ch]: mlterm_final() is added.

	* vt_parser.c: Wrong new buffer size in write_loopback() is fixed.

2017-12-15  Araki Ken  <arakiken@users.sf.net>

	* README.ja: Updated.

	* java/Makefile.in: vtemu/mlterm.o is built.

	* mlterm.[ch], MLTermPty.c: Java_mlterm_MLTermPty_nativeOpen() in MLTermPty.c
	  is separated to mlterm_open() in mlterm.[ch].

	* ef_utf32_parser.c: Illegal access to uninitalized memory is fixed.

	* configure.in: libvterm/Makefile is generated.

	* Makefile.in: vterm, install-vterm and clean-vterm targets are added.

	* libvterm/*: Added.

	* vt_termcap.c: vt_termcap_special_key_to_seq() returns "\x1b" for SPKEY_ESCAPE.

	* vt_parser.[ch]:
	  - write_loopback() changes behavior if pty is for libvterm or not.
	  - vt_parser_set_use_multi_col_char() is removed.

	* ui_screen.c, vt_parser.c: OSC 5379/5380 of "use_multi_column_char" is
	  processed in vt_parser.c instead of ui_screen.c.

	* vt_pty_ssh.c: vt_pty_ssh_keepalive() returns left time of keepalive.

	* version.h: 3.8.4 -> 3.8.4post

2017-12-02  Araki Ken  <arakiken@users.sf.net>

	* 3.8.4 released.
	  (tag "rel-3_8_4")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.8.4.

	* PROTOCOL, man/mlterm.1: Updated.

2017-12-02  Araki Ken  <arakiken@users.sf.net>

	* ui_font_ft.c: ISCII and ISO10646_UCS4_1 fonts are forced to be treated as
	  proportional.

2017-11-30  Araki Ken  <arakiken@users.sf.net>

	* doc/en/PROTOCOL, doc/en/README.fb, doc/ja/README.fb, README.ja: Updated.

	* vt_line.c: line->ctl_info.ot_layout->complex_shape and
	  line->ctl_info.ot_layout->has_var_width_char are checked.

	* vt_ot_layout.[ch]:
	  complex_shape and has_var_width_char are added to vt_ot_layout_state_t.

	* vt_shape.[ch]: IS_VAR_WIDTH_CHAR() is added.

	* hb.c: convert_text_to_glyphs() always sets glyph indexes in 'shaped'.

	* ui_screen.c: vt_line_unshape() is added before 'return 0' in draw_cursor().

	* ui_draw_str.[ch]: ui_calculate_mlchar_width() -> ui_calculate_vtchar_width()

2017-11-26  Araki Ken  <arakiken@users.sf.net>

	* MLTermPty.c:
	  vt_char_underline_style() and vt_char_is_crossed_out() => vt_char_line_style()

	* skk/dict.c:
	  - set_blocking() -> set_nonblocking()
	  - check_protocol_4() returns 0 if recv() returns error except EAGAIN.

2017-11-26  Araki Ken  <arakiken@users.sf.net>

	* vte.c: Return value type of vte_terminal_draw() is fixed.

2017-11-25  Araki Ken  <arakiken@users.sf.net>

	* quartz/ui_window.c, xlib/ui_window.c: ui_window_set_maximize_flag() supports
	  MAXIMIZE_HORIZONTAL and MAXIMIZE_VERTICAL.

	* quartz/cocoa.[hm]: window_move_resize() is added.

	* fb/ui_window.c: ui_window_set_maximize_flag() calls ui_display_set_maximized()
	  on wayland.

	* wayland/ui_display.[ch]: ui_display_set_maximized() is added.

	* ui_window.h, */ui_window.c: 'Window *child' is removed from arguments of
	  ui_window_translate_coordinates().

	* vte.c: vt_xterm_event_listener_t::xterm_resize is overridden by
	  xterm_resize() in vte.c which supports MAXIMIZE_FULL and MAXIMIZE_RESTORE.

2017-11-23  Araki Ken  <arakiken@users.sf.net>

	* ui_draw_str.c:
	  - LS_OVERLINE is processed.
	  - is_crossed_out and underline_style are united to line_style.

	* ui_im_{status|candidate}_screen.c:
	  Fixes of vt_char_set() and vt_char_combine() arguments.

	* inputmethod/*/*.c: Fixes of syms->vt_char_combine and syms->vt_char_set arguments.

	* vt_edit.[ch]:
	  - 53 and 55 of 'attr' argument of vt_edit_change_attr_area() are processed.
	  - Fixes of vt_char_set() arguments.

	* vt_parser.[ch]:
	  - is_crossed_out is removed from vt_parser_t and vt_storage_states_t.
	  - 'CSI 53 m' and 'CSI 55 m' are supported.

	* vt_char.[ch]:
	  - vt_underline_style_t -> vt_line_style_t
	  - LS_CROSSED_OUT and LS_OVERLINE are added to vt_line_style_t.
	  - vt_char_underline_style() -> vt_char_line_style().
	  - is_crossed_out is removed from arguments of vt_char_set() and vt_char_combine().
	  - is_overlined is added to arguments of vt_char_{change|reverse}_attr().
	  - vt_char_cols() returns 0 (not 1) just before vt_char_init().

	* fb/ui_imagelib.c: Minor fixes.

	* fb/ui_display.c: ui_cmap_get_pixel_rgb() returns 0 if specified pixel
	  is TP_COLOR on x68k.

	* fb/ui.h: COLOR_CACHE_MINIMUM is defined.

	* c_sixel.c: color_indexes[color] is used instead of color
	  if SIXEL_SHAREPALETTE is defined.

	* ef_charset.h: IS_ISO10646_UCS4 is moved from vt_char.h.

2017-11-21  Araki Ken  <arakiken@users.sf.net>

	* ui_screen.c, vt_parser.[ch]:
	  - 'int flag' is added to arguments of vt_xterm_event_listener_t::resize().
	  - "CSI 9;P1 t" is supported.

	* ui_window.h, */ui_window.c: ui_window_set_maximize_flag() is added.

	* console/ui_display.c: HAVE_GETTIMEOFDAY is considered.

	* c_sixel.c, c_imagelib.c: SIXEL_SHAREPALETTE works if USE_GRF is defined.

2017-11-19  Araki Ken  <arakiken@users.sf.net>

	* doc/en/ControlSequences: Updated.

	* vt_parser.c: "CSI ? 8452 h" is always set on status line.

2017-11-18  Araki Ken  <arakiken@users.sf.net>

	* win32/ui_window.c: WM_SYSKEYDOWN event of VK_OEM_XXX keys are ignored.

	* im_skk.c: sticky_shift_key is separated to sticky_shift_ch and sticky_shift_ksym.

	* quartz/ui_event_source.c, quartz/ui_scrollbar.c: Compiling error is fixed.

2017-11-15  Araki Ken  <arakiken@users.sf.net>

	* fb/ui_window.c:
	  max_glyph_width is limited to font_width - font_x_off in draw_string_intern().

	* fb/ui_font.[ch]:
	  - Compiling error is fixed.
	  - ui_get_bitmap_width() and ui_get_bitmap_width_aa() are removed.

2017-11-14  Araki Ken  <arakiken@users.sf.net>

	* fb/ui_imagelib.c:
	  - load_sixel_with_mask_from_file_1bpp() is enabled only if
	    BUILTIN_SIXEL macro is defined.
	  - load_file() tries load_sixel_from_data_sharepalette() if depth <= 8 and
	    pic_mod is normal.

	* c_sixel.c:
	  - load_sixel_from_data_sharepalette() is added if SIXEL_SHAREPALETTE macro
	    is defined.
	  - read_sixel_file() is added.

	* vt_parser.c:
	  "#0;9;%d;%d;%d" instead of "#0;2;%d;%d;%d" is added to sixel sequences.

2017-11-12  Araki Ken  <arakiken@users.sf.net>

	* c_sixel.c:
	  - Checking if width and height is changed is placed outside of realloc_pixels().
	  - The way of calculation of accessing address of 'pixels' array is changed.

	* ui_imagelib.c, vt_parser.c: Minor fixes.

2017-11-11  Araki Ken  <arakiken@users.sf.net>

	* skk/dict.c: dict_set_global() is fixed.

	* vt_edit.c: vt_edit_fill_area() applies bce fg/bg colors to a character to be filled.

	* vt_screen.[ch]: vt_screen_fill_area() is changed from a function to a wrapper macro
	  of vt_edit_fill_area().

2017-11-11  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c: Parameter of SL and SR is regarded as 1 if omitted.

	* vt_edit.c:
	  - {copy|erase}_area() are used in vt_edit_scroll_{right|left}ward()
	    instead of vt_edit_{copy|erase}_area().
	  - The third argument of erase_area() is fixed in
	    vt_edit_scroll_leftward_from_cursor().

2017-11-11  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c: DECSR is supported.

2017-11-10  Araki Ken  <arakiken@users.sf.net>

	* num_of_xxx -> num_xxx

2017-11-10  Araki Ken  <arakiken@users.sf.net>

	* vt_cursor.[ch]: Functions whose return values are not used return void.

	* vt_edit.[ch]:
	  - horizontal_tabs() moves cursor downward if edit->wraparound_ready_line is set.
	  - horizontal_tabs() checkes edit->hmargin_beg.
	  - vt_edit_set_{h|v}margin() move cursor to the top-left corner.
	  - vt_edit_set_use_hmargin() doesn't move cursor.

	* vt_screen.h, vt_parser.c: Minor fixes.

2017-11-05  Araki Ken  <arakiken@users.sf.net>

	* ui_im.h, ui_screen.c: write_to_status_line is added to ui_im_event_listener_t
	  if DEBUG is defined.

	* vt_screen.c: change_edit() calls vt_set_modified_all() only if both current
	  screen->edit and new edit aren't screen->status_edit.

2017-11-05  Araki Ken  <arakiken@users.sf.net>

	* vt_model.c: Whether vt_model_get_num_of_filled_rows == 0 or not is not checked
	  in vt_model_resize().

2017-11-05  Araki Ken  <arakiken@users.sf.net>

	* vt_edit.c: vt_edit_resize() moves cursor to the bottom line if cursor position
	  is outside of the screen after resizing.

	* vt_model.c: vt_mode_get_num_of_filled_rows() uses
	  vt_line_get_num_of_filled_chars_except_spaces() instead of vt_line_is_empty().

	* im_skk.c:
	  - cand_screen -> status_screen
	  - start_candidate is added to struct im_skk.

2017-11-05  Araki Ken  <arakiken@users.sf.net>

	* vt_screen.c: change_edit() changes screen->main_edit correctly.

	* vt_parser.c: vt_set_pty_winsize() is called in processing DECSSDT.

2017-11-04  Araki Ken  <arakiken@users.sf.net>

	* ControlSequences: Updated.

	* MLTermPty.c:
	  If vt_term_has_status_line() is true, window_scroll_upward_region() does nothing.

	* ui_picture.c: vt_term_get_rows() is placed before for(;;) instead of inside for(;;).

	* ui_screen.c:
	  - screen_height() considers if status line is shown or not.
	  - xterm_resize() converts 0 width or height to current width or height.
	  - xterm_get_window_size() returns window size excluding status line.

	* vt_term.h: vt_term_has_status_line() is added.

	* vt_parser.c:
	  - DECSSDT and DECSASD are supported.
	  - "CSI 4 t", "CSI 8 t", "CSI 14 t" and "CSI 18 t" ignores the height of status line.
	  - "CSI 4 t" and "CSI 8 t" allow omission of the third parameter.
	  - CPR, XCPR and DECCIR reports relative position if DECOM is set.
	  - DECSDM never considers DECOM.

	* vt_screen.c:
	  - vt_screen_has_status_line(), vt_screen_set_use_status_line(),
	    vt_status_line_is_focused(), vt_focus_status_line() and vt_focus_main_screen()
	    are added.
	  - Functions whose return values are not used return void.
	  - vt_screen_cursor_logical_{col|row}() are addded, and
	    vt_screen_cursor_relative_{col|row}() are removed.
	  - vt_screen_resize(), vt_screen_cursor_row(), vt_screen_cursor_row_in_screen(),
	    vt_screen_get_rows(), vt_screen_get_line() and vt_screen_get_line_in_screen()
	    considers status line.
	  - vt_get_logical_{cols|rows}() checks not only screen->logvis but also
	    screen->logvis->is_visual.

	* vt_edit.[ch]:
	  - Functions whose return values are not used return void.
	  - vt_edit_cursor_logical_{col|row}() are added, and vt_cursor_relative_{col|row}()
	    are removed.

2017-10-31  Araki Ken  <arakiken@users.sf.net>

	* ControlSequences, man/mlterm.1, README.ja: Updated.

	* mc_wordsep.c: ';' is replaced by '\x3b'.

	* mc_im.c:
	  - "Dictionary" and "Sticky shift key" entries are added to skk options.
	  - "Server" entry is added to wnn options.

	* mlconfig/main.c: USE_{XLIB|WIN32|QUARTZ} => strcmp(mc_get_gui(), "{xlib|win32|quartz}")

	* skk/dict.c:
	  - 'static int is_loaded' (renamed to global_is_loaded) is reset in dict_set_global().
	  - dict_set_global() always closes global_sock.

	* im_skk.c: 'char *engine' of im_skk_new() arguments is renamed to 'options', and
	  its format is changed from "[dictionary]" to
	  "dict=[dictionary],sskey=[sticky shift key]".

	* im_wnn.c: "--im wnn:[server]" option is supported.

	* ui_im.[ch]: XStringToKeysym() is added to ui_im_export_syms.

2017-10-24  Araki Ken  <arakiken@users.sf.net>

	* ControlSequences: Updated.

	* vt_parser.c: DECRQTSR is fixed.

2017-10-23  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c: DECCIR, XCPR, DSR(Locator) and DECCKSR are fixed.

2017-10-22  Araki Ken  <arakiken@users.sf.net>

	* ControlSequences: Updated.

	* vt_parser.c:
	  - "CSI 34 [hl]" is supported.
	  - "CSI ? 9500 [hl]" is removed.

	* mc_opentype.c:
	  - strcasestr() is replaced by ascii_strcasestr() which is originally implemented.
	  - strcasecmp() is replaced by g_strcasecmp().

2017-10-22  Araki Ken  <arakiken@users.sf.net>

	* java/Makefile.in: 'sort -r' is added in creating manifest.mf.

	* ef_ucs4_*.c: Code formatting.

	* vt_parser.[ch]: "CSI ? Pm [rs]" is supported.

2017-10-21  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.[ch]:
	  - DECBBSM(CSI ? 116 [hl]), DECRQTSR(CSI 2 $ u), DECCTR(CSI 2;Pu $ u),
	    DECRQPSR(CSI $ w), DECSNLS(CSI * |), DECSTGLT(CSI ) {) and
	    DECRSPS(DCS Ps $ t D...D ST) are supported.
	  - If 1 bit flags of vt_parser_t is copied to int variable,
	    intvalue = vt_parser->xxx ? 1 : 0.
	  - DECRQSS supports DECSTGLT, DECSCPP, DECSLPP, DECSNLS, DECAC and DECATC.
	  - Corrupt response of XCPR is fixed.
	  - Corruption of TBC (CSI g), CTC (CSI W) and DECATC(CSI ,}) is fixed.
	  - use_ansi_color is added to arguments of vt_parser_new().
	  - bold_affects_bg and use_ansi_color are added to vt_parser_t.
	  - vt_set_use_ansi_colors() is removed.

	* vt_edit.[ch]:
	  - vt_edit_is_tab_stop() is added.
	  - vt_edit_set_{relative|absolute}_origin() => vt_edit_set_relative_origin().

	* vt_color.[ch]: vt_color_force_linear_search() is added.

	* ui_main_config.[ch]: use_ansi_color is added to ui_main_config_t.

	* doc/en/ControlSequences: Added.

2017-10-14  Araki Ken  <arakiken@users.sf.net>

	* ui_brltty.c: bl_priv_change_e{u|g}id() are called if brlapi_openConnection() fails.

2017-10-12  Araki Ken  <arakiken@users.sf.net>

	* mc_click.[ch], mc_opentype.[ch]: Added.

	* mc_flags.[ch]: MC_FLAG_TRIMNEWLINE and MC_FLAG_BROADCAST are added.

	* mc_space.[ch]: MC_SPACE_BASELINE and MC_SPACE_UNDERLINE are added.

	* vt_term.c: "ot_features" and "ot_script" are added to OSC 5380 and 5381.

	* vt_ot_layout.[ch]: vt_get_ot_layout_attr() is added.

	* mlconfig/po/*.po: Updated.

2017-10-11  Araki Ken  <arakiken@users.sf.net>

	* fb/ui_font.c: "#include FT_OUTLINE_H" is added.

	* fb/ui_window.c: Compiling error is fixed.

2017-10-11  Araki Ken  <arakiken@users.sf.net>

	* ef_johab_conv.c, ui_main_config.c, man/mlterm.1:
	  https://sf.net/p/mlterm/patches/_discuss/thread/f5dc445d/0fc3/attachment/fix_spelling.diff
	  is merged.

2017-10-09  Araki Ken  <arakiken@users.sf.net>

	* doc/ja/README.ja: Updated.

	* main_loop.c: The return value of ui_screen_manager_init() is checked.

	* ui_screen.c: "click_interval" is added to OSC 5379, 5380 and 5381.

	* ui_font.h, */ui_font.c:
	  - ui_font_t::cols member is removed.
	  - ui_change_font_cols() is removed.

	* */ui_window.[ch]: ui_get_click_interval() is added.

	* ui_font_manager.[ch]:
	  ui_set_use_multi_col_char() and ui_is_using_multi_col_char() are removed.

	* ui_font_cache.[ch]:
	  - ui_font_cache_unload() reuses font_cache->usascii_font
	    after failure of init_usascii_font().
	  - ui_font_cache_t::use_multi_col_char is removed.

	* ui_main_config.c: The default value of "use_vertical_cursor" option is
	  changed from "false" to "true".

	* ui_sb_view_factory.[ch]: const modifier is added to 'name' argument of
	  ui_{transparent_}sb_view_new() and ui_unload_scrollbar_view_lib().

	* vt_parser.c:
	  - DECSCPP and DECSLPP are supported.
	  - "CSI [ 7 t" executes "update_all" of OSC 5379.

	* *.[ch]: Functions whose return values are not used return void.

2017-10-02  Araki Ken  <arakiken@users.sf.net>

	* doc/en/PROTOCOL: Updated.

	* ui_screen.c:
	  - draw_cursor() checks if cursor position is outside of the screen or not.
	  - report_mouse_tracking() considers vertical mode.
	  - "use_vertical_cursor" is added to get_config_intern() and ui_screen_set_config().

	* ui_window.c:
	  - Whether glyph width exceeds ui_get_bitmap_width()/ui_get_bitmap_width_aa()
	    or not is checked

	* fb/ui_font.h:
	  - ui_get_bitmap_width() is renamed to ui_get_bitmap_width_aa().
	  - ui_get_bitmap_width() which is for not anti aliased fonts is added.

	* fb/ui_font.c:
	  - width and width_full of XFontStruct have equal value if there is no full
	    width glyph.
	  - load_glyph() keeps face->glyph->format of FT_Load_Glyph().
	  - FT_Set_Transform() in load_ft() => FT_Outline_Set_Transform() in load_glyph()
	  - is_rotated_char() returns 1 if ch is 0xff08-ff09, 0xff0d, 0xff1a-ff1e, 0xff3b,
	    0xff3d, 0xff5b-ff5e or 0xff62-0xff63.
	  - is_right_aligned_char() is added.

	* ui_font.h: FONT_VERTICAL => FONT_VERT_RTL and FONT_VERT_LTR.

	* MLPreferenceActivity.java:
	  - list.setValueIndex() is called in addList().
	  - "Vertical cursor" checkbox is added.

	* android/jni/ui_event_source.c: config_listener->set is called between
	  pthread_mutex_{un}lock() in
	  Java_mlterm_native_1activity_MLPreferenceActivity_setConfig().

2017-09-28  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_display.c: 'capabilities' event of wl_seat_listener is handled.

	* ui_im_{status|candidate}_screen.c:
	  ui_font_manager is newly created if terminal screen is vertical mode
	  and USE_REAL_VERTICAL_FONT macro is defined.

	* fb/ui_font.c:
	  - FONT_ROTATED is defined as (FONT_ITALIC << 1) internally and
	    XFontStruct::format contains its bit.
	  - load_glyph() rotates glyphs if format has FONT_ROTATED bit.
	  - is_rotated_char() is added.
	  - 'ch' which contains unicode code point is added to arguments of
	    get_ft_bitmap_intern().

	* */ui.h: USE_REAL_VERTICAL_FONT macro is added.

	* version.h: 3.8.3 -> 3.8.3post

2017-09-23  Araki Ken  <arakiken@users.sf.net>

	* 3.8.3 released.
	  (tag "rel-3_8_3")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.8.3.

	* PROTOCOL, man/mlterm.1: Updated.

2017-09-22  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c: DECRQM reports SPKEY_BACKSPACE setting of vt_termcap_t
	  instead of vt_parser_t::vtmode_flags for DECBKM.

2017-09-21  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c:
	  - SHIFT_FLAG64 macro is added.
	  - initial_vtmode_flags() is changed to INITIAL_VTMODE_FLAGS macro.
	  - RIS(ESC c) moves cursor to the upper left.

2017-09-19  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.[ch]:
	  - VTMODE_20 macro and vt_parser_t::auto_cr are added to support LNM.
	  - Cursor is moved to left-upper cell by DECOLM.
	  - INITIAL_VTMODE_FLAGS macro is changed to initial_vtmode_flags() function
	    to process 64bit shift properly.
	  - soft_reset() resets options via set_vtmode().

2017-09-18  Araki Ken  <arakiken@users.sf.net>

	* ui_screen.c: get_config_intern() supports "fontconfig" which dumps
	  current font settings.

	* ui_font_manager.h: ui_font_manager_dump_font_config() is added.

	* ui_font_config.[ch]:
	  - ui_get_all_config_font_names() => ui_get_config_font_names_all()
	  - ui_font_config_dump() is added.

	* vt_char.[ch]: vt_get_unicode_area() is added.

	* vt_font.h:
	  - FONT_WITHOUT_SIZE_ATTR() is removed.
	  - HAS_UNICODE_AREA() => UNICODE_AREA()

	* MLActivity.java: String {resume|pause}Native() => void {resume|pause}Native()

2017-09-17  Araki Ken  <arakiken@users.sf.net>

	* ui_screen.c: Common processing in get_spot() and get_im_spot() is separated to
	  get_spot_intern().

	* console/ui_font.c, console/ui_window.c:
	  - White spaces are inserted between ASCII characters in vertical mode.
	  - scroll_region() can scroll screen leftward or rightward.

	* vt_term.c: NOT_CONVERT_TO_ISCII macro which is defined on console and cocoa
	  disables CONVERT_UNICODE_TO_ISCII.

	* cocoa.m:
	  - cand_x and cand_y which stores the initial position of preediting
	    to determine the position of candidate window are added to MLTermView.
	  - font->x_off is reflected in drawUnistr().
	  - ui_screen_t::is_preediting = 1 in preediting.

	* quartz/ui_font.c: font->x_off is set in vertical mode.

	* im_fcitx.c: Alt+Backspace => Alt+Control+h, Control+[ => Escape in key_event().

	* */ui_display.c, fb/ui_display_*.c: Pressing alt key sets Mod1Mask instead of ModMask.

	* fb/ui_display_freebsd.c: XButtonEvent::button is set if event type is ButtonRelease.

	* wayland/ui_display.c:
	  - "if (!display->buffer)" is added to ui_display_copy_lines().
	  - XButtonEvent::button is set if event type is ButtonRelease.

	* ui_im_{candidate|status}_screen.c:
	  - ui_window_t::disp::display::parent is used to get size of the
	    display on wayland.
	  - "cand_screen->num_of_candidates > 0" is checked before calling draw_screen()
	    in window_exposed().

	* vt_logical_visual.c: Modified area conversion from logical to visual in
	  vert_visual_intern() is fixed.

2017-09-12  Araki Ken  <arakiken@users.sf.net>

	* ui_im_candidate_screen.c: Unexpectedly wide candidate screen in vertical mode
	  is fixed.

	* ui_im_status_screen.[ch]:
	  - Calculating screen width is fixed.
	  - head_indexes[11] => head_indexes[15]

	* im_fcitx.c: candidateword is splitted to multiple lines in update_client_side_ui().

	* libtype/ui_font_ft.c: get_fc_col_width() never returns 0 if font->is_vertical
	  is true on xft.

	* ui_screen_manager.c: width_pix and height_pix are modified by
	  ui_screen_t::screen_width_ratio in open_pty_intern().

	* ui_screen.[ch]:
	  - ui_screen_t::{width|height} are added.
	  - ui_screen_t::screen_width_ratio is removed.

	* vt_term.c: vt_term_open_pty() doesn't swap width_pix and height_pix
	  in vertical mode.

	* fb/ui_font.c: Whether FT_LCD_FILTER_H is defined or not is checked.

	* mlconfig/main.c, mc_ratio.c: "Screen ratio against font size - Width"
	  is removed.

	* ui_main_config.[ch], ui_screen.[ch]: --hscr / "screen_height_ratio" option
	  is removed.

2017-09-09  Araki Ken  <arakiken@users.sf.net>

	* ui_font_config.c:
	  size_attr of 'font' argument of ui_get_config_font_name() is removed.

	* vt_font.h: NO_SIZE_ATTR() macro is added.

	* quartz/ui_font.c:
	  - is_bold and is_italic are added to arguments of parse_font_name().
	  - font->xfont->is_italic = 1 if (font->id & FONT_ITALIC) is true.

	* quartz/cocoa.m, quartz/ui.h: is_italic is added to XFontStruct, and if it is 1,
	  glyphs are slant by CGAffineTransformMake().

	* fb/ui_font.c: is_bold and is_italic are added to arguments of parse_fc_font_name()
	  and if is_bold or is_italic is 1, FONT_BOLD or FONT_ITALIC is set.

	* main-cocoa.m: NSAutoreleasePool is allocated manually before NSApplicationMain().

2017-09-08  Araki Ken  <arakiken@users.sf.net>

	* ui_im_status_screen.[ch]:
	  - head_indexes[10] => head_indexes[11]
	  - "\n" is not shown in a candidate window if the number of candidate lines
	    is over MAX_ROWS.

2017-09-07  Araki Ken  <arakiken@users.sf.net>

	* im_wnn.c: Access to uninitialized memory is fixed.

	* ui_display_linux.c: /sys/class/input/event%d/device/name is prefered to
	  /sys/class/input/input%d/name.

2017-09-06  Araki Ken  <arakiken@users.sf.net>

	* vte.c: Whether ui_customize_font_file() actually customizes font settings
	  is checked before redrawing screen.

	* ui_font_config.c: change_custom_cache() and customize_font_name() return 0
	  if cached value and new value are the same.

2017-09-05  Araki Ken  <arakiken@users.sf.net>

	* ui_im_status_screen.c: max_width of draw_screen() is maximum width
	  of all ui_display_t on wayland.

	* wayland/ui_display.c:
	  - If keyboard_enter() is called in entering input method surface, it sets
	    wlserv->current_kbd_surface to its parent surface instead of input method one.
	  - x and y are removed from arugments of create_surface(), and ui_display_move()
	    is called just after create_shm_buffer().
	  - focus_gtk_window() is not called if input method surface is clicked.

	* wayland/ui_window.c:
	  - win->x and win->y of root windows aren't modified on wayland.

	* im_fcitx.c, im_ibus.c:
	  - NO_XKB macro which is defined on framebuffer and console is added.
	  - connection_handler() works on wayland.

2017-09-03  Araki Ken  <arakiken@users.sf.net>

	* im_m17nlib.c: XKeysymToString() is implemented.

	* im_fcitx.c: fcitx_client_set_cursor_rect() is called in connected().

2017-09-02  Araki Ken  <arakiken@users.sf.net>

	* Makefile.in: vte, install-vte and clean-vte targets are added.

2017-09-02  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_font.c: The height of compl font is forcibly changed to the same
	  one as base font.

2017-09-01  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_display.c: focus_gtk_window(win, time) is not called if
	  ev.type is ButtonRelease.

	* wayland/ui_window.c: win->x and win->y are set to -1 in ui_window_unmap()
	  to show scrollbars correctly on autohide scrollbar mode.

	* vte_wayland.c:
	  - wl_surface_set_user_data(wl_surface, GdkWindow) is called in
	    show_root() in order to make gdk to process events on mlterm surface
	    as those on GdkWindow.
	  - GdkCursor is set by gdk_window_set_cursor().

2017-08-28  Araki Ken  <arakiken@users.sf.net>

	* vt_pty_ssh.c, vt_pty_pipewin32.c, im_iiimf.c:
	  Not only "USER" but also "LOGNAME" environmental variable is used.
	  ("USER" is not set on Solaris 11)

2017-08-27  Araki Ken  <arakiken@users.sf.net>

	* vt_pty_ssh.c: Data in vt_pty_ssh_t is kept after reconnection.

2017-08-26  Araki Ken  <arakiken@users.sf.net>

	* vte.c:
	  - vte_terminal_search_set_regex() and vte_terminal_search_get_regex() are
	    implemented.
	  - 'GRegex* gregex' is added to VteRegex.
	  - ui_screen_t::ui_sel_event_listener_t::select_in_window is overridden
	    and overriding function calls g_signal_emit("selection-changed").
	  - deadline_ignoring_source_cancelled_event defined in wayland/ui_display.c
	    is set to prevent ui_display_clear_selection() from being called by
	    gtk_clipboard_set_text().

	* ui_layout.c:
	  - ui_screen_t::window::window_focused and
	    ui_screen_t::xterm_listener::set_{window|icon}_name are overridden to
	    show window title correctly in splitted screen.
	  - If ui_screen_t or ui_scrollbar_t with a wall picture is moved but not
	    resized in reset_layout() and MANAGE_SUB_WINDOWS_BY_MYSELF is not
	    defined, ui_window_update_all() is called to redraw a wall picture.
	  - HAS_MULTI_CHILDREN macro is added.

	* ui_screen.c:
	  - ui_window_utf_selection_request() is called if
	    ui_window_xct_selection_request() fails in yank_event_received().
	  - ui_get_selection_{conv|parser}() are used.
	  - "next_pty", "prev_pty" and "close_screen" are added to OSC 5379.

	* xlib/ui_window.c: _NET_WM_NAME and _NET_ICON_NAME properties are supported.

	* win32/ui_window.c:
	  - ui_window_set_wall_picture() in ui_window_unset_wall_picture()
	    => ui_window_unset_wall_picture().
	  - 'name' argument of ui_set_{window|icon}_name() is converted to
	    appropriate character encoding.

	* fb/ui_window.c: ui_window_xct_selection_request() returns 0 on android
	  and wayland.

	* quartz/ui_window.c:
	  - ui_window_set_wall_picture() in ui_window_unset_wall_picture()
	    => ui_window_unset_wall_picture().
	  - ui_set_window_name() is implemented.

	* console/ui_window.c
	  - If name is NULL, ui_window_t::app_name is used instead in
	    ui_set_{window|icon}_name().
	  - 'name' argument of ui_set_{window|icon}_name() is converted to
	    appropriate character encoding.

	* fb/ui_window.c:
	  If name is NULL, ui_window_t::app_name is used instead in
	  ui_set_{window|icon}_name().

	* cocoa.[mh]: window_set_title() is added.

	* ui_selection_encoding.h, uitoolkit/*/ui_selection_encoding.c:
	  These files are separated from ui_screen.c.

	* vt_parser.[ch]: "CSI > t" and "CSI > T" are supported.

	* vt_util.[ch]: These files are separated from vt_parser.c.

	* vt_char_encoding.c:
	  The default value of "auto" is changed from unknown encoding to UTF-8.

	* jni/ui_event_source.c, MLActivity.java:
	  "Next pty", "Previous pty" and "Close splitted screen" are added to context menu.

2017-08-13  Araki Ken  <arakiken@users.sf.net>

	* vt_termcap.[ch]: modify_function_keys and modify_cursor_keys are added
	  to arguments of vt_termap_special_key_to_seq().

	* vt_parser.[ch]: ModifyFunctionKeys and ModifyCursorKeys are supported.

2017-08-09  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, README.ja, etc/key, etc/main, etc/main.ja: Updated.

	* ui_main_config.[ch]: "broadcast" / --bc option and
	  "ignore_broadcasted_chars" / --ibc option are added.

	* ui_screen.c:
	  - write_to_pty() broadcasts chars to all ptys if
	    vt_term_is_broadcasted() is true.
	  - write_special_key() is added to wrap vt_term_write_special_key().

	* vt_term.[ch]: vt_term_is_broadcasting() is added.

	* vt_parser.[ch]:
	  - vt_set_broadcast() and vt_parser_is_broadcasting() are added.
	  - "broadcast" and "ignore_broadcasted_chars" are added to OSC 5379 etc.

2017-08-02  Araki Ken  <arakiken@users.sf.net>

	* quartz/ui_display.c, win32/ui_display.c: Minor fixes.

2017-08-02  Araki Ken  <arakiken@users.sf.net>

	* quartz/ui_display.c: dialog() is implemented.

	* quartz/ui_connect_dialog.c: ui_connect_dialog() is implemented.

	* cocoa.[ch]:
	  - cocoa_dialog_{password|okcancel|alert}() are added.
	  - uitoolkit => uiwindow

	* main_loop.c: ignore_unknown_opt of bl_conf_parse_args() is 1 on
	  MacOSX/Cocoa because "open -a /../mlterm.app" command passes
	  "-psn_N_NNNNNN" option to mlterm.

	* main-cocoa.m: Arguments of main() is copied to global_args.

	* bl_dialog.[ch]: char* => const char*

2017-07-30  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.h: is_vt52_mode is moved to the end of vt_parser_t.

2017-07-29  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_window.c: copy_blended_pixel() is fixed.

	* gtk/vte.c:
	  - vte_terminal_set_colors() falls back to the default palettes
	    if palette_size == 0.
	  - vte_terminal_set_default_colors() is implemented.

2017-07-27  Araki Ken  <arakiken@users.sf.net>

	* fb/ui_font.c: Wrong processing of percentage in fontname is fixed.

2017-07-23  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, README.ja, PROTOCOL: Updated.

	* ui_screen.[ch]:
	  - ui_set_trim_trailing_newline_in_pasting() which trims trailing newline
	    in pasting text is added.
	  - "trim_trailing_newline_in_pasting" is added to OSC 5379, 5380 etc.
	  - shortcut_str() is called just after shortcut_match() in key_pressed().

	* vt_screen.c: check_or_copy_region() doesn't append extra space at the end.

	* version.h: 3.8.2 -> 3.8.2post

2017-07-17  Araki Ken  <arakiken@users.sf.net>

	* 3.8.2 released.
	  (tag "rel-3_8_2")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.8.2.

	* PROTOCOL, man/mlterm.1: Updated.

	* im_iiimf.c, im_uim.c, vte.c: Compiling error is fixed.

2017-07-15  Araki Ken  <arakiken@users.sf.net>

	* ui_main_config.c: If USE_FREETYPE is defined, "use_anti_alias" option works.

	* fb/ui_font.c:
	  - FT_Library_SetLcdFilter() is called in load_ft().
	  - FONT_NOAA of ui_font_present_t is checked.

	* gtk/vte.c:
	  - vte_terminal_hierarchy_changed() is moved to vte_x11.c
	  - vte_terminal_draw(), vte_terminal_spawn_async(), vte_pty_spwan_async(),
	    vte_terminal_{get|set}_allow_hyperlink and
	    vte_terminal_hyperlink_check_event() are added.
	  - Whether 'exception' is NULL or not is checked in
	    vte_terminal_set_word_char_exceptions().

	* gtk/vte_x11.c: FORCE_TRANSPARENCY macro is added.

2017-07-05  Araki Ken  <arakiken@users.sf.net>

	* main-con.c: It is assumed that mlterm-con-server is in BINDIR
	  instead of LIBEXECDIR/mlterm on cygwin and msys.

	* bl_pty_helper.c, c_imagelib.c, c_regis.c, */ui_imagelib.c,
	  vt_config_menu.c: BL_LIBEXECDIR is used.

	* bl_path.h: BL_LIBEXECDIR(suffix) is added.

	* ui_im_status_screen-cocoa.m: Compiling error is fixed.

2017-07-02  Araki Ken  <arakiken@users.sf.net>

	* ui_screen.c: <dev> in OSC 5379;<dev>:a=b works.

	* vt_parser.c: "challenge" of OSC 5380 works from console not only mlconfig.

	* accessories/mlsplit.sh: Added.

2017-06-29  Araki Ken  <arakiken@users.sf.net>

	* README*, man/mlterm.1: Updated.

	* configure.in: utmp is forcibly disabled on cygwin and mingw.

2017-06-25  Araki Ken  <arakiken@users.sf.net>

	* vt_edit.c: vt_edit_save_protected_chars() doesn't call malloc()
	  until vt_char_is_protected() is true.

	* ui_font_ft.c:
	  - Whether a name of a loaded font for iscii is *-TT* or not is
	    checked, and if not, x_font_new() returns NULL.
	  - cairo_font_open() removes FC_*LANG from font->pattern.

	* hb.c:
	  - Characters are separated to segments and hb_shape() is called
	    for each segment.
	  - RTL scripts are supported.

	* ui_im.[ch], im_*.c, ui_im_{candidate|status}_screen.c, vt_parser.[ch]:
	  Arguments of vt_convert_to_internal_ch() and
	  ui_im_{candidate|status}_screen_new() are changed.

	* ef_ucs_property.table: Updated to Unicode 10.0.0 (UnicodeData.txt and
	  EastAsianWidth.txt)

2017-06-21  Araki Ken  <arakiken@users.sf.net>

	* vt_edit.c: vt_edit_save_protected_chars() is optimized.

2017-06-21  Araki Ken  <arakiken@users.sf.net>

	* vt_screen.[ch], vt_term_manager.c, vt_parser.c:
	  - vt_write_content_area_t is added.
	  - 'area' is added to the argument of vt_screen_write_content(), and
	    beg and end are removed.

2017-06-21  Araki Ken  <arakiken@users.sf.net>

	* ui_screen.c: UPDATE_SCREEN_BLINK is added to blink screen.

	* ui_draw_str.c: {fc|xcore}_draw_str() checks if fg_color == bg_color
	  instead of vt_char_is_visible().

	* vt_parser.[ch]:
	  - get_now_suffix() is added and a file name of logging vt sequence and
	    snapshot has "-YYYYMMDDHHMM" suffix.
	  - is_protected is added to vt_parser_t, then DECSCA and selective erase
	    are supported.
	  - beg and end (row) are added to the arguments of snapshot(), then
	    MC and DECMC are supported with the use of snapshot().
	  - is_invisible is added to vt_parser_t, then SGR 8 and 28 are supported.

	* vt_screen.[ch]:
	  - is_protected is added to the arguments of vt_screen_fill_area().
	  - is_protected is added to the arguments of vt_screen_combine_with_prev_char().
	  - visible is removed from the arguments of vt_screen_blink().
	  - beg and end (row) are added to the arguments of vt_screen_write_content().

	* vt_edit.[ch]:
	  - vt_edit_{save|restore}_protected_chars() are added.
	  - vt_edit_change_attr_area() processes SGR 3, 6, 9, 21, 23, 29.

	* vt_char.[ch]:
	  - is_visible is removed and is_protected is added to vt_char_t::attr.
	  - is_protected is added to the arguments of vt_char_set() and vt_char_combine().
	  - vt_char_{set|is}_visible() are removed.
	  - vt_set_blink_chars_visible() is added.
	  - vt_char_get_unicode_area_font() is renamed to vt_get_unicode_area_font().
	  - italic and crossed_out are added to the arguments of vt_char_change_attr()
	    and vt_char_reverse_attr().

2017-06-18  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c: Whether ps[0] < VTMODE(0) is checked in processing DECRQMH.

2017-06-18  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c: CSI?40h resizes screen as the value of DECCOLM.

2017-06-17  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.[ch]:
	  - DECATC is supported.
	  - DECRQM and DECRQMH are supported and {set|get}_vtmode() functions and
	    vtmode_t enum and so on are added.
	  - SGR of DECRQSS is supported.

	* vt_logical_visual.c:
	  'count == 0' => 'count = 0' in vt_logical_visual_cursor_is_rtl().

	* vt_screen.h:
	  - vt_screen_is_using_bce() and vt_screen_is_using_rect_attr_select() are added.
	  - vt_screen_set_use_bce() changes setting of vt_screen_t::alt_edit
	    instead of vt_screen_::normal_edit.

	* vt_edit.h:
	  vt_edit_is_using_bce() and vt_edit_is_using_rect_attr_select() are added.

2017-06-14  Araki Ken  <arakiken@users.sf.net>

	* xlib/ui_font.c: Fixes for DECDHL.

	* console/ui_window.c: size_attr is added to the arguments of set_attr()
	  to support DECDHL and DECDWL.

	* console/ui_font.c: Unnecessary code is removed.

2017-06-12  Araki Ken  <arakiken@users.sf.net>

	* c_regis.c: Hack for MSYS is added.

	* ui_font.h, win32/ui.h, win32/ui_font.c:
	  'size' is moved from ui_font_t to XFontStruct on win32.

	* configure.in, baselib/configure.in: Whether it is msys-2.0 or not is checked.

2017-06-11  Araki Ken  <arakiken@users.sf.net>

	* README.win32: Updated.

	* libptyssh/vt_pty_ssh.c: connect_to_x11() is separated from x11_callback().

	* win32/ui_display.c: CloseHandle(_disp.cursors[count]) is removed.

2017-06-07  Araki Ken  <arakiken@users.sf.net>

	* console/ui.h, win32/ui.h: "#include <mef/ef_conv.h>" is removed.

	* config.sub, config.guess: Updated.

2017-06-05  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_display.c:
	  ui_display_t::selection_owner is set in add_root_to_display().

	* gtk/Makefile.in: @BRLAPI_CFLAGS@ and @BRLAPI_LIBS@ are added.

	* vte.c:
	  - vte_terminal_{set|get}_word_char_exceptions() is fixed.
	  - ui_brltty_{init|final}() are called.

2017-06-04  Araki Ken  <arakiken@users.sf.net>

	* ui_brltty.c: BRLAPI_KEY_CMD_SAY_LINE, BRLAPI_KEY_CMD_SPEAK_CURR_LINE,
	  BRLAPI_KEY_CMD_SAY_ABOVE, BRLAPI_KEY_CMD_SAY_BELOW are supported.

2017-06-04  Araki Ken  <arakiken@users.sf.net>

	* README, README.ja: Updated.

	* doc/en/README.brltty: Added.

	* main_loop.c, ui_screen.c: ui_brltty_* functions are called.

	* ui_brltty.c: Added.

	* configure.in: --enable-brlapi is added.

	* encodefilter/src/Makefile.in: MINOR is changed from 0 to 1.

	* mef.c: "utf32le" is added.

	* wayland/ui_display.c:
	  - focus_gtk_window() is called in pointer_button().
	  - "xterm" style cursor is loaded in ui_display_init_wlserv().

	* vte_wayland.c: focus_gtk_window() is added.

	* ui_screen_manager.c: DISPLAY environmental variable is set on wayland.

	* ef_utf32_conv.[ch]:
	  ef_utf32le_conv_new() and ef_utf32_use_bom() are added.

2017-05-28  Araki Ken  <arakiken@users.sf.net>

	* ef_ucs_property.table: Updated to Unicode 9.0.0 (UnicodeData.txt and
	  EastAsianWidth.txt)

2017-05-26  Araki Ken  <arakiken@users.sf.net>

	* README, README.ja, man/mlterm.1: Updated.

	* im_iiimf_aux.c:
	  - The default value of AUX_BASE_DIR macro is changed from "/usr/lib/im"
	    to "/usr/lib/iiim/le".
	  - HTT_AUX_BASE_DIR environmental variable is added.

	* im_iiimf.c:
	  - HTT_DISABLE_STATUS_WINDOW environmental variable is renamed to
	    HTT_SHOW_STATUS_WINDOW.
	  - IIIMCF_ATTR_CLIENT_X_DISPLAY_NAME is set on xlib.

	* im_iiimf.h: aux_* functions are disabled on platforms except xlib.

	* iiimf/Makefile.in: im_iiimf_aux.c is compiled on xlib alone.

2017-05-23  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c:
	  - SGR 39 and 49 works if use_ansi_colors is false.
	  - Unnecessary debug_print_unknown() is removed.

	* fb/ui_window.c:
	  Freetype specific code is enclused by #if defined(USE_FREETYPE) ... #endif.

	* android/jni/ui_display.h: IM_WINDOW_IS_ACTIVATED() is added.

2017-05-21  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c: "ESC 2"(DECCAHT), "ESC 1"(DECCHTS), "ESC I"(HTJ),
	  "CSI ? Pi;Pa;Pv S", "CSI Ps1;Ps2;Ps3 ,l"(DECAC) and "CSI W"(CBC)
	  are implemented.

	* vt_edit.c: The starting position of erase_area() is fixed in
	  vt_edit_scroll_{right|left}ward_from_cursor().

	* ui_screen.c: baseline_offset option is disabled on console.

	* fb/ui_display.c:
	  Busy loop where mlterm-fb on inactive console falls is fixed.

	* mlterm-con.c: mlterm-con works on Solaris11.

	* iiimf/keymap.c: keysyms which are undefined on framebuffer are enclosed
	  by #ifdef ... #endif.

	* vte.c: OPEN_SCREEN, OPEN_PTY, NEXT_PTY, PREV_PTY, HSPLIT_SCREEN,
	  VSPLIT_SCREEN, NEXT_SCREEN, CLOSE_SCREEN, HEXPAND_SCREEN,
	  VEXPAND_SCREEN shortcut keys are disabled on libvte compatible library.

	* android/jni/ui.h: FORCE_UNICODE is undefined.

2017-05-18  Araki Ken  <arakiken@users.sf.net>

	* README.ja, man/mlterm.1: Updated.

	* ui_main_config.c: "baseline_offset" / --blpos option is added.

	* ui_screen.[ch]:
	  - "baseline_offset" is added to OSC 5379 etc.
	  - baseline_offset is added to arguments of ui_screen_new().

	* ui_window.c: Chars except unicode are converted to unicode for freetype.

	* fb/ui_font.c: TrueType fonts are loaded for charsets except Unicode.

2017-05-17  Araki Ken  <arakiken@users.sf.net>

	* ui_screen.c: draw_cursor() selects appropriate position of cursor bar
	  according to rtl or ltr attribute of a cursor character.

	* vt_term.h: vt_term_cursor_is_rtl() is added.

	* vt_screen.h: vt_screen_cursor_is_rtl() is added.

	* vt_logical_visual.[ch]:
	  - If meet_pos_info & 0x8000000 is true, ctl_logical() forces a cursor
	    character to be redrawn.
	  - vt_logical_visual_cursor_is_rtl() is added.

	* vt_line_bidi.[ch], vt_line.[ch]:
	  - vt_line_bidi_convert_logical_char_index_to_visual() doesn't check meeting
	    position of rtl and ltr characters if meet_pos_info is NULL.
	  - if meet_pos_info & 0x8000000 is true, cursor position is really adjusted
	    according to metting position of rtl and ltr characters.

2017-05-14  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c: ESC $ ) is supported on utf8 encoding.

	* ef_iso2022kr_conv.c: iso2022_conv.g1 = KSC5601_1987 is added.

	* ef_iso2022jp_conv.c: iso2022_conv->g0 is replaced by ch.cs after convertion
	  correctly finishes.

	* mef.c: "isciiroman" encoding is removed.

2017-05-14  Araki Ken  <arakiken@users.sf.net>

	* vt_pty_ssh.c: WSASocket() is called with WSA_FLAG_OVERLAPPED in _socketpair().

2017-05-08  Araki Ken  <arakiken@users.sf.net>

	* ui_screen_manager.c, MLTermPty.c, vte.c:
	  Calling vt_create_term() and ui_screen_new() is fixed.

	* ui_screen.[ch]:
	  - blink_cursor is removed.
	  - Underline cursor and bar cursor are supported.

	* vt_term.[ch]: vt_term_is_visible_cursor() and vt_term_get_cursor_style() are added.

	* vt_parser.[ch]:
	  - vt_cursor_style_t is added and DECSCUSR(3,4,5,6) is supported.
	  - is_visible_cursor is moved from vt_screen.
	  - vt_parser_is_visible_cursor() and vt_parser_get_cursor_style() are added.
	  - Processing "blink_cursor" of OSC 5379-5383 is moved from ui_screen.c

2017-05-07  Araki Ken  <arakiken@users.sf.net>

	* vt_parser.c: The response to DECRQDE is fixed.

	* uitoolkit/Makefile.in: Error in compiling winrs.rs is fixed.

2017-05-07  Araki Ken  <arakiken@users.sf.net>

	* keymap.c: XK_Kakji, XK_Muhenkan, XK_Henkan, XK_Hiragana, XK_Katakana and
	  XK_Zenkaku_Hankaku are processed.

	* im_iimf.c: create_handle() searches unix domain socket files in /tmp/.iiim-$USER/.

	* vt_parser.c:
	  - DECRQDE (CSI " v), NP(CSI U), PP(CSI V), PPA(CSI SP P), PPR(CSI SP Q) and
	    PPB(CSI SP R) are processed.
	  - DECCRA and DECLRP supports page.

	* ui_picture.c: cleanup_inline_pictures() checks term->screen->page_edits.

	* vt_screen.[ch]:
	  - 'page_edits' is added to vt_screen_t.
	  - vt_screen_is_alternative_edit() is changed from function to macro.
	  - src_page and dst_page arguments are added to vt_screen_copy_area().
	  - vt_screen_get_page_id(), vt_screen_goto_page(), vt_screen_goto_next_page()
	    and vt_screen_goto_prev_page() are added.

2017-05-05  Araki Ken  <arakiken@users.sf.net>

	* console/ui_font.c, ui_screen.c: line_space and letter_space options are ignored.

	* console/ui_window.c, fb/ui_window.c: ui_window_is_scrollable() returns 0
	  if IM_WINDOW_IS_ACTIVATED() (not IS_IM_WINDOW()) is true.

	* console/ui_display.[ch], fb/ui_display.[ch]:
	  IM_WINDOW_IS_ACTIVATED() macro is added.

	* main/main-con.c, console/ui_display.c: If termios.c_cc[VERASE] is 0x7f,
	  0x7f character from stdin is converted to 0x08.

	* main/Makefile.in: LIBS2_{fb|console|wayland} variables are fixed.

	* iiimf/keymap.c, im_iiimf.h, im_iiimf_aux.c: Platforms except x11 are supported.

	* im_iiimf.c:
	  - The timing of calling status_change() or stat_screen->delete() is fixed.
	  - IIIMF_SERVER_ADDRESS environmental variable => HTT_SERVER_ADDRESS.

	* iiimf/Makefile.in: TARGET_{xlib|fb|console|wayland} are added.

2017-05-04  Araki Ken  <arakiken@users.sf.net>

	* quartz/ui_window.c, quartz/ui_font.[ch], quartz/ui.h, cocoa.m:
	  ui_font_t::cg_font is moved to XFontStruct.

	* win32/ui_window.c, win32/ui_font.[ch], win32/ui.h, ui_font_cache.c:
	  ui_font_t::fid and ui_font_t::conv are moved to XFontStruct.

	* xlib/ui_xim.c: Minor fixes.

	* xlib/ui_xic.c: XNArea is removed from XVaCreateNestedList().

	* inputmethod/im_iimf.c:
	  - IIIMF_ATTR_SERVER_ADDRESS and IIIMF_ATTR_SERVER_SERVICE attributes are set.
	  - The value of IIIMF_SERVER_ADDRESS environmental variable replaces
	    IIIMF_ATTR_SERVER_ADDRESS attribute.
	  - status_change() is called in lookup_choice_done() and
	    in IIIMCF_EVENT_TYPE_TRIGGER_NOTIFY case in dispatch().

	* inputmethod/iiimf: Revived.

	* configure.in: --disable-iiimf option is added.

	* version.h: 3.8.1 -> 3.8.1post

2017-04-29  Araki Ken  <arakiken@users.sf.net>

	* 3.8.1 released.
	  (tag "rel-3_8_1")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.8.1.

	* PROTOCOL, man/mlterm.1: Updated.

	* vte.c: screen->window.width and screen->window.height are updated even
	  if VteTerminal is not realized.

	* wayland/ui_display.c: ui_display_move() stores x and y in display->{x,y}
	  only if display->buffer is non-NULL.

2017-04-28  Araki Ken  <arakiken@users.sf.net>

	* README, gtk/README: Updated.

	* vte_wayland.c, vte.c:
	  - vte_terminal_map() is added and registered to GTK_WIDGET_CLASS(vclass)->map.
	  - ui_display_map() etc are removed from vte_terminal_focus_in().

	* wayland/ui_color.c: The value of x_color_t::{red|green|blue} is not
	  multiplied by alpha on wayland.

	* {wayland,fb}/ui_window.c, console/ui_window.c: Initialization of
	  child->inputtable and child->is_focused in ui_window_add_child() is fixed.

	* wayland/ui_display.[ch]:
	  - search_focused_window() searches windows in turn from children.
	  - FocusOut macro is defined and ui_window_receive_event(FocusOut) instead
	    of win->window_unfocused() is called in keyboard_leave().
	  - wl_subsurface_set_desync() is called in ui_display_map(), and
	    wl_subsurface_set_sync() is called in ui_display_unmap().

	* ui_color_cache.c:
	  color_caches[count]->is_loaded => color_caches[count]->cache_256ext->is_loaded
	  (This causes segmentation fault in using many colors by SGR 38;2;r;g;b
	  or 48;2;r;g;b sequence)

2017-04-25  Araki Ken  <arakiken@users.sf.net>

	* README.ja, man/mlterm.1, PROTOCOL: Updated.

2017-04-24  Araki Ken  <arakiken@users.sf.net>

	* vt_pty_ssh.c: zombie() removes a zombie channel from ssh_session_t.

2017-04-24  Araki Ken  <arakiken@users.sf.net>

	* vte.c: gtk_m_adjustment_value_changed() => gtk_adjustment_value_changed().

	* ui_font_ft.c: Double free problem by FcPatternDestroy() is fixed.

2017-04-23  Araki Ken  <arakiken@users.sf.net>

	* fb/ui_window.c: A bug which disabled ui_window_move() to move root windows
	  is fixed.

	* fb/ui.h: Compiling error is fixed.

	* wayland/ui_display.c: The return value of ui_display_move is changed from
	  void to int.

2017-04-23  Araki Ken  <arakiken@users.sf.net>

	* main_loop.c: Minor fixes.

	* fb/ui_font.c: Compiling error is fixed.

2017-04-23  Araki Ken  <arakiken@users.sf.net>

	* ui_window.c:
	  draw_string() is separated to draw_string() and draw_string_intern()
	  in order to show complementary glyphs.

	* ui.h, ui_font.h, ui_font.c:
	  ui_get_bitmap() returns a complementary glyph in an alternative font
	  if no glyph is found in a specified xfont.

	* main_loop.c, ui_font_config.c:
	  ui_costomize_font_file() works if --aafont option is specified on framebuffer or
	  wayland.

2017-04-16  Araki Ken  <arakiken@users.sf.net>

	* README, README.ja: Updated.

	* fb/ui_window.c: ui_window_move() does nothing for root windows except on wayland.

	* vte.c, vte_wayland.c:
	  - toplevel_configure and hierachy_changed handlers are removed on wayland.
	  - ui_display_map() is called from vte_terminal_focus_in() instead of
	    vte_terminal_map() on wayland.
	  - Focus and unfocus hacks are removed on wayland.
	  - Dummy api functions related to VteRegex (0.46 or later) are added.

	* wayland/ui.h, wayland/ui_display.c:
	  wl_subsurface instead of wl_shell_surface is used for libvte compatible library.

	* android/jni/ui.h: COMPOSE_DECSP_FONT is defined.

2017-03-28  Araki Ken  <arakiken@users.sf.net>

	* ui_display_linux.c:
	  - 10 or larger number is availabe for event device (/dev/input/event*%d*) number.
	  - "ts" is removed from mouse name list.

	* fb/ui_font.c, fb/ui_decsp_font.c: "decsp-%dx%d" of a composed decsp font is
	  created in ui_font_new() instead of ui_load_decsp_xfont().

	* */ui.h: COMPOSE_DECSP_FONT is added.

2017-03-25  Araki Ken  <arakiken@users.sf.net>

	* {wayland,fb}/ui_window.c: convert_to_decsp_font_index() is added.

	* {wayland,fb}/ui_font.c:
	  - ui_compose_dec_special_font() is implemented.
	  - If compose_dec_special_font is true, ui_load_decsp_xfont() is called.

	* {wayland,fb}/ui_decsp_font.[ch]: Added.

	* gtk/vte.c: If ui_wlserv_t::current_kbd_surface is Display::surface or
	  Display::parent_surface, win->window_unfocused is forcibly called in
	  vte_terminal_focus_out() on wayland.

	* wayland/ui.h, wayland/ui_display.c:
	  Display::current_surface => current_kbd_surface.

	* console/ui_display.c: vt_char_encoding_conv_set_use_loose_rule(1) is called
	  for disp->display->conv.

	* console/ui_connect_dialog.c: USE_COSNOLE => USE_CONSOLE

	* console/ui_window.[ch], ui_draw_str.c:
	  ui_window_console_drwa_decsp_string() is added.

	* ui_screen.c:
	  utf16le_illegal_char() which converts DEC Special to Unicode is added.

	* vt_char_encoding.[ch]:
	  - vt_convert_ucs_to_decsp() and vt_convert_decsp_to_ucs() are moved
	    from vt_parser.c
	  - utf8_illegal_char which converts DEC Special to Unicode is added.
	  - iso2022_illegal_char and non_iso2022_illegal_char aren't used by default
	    and vt_char_encoding_conv_set_use_loose_rule() enables them.

2017-03-21  Araki Ken  <arakiken@users.sf.net>

	* doc/{en,ja}/README.fb: Updated.

	* ui_screen.c:
	  draw_preedit_str() can have drawn cursor vertical line outside screen.

	* wayland/ui_font.c: ui_font_set_dpi_for_fc() is implemented.

	* gtk/Makefile.in: ui_display.o is rebuilt every time with -DCOMPAT_LIBVTE option.

	* wayland/ui_display.c: Functions for libvte compatible library are added.

	* gtk/vte.c:
	  - wayland is supported.
	  - vte.c is separated to vte.c, vte_xlib.c and vte_wayland.c.

2017-03-07  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_connect_dialog.c: Server name is shown before "Password:".

2017-03-07  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_connect_dialog.c:
	  - ui_window_draw_image_string() is called every time.
	  - ui_display_receive_next_event_singly() is called on wayland.

	* wayland/ui_display.[ch]: ui_display_receive_next_event_singly() is added.

	* main_loop.c: 'mlterm -v' outputs compiled features.

	* main/Makefile.in: CFLAGS_FOR_FEATURES is added.

	* configure.in: "Supported font formats" is output on wayland.

	* Makefile.in: 'install-wl' target is added.

2017-03-06  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_display.c: check_resize() returns 0 if the difference between
	  specified width and height and current width and height is less than
	  width_inc and height_inc.

	* doc/en/README.wayland: Added.

	* doc/en/README.fb: Updated.

2017-03-05  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_color.c: red, green and blue are multiplied by alpha before
	  RGB_TO_PIXEL() on wayland.

	* wayland/ui_window.c: minor fixes.

2017-03-05  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_display.c:
	  - Pointer at the center of top and bottom margin enables you to move
	    the window instead of pressing Alt+Button1.
	  - 'check_inc' argument (which is Display::is_resizing) is added to
	    check_resize().

	* ui_layout.c:
	  - Rounding up 'separator' is prohibited if
	    'total < separator + margin + next_win' in modify_separator().
	  - MANAGE_SUB_WINDOWS_BY_MYSELF => MANAGE_ROOT_WINDOWS_BY_MYSELF
	    in change_sb_mode_intern().

	* ui_window.c: check_update_children() is added to redraw screen correctly
	  on wayland.

	* */ui.h, ui_layout.c, wayland/ui_window.c: NO_EXPOSE_ON_RESIZE is removed.

2017-03-05  Araki Ken  <arakiken@users.sf.net>

	* ui_screen.c: ui_window_update_all(ui_screen_t) instead of
	  ui_window_update_all(ui_layout_t) is called in window_resized().

	* ui_main_config.c: ONLY_USE_UNICODE_FONT and ONLY_USE_UNICODE_BOXDRAW_FONT
	  are set if ui_is_using_aafont() is true.

	* ui_layout.c: Even if a child window is not resized by resizing its parent,
	  ui_window_update_all() is called in reset_layout on wayland.

	* wayland/ui_window.c: ui_window_update_all() is called at the end of
	  ui_window_show() on wayland. Without this, screen isn't drawn in startup.

2017-03-05  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_display.c:
	  ui_display_resize() calls wl_display_roundtrip() internally.

	* wayland/ui_window.c: ui_window_set_normal_hints() is implemented.

2017-03-05  Araki Ken  <arakiken@users.sf.net>

	* mc_im.c: get_im_info() is fixed.

	* ui_screen.c:
	  - "use_aafont" is added to OSC 5380/5381.
	  - ui_window_update_all(ui_layout_t) instead of ui_window_update_all(ui_screen_t)
	    is called in window_resized().

	* ui_font_config.[ch]: ui_is_using_aafont() is added.

	* mc_font.c: get_font_file() returns "*aafont" if use_aafont option is true.

	* wayland/ui_display.c: Minor fixes.

2017-03-04  Araki Ken  <arakiken@users.sf.net>

	* ui.h, ui_display.c:
	  - During wl_shell_surface_resize(), Display::is_resizing is 1.
	    This forces shell_surface_configure() not to modify specified width and height,
	    and permits miximizing windows.
	  - ui_display_receive_next_events() calls wl_display_dispatch() once per
	    wl_display.

	* ui_main_config.c: The default value of "input_method" option is "ibus"
	  on wayland.

	* ui_layout.c: x_window_resize_with_margin(scrollbar) is called before
	  x_window_resize_with_margin(screen) in reset_layout().

2017-03-04  Araki Ken  <arakiken@users.sf.net>

	* quartz/ui_window.c:
	  - view_update() is called in ui_window_set_wall_picture() in order to
	    update screen in changing a wall picture.
	  - ui_window_draw_*_image_string() are removed.

	* fb/connect_dialog.c:
	  - ui_window_get_str() is called in key_pressed().
	  - ui_window_console_draw_string() is called on console.

	* configure.in, inputmethod/*/Makefile.in:
	  - {POBL|MEF}_LIBS_FOR_MODULE are replaced by LPOBL and LMEF

	* console/ui_window.c:
	  - XK_BackSpace, XK_Tab and XK_Returns key events are correctly processed.
	  - ui_window_draw_*_string() functions are removed.

	* main-con.c:
	  - termios is reverted to the default value on exit().
	  - Whether read() returns -1 is not checked.

	* */ui.h, ui_draw_str.c, ui_picture.c:
	  - DRAW_SCREEN_IN_PIXELS, NO_DRAW_IMAGE_STRING are added
	  - HAVE_PTHREAD is defiend or undefined in ui.h instead of ui_picture.c.

	* ui_screen_manager.c: 'mlclient' is disabled on console, while 'mlclientx'
	  is still available.

	* console/ui_connect_dialog.h: Added.

2017-03-03  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_display.c: Whether disp is NULL or not is checked in
	  receive_key_event() which may be called after the surface is destroyed.

	* ui_font_manager.c: If US-ASCII font is not found, font loading is retried
	  after calling ui_use_aafont().

	* ui_font_config.[ch]: ui_use_aafont() is added.

	* fb/ui_font.[ch]: ui_font_use_fontconfig() is added.

	* mc_im.c: get_im_info() searches libim-foo-fb.so on framebuffer or console and
	  libim-foo-wl.so on wayland.

	* mc_font.c, mc_io.[ch]: mc_gui_is_win32() is replaced by mc_get_gui().

	* main_loop.c: --aafont / use_aafont option is added.

	* skk/dict.c, im_skk.c, ef_str_parser.c: The dependency on libmef library is removed.

	* configure.in: --enable-fontconfig option is enabled by default.

2017-02-28  Araki Ken  <arakiken@users.sf.net>

	* README.ja, README.fb: Updated.

	* wayland/ui_display.c:
	  - ui_display_rotate() and ui_display_logical_to_physical_coordinates() are added.
	  - wl_display_roundtrip() is called in auto_repeat().

	* */ui.h:
	  - XIM and XIMStyle are removed.
	  - MANAGE_WINDOWS_BY_MYSELF => MANAGE_{ROOT|SUB}_WINDOWS_BY_MYSELF
	  - NO_EXPOSE_ON_RESIZE, USE_GC, CHANGEABLE_CURSOR, PLUGIN_MODULE_SUFFIX,
	    KEY_REPEAT_BY_MYSELF, ROTATABLE_DISPLAY, PSEUDO_COLOR_DISPLAY,
	    WALL_PICTURE_SIXEL_REPLACES_SYSTEM_PALETTE, SUPPORT_URGENT_BELL,
	    FORCE_UNICODE, NEED_DISPLAY_SYNC_EVERY_TIME are added.

	* main_loop.c, ui_display_wscons.c: wskbd_repeat_{1|N} => kbd_repeat_{1|N}

	* configure.in: --enable-fontconfig option is disabled by default.

2017-02-25  Araki Ken  <arakiken@users.sf.net>

	* */ui_display.c:
	  The default value of ui_display_t::name is as follows.
	  - DisplayString() on xlib
	  - getenv("DISPLAY") or ":0.0" on other platforms.

2017-02-25  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui_display.c:
	  - Wheel mouse is supported.
	  - Control+Button3 etc work.

	* ui_screen.c: NULL is passed to vt_term_start_config_menu() on wayland.

	* {console,fb,win32,cocoa}/ui_display.c: ui_display_t::name has always
	  non-null value.

	* */ui.h: DisplayString() macro is removed.

2017-02-24  Araki Ken  <arakiken@users.sf.net>

	* ui_screen_manager.c, vte.c: main_config.underline_offset is added
	  to arguments of ui_screen_new().

	* ui_draw_str.[ch]:
	  - bottom_margin is removed.
	  - underline_offset is added.

	* ui_screen.[ch]:
	  - ui_line_top_margin() -> line_top_margin()
	  - ui_line_bottom_margin() is removed.
	  - check_line_space() => modify_line_space_and_underline_offset().
	  - "underline_offset" is added to OSC 5379 etc.

	* ui_main_config.[ch]: --ulpos/underline_offset option is added.

2017-02-24  Araki Ken  <arakiken@users.sf.net>

	* README.ja, mlterm.1: Updated.

	* ui_screen.[ch], ui_main_config.[ch]: The type of line_space is changed from
	  u_int8_t to int8_t.

2017-02-23  Araki Ken  <arakiken@users.sf.net>

	* console/ui_window.c: ui_window_{xct|utf}_selection_request() and
	  ui_window_send_text_selection() are implemented.

	* console/ui_display.c:
	  ui_display_{own|clear}_selection() enables copy&paste between
	  different displays.

	* console/ui.h: XSelectionRequestEvent is defined as a structure.

	* fb/ui_window.c: ADDITIONAL_ARG is removed.

	* fb/ui_display.[ch], android/jni/ui_display.[ch], wayland/ui_display.[ch]:
	  'ui_display_t *disp' argument is added to ui_display_get_pixel(),
	  ui_display_put_image() and ui_display_copy_lines().

2017-02-20  Araki Ken  <arakiken@users.sf.net>

	* quartz/ui_window.c: If ui_window_is_selection_owner() is true,
	  ui_window_set_selection_owner() does nothing.

	* fb/ui_window.c:
	  - ui_display_clear_selection() is called in ui_window_final().
	  - ui_display_own_selection() is called in ui_window_set_selection_owner().
	  - ui_window_{utf|xct}_selection_request() works on framebuffer.

	* fb/ui.h: XSelectionRequestEvent is defined as a structure.

	* console/ui_window.c:
	  - ui_display_clear_selection() is called in ui_window_final().
	  - ui_display_own_selection() is called in ui_window_set_selection_owner().

	* android/jni/ui_display.c, console/ui_display.c, fb/ui_display.c:
	  ui_display_own_selection() and ui_display_clear_selection() are implemented.

	* ui_window.h, ui_screen.c:
	  - is_sel_owner is removed from ui_window_t on platforms except win32.
	  - ui_window_is_selection_owner() is added.

2017-02-19  Araki Ken  <arakiken@users.sf.net>

	* *.[ch], *.[ch].in: 'type* var' => 'type *var'

2017-02-19  Araki Ken  <arakiken@users.sf.net>

	* wayland/ui.h, wayland/ui_display.c: DnD and Copy&Paste are supported.

	* ui_screen_manager.c: WAYLAND_DISPLAY environmental variable is set
	  on wayland.

	* ui_screen.c: ui_window_update_all() is called instead of ui_window_update()
	  in window_resized() on wayland because expose event is not delivered in
	  resizing a window.

	* ui_im_{status|candidate}_screen.c: adjust_window_position_by_size() is
	  disabled on wayland.

	* ui_event_source.c: additional_fds.handler() is called after ui_display_idling()
	  because input method additional handler may destroy ui_display.

	* wayland/ui_window.c:
	  - Wrong clipped area in draw_string() is fixed.
	  - Stuff for wayland.

	* ui_imagelib.c: waitpid() is called to wait for child process to die because
	  vt_pty_unix_new() may block without this.

	* ui_font_config.c: If USE_FONTCONFIG and USE_FREETYPE is enabled on wayland,
	  "mlterm/*aafont" files are used.

	* ui_font.c: fontconfig is supported.

	* im_ibus.c, im_fcitx.c:
	  - wayland is supported.
	  - USE_IM_CANDIDATE_SCREEN macro is added.

	* ui_im.c: libim-xxx-wl.so is loaded on wayland.

	* inputmethod/*/Makefile.in:
	  TARGET_wayland = libim-xxx-wl.la is added.

	* configure.in:
	  - anti-alias is enabled by default.
	  - --disable-fontconfig is added.

2017-02-06  Araki Ken  <arakiken@users.sf.net>

	* configure.in, mlterm-menu/Makefile.in, main/Makefile.in, tool/mlconfig/Makefile.in
	  tool/mlimgloader/Makefile.in, uitoolkit/Makefile.in, fb/ui_window.c,
	  ui.h, ui_display.h, ui_draw_str.c, ui_event_source.c, ui_font_config.c,
	  ui_gc.h, ui_im.c, ui_main_config.c, ui_sb_view_factory.c, ui_window.h, wayland/*:
	  Initial wayland support is added.

	* fb/ui_font.c:
	  USE_FREETYPE macro check is added to ui_font_has_ot_layout_table().

2017-02-05  Araki Ken  <arakiken@users.sf.net>

	* ui_event_source.c: 'break' in checking FD_ISSET(additional_fds) is removed.

2017-02-05  Araki Ken  <arakiken@users.sf.net>

	* android/jni/ui_display.c: rotate_display flag and related code are removed.

2017-02-05  Araki Ken  <arakiken@users.sf.net>

	* android/jni/ui_display.c: Minor fixes.

	* version.h.in: 3.8.0 -> 3.8.0post

2017-01-07  Araki Ken  <arakiken@users.sf.net>

	* 3.8.0 released.
	  (tag "rel-3_8_0")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.8.0.

	* README, gtk/README: Updated.

	* libptyssh/vt_pty_ssh.c: zombie() calls vt_write_to_pty() instead lo_write_to_pty().

	* MLTerm.java: display.isDisposed() is checked just before display.wake()
	  in startPtyWatcher().

2017-01-07  Araki Ken  <arakiken@users.sf.net>

	* libptyssh/vt_pty_ssh.c: bl_trigger_sig_child() is called if vt_pty_ssh_t::is_eof
	  is true in lo_send_to_pty() instead of lo_write_to_pty().

2017-01-03  Araki Ken  <arakiken@users.sf.net>

	* bl_pty_{bsd|streams}.c: termios.c_cc[VSTATUS] = CSTATUS.

2016-12-30  Araki Ken  <arakiken@users.sf.net>

	* ui_screen_manager.c: main_config.disp_name is passed to open_screen_intern() in
	  mlclient().

2016-12-29  Araki Ken  <arakiken@users.sf.net>

	* android/jni/ui_event_source.c:
	  - Java_mlterm_native_1activity_MLActivity_{pause|resume}Native() which call
	    ui_window_set_mapped_flag() are added.
	  - ui_window_set_mapped_flag() are removed in
	    Java_mlterm_native_1activity_MLPreferenceActivity_set{DefaultFontConfig|Config}().

	* MLActivity.java:
	  onResume() calls resumeNative(), and onPause() calls pauseNative().

	* android/jni/ui_display.c:
	  - get_jni_env() is added.
	  - AttachCurrentThread()/DetachCurrentThread() is replaced by get_jni_env().
	  - if a specified window is not mapped, ui_window_set_mapped_flag(1) does nothing.

	* android/jni/ui_xic.c:
	  AttachCurrentThread()/DetachCurrentThread() is replaced by GetEnv().

	* ui_window.h:
	  - saved_mapped is added to ui_window_t on Android.
	  - xft_draw and cairo_draw are added to ui_window_t on xlib.

	* android/jni/main.c: android_main() calls AttachCurrentThread()/DetachCurrentThread().

	* MLPreferenceActivity.java: 'private' is added to native methods.

2016-12-25  Araki Ken  <arakiken@users.sf.net>

	* xlib/ui_window.c:
	  - ensure_input_focus() which calls XSetInputFocus() with a window whose
	    'inputtable' is greater than 0 is added.
	  - ensure_input_focus() is called if a root window receives FocusIn event.

	* ui_font_ft.c: charset_cache is allocated dynamically.

	* vte.c, ui_screen_manager.c, cocoa.m: bl_dl_close_all() which frees leaked memory
	  is called after bl_mem_free_all().

2016-12-25  Araki Ken  <arakiken@users.sf.net>

	* jni/ui_event_source.c:
	  - "mlclient --serv=" is allocated on stack in
	     Java_mlterm_native_1activity_MLActivity_execCommand()
	  - Java_mlterm_native_1activity_MLPreferenceActivity_setConfig() changes
	    start_with_local_pty variable, not only saves it to ~/.mlterm/main.

2016-12-24  Araki Ken  <arakiken@users.sf.net>

	* ui_font_ft.c: FcCharSetDestroy(font->compl_fonts[count].charset) is removed.

2016-12-24  Araki Ken  <arakiken@users.sf.net>

	* ui_font_ft.c:
	  - add_charset_to_cache() and get_cached_charset() are added to store FcCharSet.
	  - FcConfigSubstitute() in cairo_compl_font_open() is removed.

	* MLActivity.java:
	  - MENU_OPENPTY_ID => MENU_NEWSCREEN_ID
	  - MENU_LOCALPTY_ID is added.
	  - "Open new pty" => "Open new screen"
	  - "Open local pty" is added to menu.

	* jni/ui_event_source.c: Java_mlterm_native_1activity_MLActivity_execCommand()
	  supports opening local pty by "mlclientx --serv=" by cmd == 1.

2016-12-18  Araki Ken  <arakiken@users.sf.net>

	* ui_screen_manager.c: Uninitialized variables are fixed.

2016-12-13  Araki Ken  <arakiken@users.sf.net>

	* ui_event_source.c: Java_mlterm_native_1activity_MLActivity_execCommand() is added.

	* MLActivity.java:
	  - "Open new pty", "Connect to SSH server", "Split screen vertically",
	    "Split screen horizontally" and "Update screen" are added to context menu.
	  - execCommand() native method is added.

	* vte.c:
	  - Compatibility with vte 0.40.0 or later which dropped VteTerminalPrivate
	    is supported.
	  - vte_terminal_set_color_cursor_foreground() is added.
	  - vte_terminal_set_geometry_hints_for_window() is implemented.

2016-12-11  Araki Ken  <arakiken@users.sf.net>

	* ui_main_config.c, ui_screen_manager.[ch], vt_term.[ch]:
	  ui_set_start_with_local_pty() in ui_screen_manager.c is removed, and
	  vt_term.c has 'start_with_local_pty' global variable.

	* ui_font_ft.c:
	  Whether font->compl_fonts is NULL or not is checked in cairo_calculate_char_width().

	* MLPreferenceActivity.java:
	  "Don't show SSH dialog on startup" checkbox is added.

	* android/jni/ui_event_source.c:
	  - XWINDOW_OF() => UIWINDOW_OF()
	  - ui_window_set_mapped_flag(0) and ui_window_set_mapped_flag(1) are called
	    in Java_mlterm_native_1activity_MLPreferenceActivity_setConfig() and
	    Java_mlterm_native_1activity_MLPreferenceActivity_setDefaultFontConfig().

	* android/jni/ui_display.[ch]:
	  - Long click on scrollbar doesn't invoke context menu.
	  - ui_window_set_mapped_flag() is added.
	  - ui_window_set_mapped_flag(0) is called on APP_CMD_TERM_WINDOW, and
	    ui_window_set_mapped_flag(1) is called on APP_CMD_INIT_WINDOW, and

2016-12-04  Araki Ken  <arakiken@users.sf.net>

	* README.android: Updated.

	* ui_font_config.c: mlcc font FOOBAR "" removes a font setting of FOOBAR
	  specified in ~/.mlterm/*font.

	* main_loop.c, ui_main_config.c: The 6th argument (option explanation) of
	  bl_conf_add_opt() is removed on Android, Cocoa or Win32GDI.

	* vt_pty_intern.h: vt_config_menu_write() sets android_config_response instead
	  of write data to a configuration menu program on Android.

	* ui_event_source.c:
	  - get_current_term() which searches currently focused vt_term is added.
	  - Java_mlterm_native_1activity_MLPreferenceActivity_* are added.
	  - 'android_config_response' global variable is added.

	* ui_display.c: init_window() ignores the difference between
	  lock == -1 and lock == 0.

	* MLActivity.java: "Configuration" is added to context menu.

	* MLPreferenceActivity.java: Added.

	* AndroidManifest.xml: MLPreferenceActivity is added.

2016-11-14  Araki Ken  <arakiken@users.sf.net>

	* README.android: Updated.

	* ui_main_config.c: "start_with_local_pty" / --slp option is added only if
	  USE_LIBSSH2 is defined on Android.

	* ui_screen_manager.[ch]: ui_set_start_with_local_pty() is added.

	* configure.in:
	  - vt_cv_* -> ml_cv_*
	  - -lfreetype is added to OT_LAYOUT_LIBS with -lharfbuzz on cygwin/win32gdi
	    in order to avoid compiling error.

	* MLActivity.java: 'weight' argument is passed to LinearLayout.LayoutParams()
	  in makeTextEntry().

2016-11-12  Araki Ken  <arakiken@users.sf.net>

	* MLActivity.java:
	  - Context menu by long click is supported.
	  - Screen is completely redrawn in onResume().

	* android/jni/ui_event_source.c:
	  Java_mlterm_native_1activity_MLActivity_updateScreen() is added.

	* android/jni/ui_display.c:
	  - process_mouse_event() considers LongClick event.
	  - perform_long_click(), ui_display_update_all() is added.

	* android/jni/ui.h: long_press_counter is added to Display.

2016-11-06  Araki Ken  <arakiken@users.sf.net>

	* Android.mk, android/jni/main.c, android/jni/ui_display.[ch],
	  android/jni/ui_connect_dialog.c, MLActivity.java: libssh2 is supported.

	* ui_screen_manager.c: clean up.

	* vt_pty_ssh.c:
	  If user is NULL, getenv("USER") or getenv("USERNAME") is used to search
	  a matched ssh session.

	* ui_main_config.c: --restart option is invalidated on Android.

2016-10-16  Araki Ken  <arakiken@users.sf.net>

	* *.[chm], *.java: Indentation settings for emacs are added to the head of files.

	* wnn/wnnlib.[ch], gtk/marshal.[ch], gtk/reaper.c, gtk/vtetypebuiltins.c,
	  mlconfig/gtkxlfdsel.[ch]:
	  Format of them is reverted to 3.7.2

2016-10-10  Araki Ken  <arakiken@users.sf.net>

	* uitoolkit/*/ui_window.c: x_window_t::button_released is called if ButtonPress
	  event is received when x_window_t::button_is_pressing is true.

	* mlconfig/main.c: "Snapshot" button is added.

	* tool/mlclient/main.c: Help message is fixed.

	* tool/accessories/gedit.sh: Added.

2016-10-07  Araki Ken  <arakiken@users.sf.net>

	* ui_shortcut.c: Mod2 which is sent by pressing a button when num-lock is on
	  is ignored.

2016-10-02  Araki Ken  <arakiken@users.sf.net>

	* man/mlclient.1: Updated.

	* ui_screen_manager.c:
	  - mlclient() accepts --vsep and --hsep options.
	  - retain_encoding and retain_server arguments are added to open_or_split_screen().

2016-09-27  Araki Ken  <arakiken@users.sf.net>

	* vt_line.c: set_real_modified() is called in vt_line_unuse_ctl() for *_render().

2016-09-24  Araki Ken  <arakiken@users.sf.net>

	* configure.in, vtemu/Makefile.in: libmlterm_core is renamed to libmlterm_coreotl
	  if open type layout is supported.

	* doc/ja/README.ja, man/mlterm.1, etc/main, etc/main.ja: Updated

	* ui_main_config.c: "ssh_auto_reconnect" / --rcn option is added.

	* vt_pty_ssh.[ch], vt_pty.h, vt_pty_ssh.c:
	  - Automatic reconnection to ssh server in unexpected disconnection is supported.
	  - vt_pty_ssh_set_use_auto_reconnect() is added.

2016-09-04  Araki Ken  <arakiken@users.sf.net>

	* ui_layout.c: screen->window.[vh]margin * 2 is added to term->separator_[xy].

2016-09-03  Araki Ken  <arakiken@users.sf.net>

	* ui.h: GUI_TYPE is added.

	* uitoolkit/*/ui.h, ui_screen.c: XIM_SPOT_IS_LINE_TOP is added.

	* vte.c: vte_terminal_event_check_gregex_simple() and vte_get_features()
	  are implemented.

2016-08-29  Araki Ken  <arakiken@users.sf.net>

	* ef_tblfunc_loader.c: The names of dynamically Loaded modules are changed
	  from libef_xxx.so to libmef_xxx.so.

	* ui_event_source.c, ui_picture.c: X_PROTOCOL -> USE_XLIB.

2016-08-29  Araki Ken  <arakiken@users.sf.net>

	* java/.java.policy: Added.

	* xwindow/ -> uitoolkit/
	  kiklib/ -> baselib/
	  mkf/ -> encodefilter/
	  mlterm/ -> vtemu/
	  libkik -> libpobl
	  libmkf -> libmef

	* Google coding style is applied.

2016-08-21  Araki Ken  <arakiken@users.sf.net>

	* ml_pty_ssh.c: Compression of ssh connection is always enabled if libssh2-1.5.0
	  or later is used.

2016-08-18  Araki Ken  <arakiken@users.sf.net>

	* README.cosole, PROTOCOL: Updated.

	* main-con.c: termios is reset on exit.

	* version.h.in: 3.7.2 -> 3.7.2post

2016-08-15  Araki Ken  <arakiken@users.sf.net>

	* 3.7.2 released.
	  (tag "rel-3_7_2")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.7.2.

	* doc/en/README.console: Added.

2016-08-14  Araki Ken  <arakiken@users.sf.net>

	* main_loop.c, x_main_config.c: "mod_meta_prefix" / --metaprefix option
	  is processed in x_main_config.c instead of main_loop.c.

	* x_screen.[ch]: x_free_mod_meta_prefix() is added.

	* vte.c: "word_separators" / --sep and "auto_restart" / --restart options
	  which are processed in x_main_config.c are removed.

	* hb.c: <ftmodapi.h> in win32gdi is changed to <freetype/ftmodapi.h>

	* android/jni/x.h: platform dependent options are added.

2016-08-11  Araki Ken  <arakiken@users.sf.net>

	* README.ja, man/mlterm.1: Updated.

	* x_main_config.c: "primary_da" / --da1 and "secondary_da" / --da2 options
	  are added.

	* ml_vt100_parser.[ch]:
	  - ml_set_{primary|secondary}_da() are added.
	  - DA1 response is changed from CSI?1;2;3;4;7;29c to CSI?63;1;2;3;4;6;29c.
	  - DA2 response is changed from CSI>1;279;0c to CSI>24;279;0c
	  - DECRQSS is partially supported.

	* ml_edit.c: ml_edit_scroll_{up|down}ward() works if cursor position is not
	  within vertical and horizontal margins.

	* mlterm/Makefile.in: Whether $libdir/libmlterm_core.so is built with open type
	  layout option is checked before installing new libmlterm_core.so libraray.

	* main-con.c, console/x_display.c: #ifdef ECHOPRT is added.

	* x_window.c: Cursor is moved within vertical and horizontal margins before
	  SD or SU.

	* configure.in: --with-gui=console works on cygwin.

2016-08-07  Araki Ken  <arakiken@users.sf.net>

	* x_window.h: clip_y and clip_height members of x_window_t are enabled on mlterm-con
	  for input method plugins to work with both mlterm-fb and mlterm-con.

	* x_im_{candidate|status}_screen.c:
	  MARGIN and LINE_SPACE are 0 on mlterm-con.

	* console/x_window.c:
	  - IS_IM_WINDOW() macro is defined.
	  - IS_IM_WINDOW() check is added to x_window_fill_with().

	* fb/x_window.c: IS_IM_WINDOW() macro is defined.

	* console/x.h:
	  - The previous change is reverted for input method plugins to work with both
	    mlterm-fb and mlterm-con.
	  - Values of key symbols on platformes except linux and *bsd are the same as
	    those on freebsd.

	* configure.in: --with-gui=console works on cygwin.

2016-08-06  Araki Ken  <arakiken@users.sf.net>

	* console/x_window.c: If win->disp->width == win->width, x_window_is_scrollable()
	  returns 1 even if win->disp->display->support_hmargin is 0.

	* x_display.h: x_display_set_sixel_colors() is defined as (0) if USE_LIBSIXEL
	  is not defined.

	* console/x_display.c:
	  The default value of Display::support_hmargin is changed from 1 to 0.

	* console/x.h: The values of keyboard symbols are defined as 0xff00-0xffff.

	* main/Makefile.in: mkdir $(LIBEXECDIR)/mlterm instead of $(LIBEXECDIR).

2016-08-06  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c: ModifyOtherKeys on win32 gdi is fixed.

	* console/x.h, console/x_display.c, console/x_window.c:
	  x_window_is_scrollale() is enabled only if the console where mlterm-con works
	  supports DECSLRM and DECLRMM which is checked by DA2 response.

	* ml_vt100_parser.c:
	  - DA2 response is changed from \x1b[>1;277;0c to \x1b[>1;279;0c.
	  - Wrong processing of shift+space in ml_vt100_parser_write_modified_key() is fixed.

2016-07-30  Araki Ken  <arakiken@users.sf.net>

	* console/x_display.c: modifyOtherKeys is enabled by default.

2016-07-29  Araki Ken  <arakiken@users.sf.net>

	* c_imagelib.c, main_loop.c, gdk-pixbuf.c, x_color.h, x_color_cache.c,
	  x_color_manager.c, x_display.h, x_draw_str.c, x_font.h, x_font_cache.c,
	  x_font_cache.h, x_font_config.c, x_font_manager.c, x_font_manager.h,
	  x_im_candidate_screen.c, x_im_status_screen.c, x_imagelib.h, x_layout.c,
	  x_main_config.c, x_picture.h, x_screen.c, x_window.h, xlib/x_imagelib.c:
	  USE_WIN32GUI, USE_QUARTZ, USE_FRAMEBUFFER and USE_CONSOLE are refactored.

	* console/x.h, fb/x.h, quartz/x.h, win32/x.h:
	  Platform dependent options (X_COLOR_HAS_RGB, SUPPORT_TRUE_TRANSPARENT_BG,
	  TYPE_XCORE_SCALABLE, MANAGE_WINDOWS_BY_MYSELF,
	  INLINE_PICTURE_MOVABLE_BETWEEN_DISPLAYS, SUPPORT_POINT_SIZE_FONT) are added.

	* xlib/x.h: Added.

	* x.h: USE_XLIB is defined on xlib.

2016-07-26  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, README.ja, PROTOCOL: Updated.

	* main_loop.c: If no ml_term_t exists, mlterm-con-server exits from the main loop.

	* main/main-con.c:
	  - Moved from tool/mlclient/.
	  - mlterm-con-server is started if unix domain socket of ~/.mlterm/socket-con
	    doesn't work.

	* main/Makefile.in: mlterm-con-server is installed to $(libexec)/mlterm, and
	  mlterm-con is to $(bindir)/mlterm.

	* im_fcitx.c, im_ibus.c, im_m17nlib.c, im_uim.c:
	  USE_FRAMEBUFFER -> USE_FRAMEBUFFER || USE_CONSOLE

	* x_screen.c: "console_encoding" and "console_sixel_colors" are added to OSC 5379.

	* x_main_config.c: --csz/cell_size option is added.

	* x_draw_str.c, x_picture.h: If INLINE_PICTURE_MOVABLE_BETWEEN_DISPLAYS macro
	  is defined, cur_pic->disp == window->disp is not checked.

	* daemon.c:
	  - client_connected() for mlterm-con-server is moved from console/x_display.c
	  - STD{IN|OUT|ERR}_FILENO are closed in daemon_init().

	* console/x_window.c:
	  - x_window_fill_with() do nothing if height or width is less than
	    LINE_HEIGHT or COL_WIDTH,
	  - UTF16 characters are converted to UTF8 in draw_string().
	  - Creating sixel_{output|dither}_t and calling sixel_encode() are moved to
	    x_display.c.

	* console/x_display.[ch]:
	  - x_display_set_default_cell_size() is added.
	  - ShiftMask is set if 'A' - 'Z' character is received.
	  - start_server() and end_server() are removed.
	  - client_connected() is moved to daemon.c.
	  - x_picture_display_closed() is not called in x_display_close().
	  - "x_display_t *  disp" is added to arguments of x_display_set_char_encoding().
	  - x_display_set_sixel_colors() and x_display_output_picture() are added.

	* console/x.h: sixel_output and sixel_dither are added to Display.

2016-07-18  Araki Ken  <arakiken@users.sf.net>

	* x_screen_manager.c: open_screen_intern() uses layout->window.disp instead of
	  calling x_display_open() if layout is not NULL.

	* man/mlterm.1, doc/ja/README.ja, etc/main, etc/main.ja: Updated.

	* x_font_manager.c: The type of returned value of adjust_font_size() is changed
	  from void to int.

	* x_main_config.c: mlterm-con accepts -d option.

	* console/x_display.c:
	  - Server mode via unix domai socket of ~/.mlterm/socket-con is supported.
	  - Multiple displays are managed.

	* mlclient/main-con.c, mlclient/Makefile, mlclient/Makefile.in:
	  mlclient-con is added.

2016-07-09  Araki Ken  <arakiken@users.sf.net>

	* cocoa.m: A patch at http://the.nyarla.net/entry/2016/06/03/195013 is merged.
	  (Wheel mouse is supported.)

	* x_window_cairo.c: x_font_t::x_off is ignored in drawing text with the use
	  of complementary fonts.

	* x_font_ft.c: Loading complementary fonts is moved from x_window_cairo.c to
	  x_font_ft.c, and named as x_search_next_cairo_font().

	* main.c: ml_set_timeout_read_pty(0xffff) on NetBSD or OpenBSD framebuffer.

	* ml_vt100_parser.[ch]:
	  - ml_set_timeout_read_pty() is added.
	  - USE_FRAMEBUFFER macro is removed.
	  - snapshot() is rewritten with the use of ml_screen_write_content().

	* mlterm/Makefile.in: @GUI_CFLAGS@ is removed.

	* ml_term_manager.c: ml_term_write_content() is called in restarting mlterm in segv etc.

	* ml_term.h: ml_term_write_content() is added.

	* ml_screen.[ch]: ml_screen_write_content() is added.

	* inputmethod/*/Makefile.in: TARGET_console is added.

	* configure.in:
	  - "console" is added to --with-gui option.
	  - --disable-skk is revived.

	* x_layout.c: SEPARATOR_WIDTH => SEPARATOR_WIDTH and SEPARATOR_HEIGHT.

	* x_draw_str.c: If USE_CONSOLE is defined, text is drawn by
	  x_window_console_draw_string*().

	* x_window.h, console/x_window.c: x_window_console_draw_string*() which receive
	  a flag to draw underline are added.

	* x_main_config.c: --ckm, console_encoding option is added.

	* x_display.h, console/x_display.c: x_display_set_char_encoding() is added.

	* xwindow/x.h: console/x.h is included if USE_CONSOLE is defined.

	* xwindow/console: Added.

	* version.h.in: 3.7.0 -> 3.7.0post

2016-05-08  Araki Ken  <arakiken@users.sf.net>

	* 3.7.1 released.
	  (tag "rel-3_7_1")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.7.1.

	* man/mlterm.1, doc/en/PROTOCOL: Updated.

2016-05-08  Araki Ken  <arakiken@users.sf.net>

	* im_wnn.c: Shortcut in inserting 'n' is added.

	* im_skk.c: The color of converting text in editing a new word is reversed.

2016-05-07  Araki Ken  <arakiken@users.sf.net>

	* dict.c: "\r\n" is supported.

	* im_skk.c: Shortcut in inserting 'n' is added.

	* quartz/x.h: NSBackTabCharacter is assigned to XK_ISO_Left_Tab.

2016-05-06  Araki Ken  <arakiken@users.sf.net>

	* im_skk.c:
	  - im_skk_t::mode is backed up and restored before and after editing a new word.
	  - Text on a status window is correctly updated.

	* dict.c:
	  - The timing of loading global dictionary is fixed.
	  - Uninitialized variable ('num') is fixed.

2016-05-05  Araki Ken  <arakiken@users.sf.net>

	* im_skk.c, dict.[ch]: Cleanup.

2016-05-05  Araki Ken  <arakiken@users.sf.net>

	* im_skk.c, dict.c:
	  - 'back' argument of dict_completion() is changed to 'step' which designates
	    how many steps to go to a next caption.
	  - dict_completion_reset() -> dict_completion_reset_and_finish().

2016-05-05  Araki Ken  <arakiken@users.sf.net>

	* dict.c: Whether skk server supports "4xxx \n" protocol or not is checked.

	* im_skk.c, dict.c: Completion is supported.

	* ml_vt100_parser.c: vt100_parser->yeild = 0 (specific to framebuffer) at
	  the end of parse_vt100_parser() is removed.

2016-05-04  Araki Ken  <arakiken@users.sf.net>

	* x_im_status_screen.c, win32/x_window.c: Hack for win32gdi is moved from
	  x_im_status_screen.c to win32/x_window.c

	* x_im_status_screen-cocoa.m: Status screen is shown before calling
	  x_im_status_screen_t::show().

2016-05-04  Araki Ken  <arakiken@users.sf.net>

	* im_skk.c:
	  - Direct input triggered by 'l' key is available in editing a word
	    to be newly registerd.
	  - Status window is shown while skk is enabled.
	  - Full width alphabets input triggerd by 'L' is available.
	  - (concat "...") is partially available.
	  - It is possible to register a new word containing '/' and ';'.

	* hb.c: Compiling error is fixed.

	* configure.in: hb-coretext.h is checked on MacOSX/Cocoa.

2016-05-01  Araki Ken  <arakiken@users.sf.net>

	* im_skk.c: Ctrl+g resets preediting states.

2016-05-01  Araki Ken  <arakiken@users.sf.net>

	* im_skk.c: Wrong parsing of comment string staring with ';' is fixed.

	* skk/dict.c: winsock is supported.

	* configure.in: skk is enabled on win32gdi without cygwin.

	* x_window_cairo.c: A bug which dropped almost all glyph complementary fonts
	  is fixed.

2016-05-01  Araki Ken  <arakiken@users.sf.net>

	* quartz/x_im_status_screen-cocoa.m: Added for input method plugin.

	* quartz/x_window.c: x_window_translate_coordinates() is implemented by using
	  window_get_position().

	* cocoa.[hm]:
	  - window_get_position() is added.
	  - NSShiftMask isn't ignored in insertText().
	  - x_display_t::width and x_display_t::height are set in viewDidMoveToWindow.

	* im_skk.c, im_wnn.c: dha dhi dhu dhe and dho are supported.

	* skk/dict.c: input_method option accepts whether skk dictionary or skk server
	  uses utf8 instead of eucjp.
	  (e.g. --im skk:localhost:utf8)

	* wnn/Makefile.in, canna/Makefile.in, skk/Makefile.in: TARGET_quartz is added.

	* configure.in: skk, wnn and canna are available on MacOSX/Cocoa.

	* configure.in, ml_char.c:
	  Fix https://github.com/saitoha/homebrew-sixel/pull/2
	  (Merge https://bitbucket.org/arakiken/mlterm/pull-requests/2/ml_charc-strip-the-dependency-of with some fixes.)

	* README, doc/ja/README.ja: Updated.

2016-04-28  Araki Ken  <arakiken@users.sf.net>

	* skk/dict.[ch], skk/mkf_str_parser.[ch]: Added.

	* im_skk.c: Many bugs are fixed.

2016-04-21  Araki Ken  <arakiken@users.sf.net>

	* im_skk.c: ~/.skk-jisyo is loaded.

	* kik_conf_io.c: Regular files whose names begin with "." in the home directory
	  aren't checked if they should exit in ~/.config/ or not.

2016-04-18  Araki Ken  <arakiken@users.sf.net>

	* inputmethod/skk: Added.

	* im_wnn.c: Minor fixes.

	* x_im_status_screen.c: Incorrect redrawing on win32gdi is fixed.

	* configure.in: skk is enabled by default.

2016-04-10  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c: The change of 1611 commit is reverted.

	* ml_vt100_parser.c: 0.01 sec interval is used for the limit of reading bytes in
	  ml_parse_vt100_sequence() instead of MAX_READ_COUNT.

	* ml_line.c: Fix https://sourceforge.net/p/mlterm/mailman/message/34992704/.

	* man/mlterm.1: U+XXXX-XXXX in ~/.mlterm/*font is documented.

	* kik_pty_{bsd|stream}.c: If B38400 is defined, B38400 is used instead of B9600.

2016-04-03  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1: Updated.

2016-03-23  Araki Ken  <arakiken@users.sf.net>

	* x_im_candidate_screen.c: The number of drawing candidate window is decreased.

	* x_im_status_screen.c: Minor fixes.

	* im_wnn.c:
	  - "[N/N]" is shown after preediting text.
	  - Candidate number is shown in candidate window.
	  - CAND_WINDOW_ROWS(==5) is defined.

2016-03-19  Araki Ken  <arakiken@users.sf.net>

	* registobmp/Makefile.in: Changeset 2562 commit (-lm is removed) is reverted.

	* ml_vt100_parser.c: "vt_color_mode" is added to OSC 5380 and 5381.

	* ml_color.[ch]: ml_get_color_mode() is added.

	* vte.c: Font size specified after font family in the 2nd argument of
	  vte_terminal_set_font_from_string() is applied to "fontsize" option.

	* version.h.in: 3.7.0 -> 3.7.0post

2016-03-13  Araki Ken  <arakiken@users.sf.net>

	* 3.7.0 released.
	  (tag "rel-3_7_0")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.7.0.

	* etc/main, etc/main.ja: Updated.

	* fb/x_color.c, fb/x_display.c: The type of the first argument of
	  x_cmap_get_closest_color() is reverted from u_int to u_long.

2016-03-12  Araki Ken  <arakiken@users.sf.net>

	* mlfc/main.c: 'mlfc -h' shows usage message.

	* MLTerm.java: The size of color palette is changed from 258 to 512.

	* MLTermPty.c: If a previous character is not converted to UTF-16,
	  NULL is passed to the 2nd argument of need_style().

	* ml_color.c: If current value is overwritten by specifying the same
	  value as the default rgb, color_config_set_rgb() erases the current one.

	* x_screen.c: Not only "USASCII" but also "US_ASCII" and "US-ASCII" are
	  available for {set|get}_font_config().

2016-03-11  Araki Ken  <arakiken@users.sf.net>

	* README.ja, man/mlterm.1: Updated.

	* ml_vt100_parser.c, x_main_config.c: "use_approximate_vt_color" is changed
	  to "vt_color_mode"

	* ml_color.c:
	  - 'threshold' is added to arguments of ml_get_closest_256_colors().
	  - ml_set_use_approximate_vt_color() -> ml_set_color_mode()

2016-03-11  Araki Ken  <arakiken@users.sf.net>

	* x_main_config.c: "use_approximate_vt_color" option is added.

	* fb/x_display.c: The performance of x_cmap_get_closest_color() is improved
	  by using ml_get_closest_256_color().

	* ml_color.c:
	  - ml_set_use_approximate_vt_color() is added.
	  - ml_get_closest_256_color() is added.
	  - The performance of ml_get_closest_color() is improved by using
	    ml_get_closest_256_color().

	* ml_vt100_parser.c:
	  - Whether ps is -1 or not is checked before calling ml_get_closest_color().
	  - "use_approximate_vt_color" is added to OSC 5379.

	* c_imagelib.c, fb/x_display.c, ml_color.c:
	  The variable type of holding distance of colors in searching
	  approximate color is changed from u_long to u_int.

2016-03-06  Araki Ken  <arakiken@users.sf.net>

	* x_color_cache.[ch]:
	  x_color_cache_256_t -> xc_olor_cache_256ext_t which contains extended colors.

	* x_color.h: The type of pixel is changed from u_long to u_int32_t in x_color_t.

	* ml_color.[ch]:
	  - 0x100-0x1ef is used to allocate 24bit colors. (Named as "extended colors")
	  - 0x100-0x106 (ML_FG_COLOR-ML_CROSSED_OUT_COLOR) is moved to 0x1f0-0x1f6.
	  - MAX_256_COLORS, MAX_EXT_COLORS, MAX_256EXT_COLORS, IS_EXT_COLOR(),
	    IS_256EXT_COLOR(), EXT_COLOR_TO_INDEX(), INDEX_TO_EXT_COLORS(),
	    COLOR_DISTANCE() and COLOR_DISTANCE_THRESHOLD macros are added.
	  - ml_ext_color_is_changed() is added.
	  - ml_get_closest_color() and ml_get_color_rgba() consider extended colors.
	  - IS_VALID_COLOR_EXCEPT_FG_BG() is renamed to IS_VALID_COLOR_EXCEPT_SPECIAL_COLORS().

	* kik_map.h:
	  - The number of searching is decreased.
	  - MAP_MARGIN_SIZE macro is newly defined.

	* kik_map.c: Minor fixes of test code.

2016-03-05  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c: 'mlcc font USASCII <Font Name>' is available.

	* x_font_config.c: Unnecessary kik_str_alloca_dup() is removed.

	* quartz/x_imagelib.c: If gif file path is ~/.mlterm/anim*, split_animation_gif()
	  is not called.

	* quartz/x_font.c: x_font_t::ot_font_not_found is checked in
	  x_font_has_ot_layout_table().

	* kik_mem.c: Illegal access to unallocated memory in kik_mem_free_all() is fixed.

2016-03-03  Araki Ken  <arakiken@users.sf.net>

	* quartz/cocoa.m: [NSRunLoop runUntilDate] is called if huge data is received
	  or screen is blanked temporarily by visual bell.

	* mlfc/Makefile.in: Install directory is fixed.

2016-03-01  Araki Ken  <arakiken@users.sf.net>

	* configure.in: Not only <machine/grfioctl.h> but also <machine/vuid_event.h>
	  is checked not to enable USE_GRF on NetBSD/macppc.

2016-02-28  Araki Ken  <arakiken@users.sf.net>

	* quartz/x_window.c: x_window_set_normal_hints() is fixed.

	* quartz/x_imagelib.c: animation gif is supported.

	* ml_vt100_parser.c: SUPPORT_ITERM2_OSC1337 is enabled by default.

	* main.c: _fmode = _O_BINARY on win32.

2016-02-26  Araki Ken  <arakiken@users.sf.net>

	* README.fontproto, README.ja, man/mlterm.1: Updated.

	* mc_font.c: "UNICODE (Hebrew)", "UNICODE (Hindi)", "UNICODE (Bengali)",
	  "UNICODE (Punjabi)", "UNICODE (Gujarati)", "UNICODE (Oriya)", "UNICODE (Tamil)",
	  "UNICODE (Telugu)", "UNICODE (Kannada)" and "UNICODE (Malayalam)" are added.

	* mc_io.[ch]: font_size is removed from arguments of mc_{set|get}_font_name().

	* ml_vt100_parser.[ch]:
	  - font_size is removed from arguments of ml_config_event_listener_t::get_font.
	  - CSI?12h and CSI?12l (XT_CBLINK) are dropped.

	* x_window_cairo.c:
	  Alias font names are considered in searching glyph complementary fonts.

	* x_font_ft.c:
	  - The format of cairo or xft font name is changed as follows.
	      [Family] [Weight] [Slant] [Size]-[Encoding]:[Percentage]
	    ->[Family] [Weight] [Slant] [Size]:[Percentage]
	  - It is not necessary to escape '-' by '\' in font name.

	* x_font_config.[ch]:
	  - The format of value of ~/.mlterm/*font is changed as follows.
	    [Font name];[Size],[Font name];[Size],[Font name];... -> [Font name]
	  - x_customize_font_name() and x_customize_default_font_name() are removed.

	* x_main_config.c, x_font_manager.c: Whether font_size is within
	  font_size_range is checked in x_font_manager.c, not in x_main_config.c.

	* x_font_cache.c, x_font_config.c, x_font_manager.c:
	  {min|max}_font_size static variables and x_set_font_size_range() are
	  moved from x_font_config.c to x_font_manager.c.

	* ml_termcap.c:
	  - Illegal memory access around db on memory for MacOSX/Cocoa and Android is fixed.
	  - DB on memory isn't used on MacOSX/Cocoa.

	* ml_char.c: unicode_area_{max|min} static variables are added.

	* configure.in: mlfc is added to the default value of --with-tools option.

	* tool/mlfc: Added.

	* cocoa.m: If x_get_all_screens(NULL) has already returned 0 before willClose() is
	  called, nothing except calling [NSNotificationCenter removeObserver] is done.

	* cocoa.[hm], quartz/x_window.c: view_set_normal_hints() is changed to
	  window_set_normal_hints(), because x_window_set_normal_hints(root window
	  whose my_window is NSWindow*) calls window_set_normal_hints(NSWindow).

	* main-cocoa.m: [[NBundle mainBundle] bundlePath] is passed to kik_set_sys_conf_dir().

	* cocoa/install.sh: etc/* files are installed to mlterm.app bundle.

	* otl.h: Syntax error is fixed.

	* ml_char_encoding.c, kik_conf_io.c: Minor fixes.

	* version.h.in: 3.6.3 -> 3.6.3post

2016-02-14  Araki Ken  <arakiken@users.sf.net>

	* 3.6.3 released.
	  (tag "rel-3_6_3")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.6.3.

	* ml_ot_layout.c: ucs_filled++ is moved outside of ml_is_rtl_char() which
	  may be replaced by (0).

2016-02-14  Araki Ken  <arakiken@users.sf.net>

	* README, README.ja: Updated.

	* libotl/Makefile.in: LKIK=${top_builddir}/kiklib/src/libkik.la -> LKIK=@LKIK@

	* configure.in: If --enable-anti-alias isn't specified, open type layout is
	  disabled on framebuffer.

2016-02-13  Araki Ken  <arakiken@users.sf.net>

	* 3.6.2 released.
	  (tag "rel-3_6_2")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.6.2.

	* README, doc/ja/README.ja: Updated.

	* configure.in: --disable-otl is added.

2016-02-11  Araki Ken  <arakiken@users.sf.net>

	* README.indic: Updated.

	* ml_vt100_parser.c: fopen/fclose/fwrite are replaced by
	  cygfopen/cygfclose/cygfwrite defined in cygfile.[ch].

	* mlterm/cygfile.[ch]: Added.

	* kik_dlfcn_win32.c, gdiplus.cpp, gdk-pixbuf.c, mlimgloader/none.c,
	  win32/x_dnd.c, win32/x_imagelib.c:
	  cygwin_conv_to_{win32|posix}_path() -> kik_conv_to_{win32|posix}_path().

	* kik_path.[ch]: kik_conv_to_{win32|posix}_path is added.

	* x_screen.c: x_stop_selecting() is called in button_released() even if
	  mouse reporting mode is set.

	* fb/x_font.c, libtype/x_window_{cairo|xft}.c, cocoa.m, quartz/x_font.c,
	  win32/x_font.c, xlib/x_font.c:
	  #ifdef USE_OT_LAYOUT ... #endif is inserted.

	* configure.in: `pkg-config freetype2 --cflags` is added to OT_LAYOUT_CFLAGS
	  with harfbuzz on platforms except MacOSX/Cocoa.

	* prepare.sh: Files in xwindow/libotl are copied.

	* Android.mk:
	  - OTF_* -> OTL_*
	  - -Ixwindow/libotl and -DNO_DYNAMIC_LOAD_OTL are added to OTL_CFLAGS.

2016-02-10  Araki Ken  <arakiken@users.sf.net>

	* README.ja: Updated,

	* x_font.h, quartz/x_font.c: pointsize -> size.

	* x_main_config.[ch]: use_ot_layout is added to x_main_config_t.

	* x_screen.c: use_ot_layout is added to arguments of change_ctl_flag().

	* x_draw_str.c: If xfont->use_ot_layout is true on win32gdi,
	  x_window_draw_image_string() variant functions are not used.

	* win32/x_font.c:
	  - ISO10646_UCS4_1_V is added to wincs_info_table.
	  - is_ucs is added to arguments of text_out().
	  - x_calculate_char_width() returns 0 if calculate_char_width() returns 0.

	* otf.c, win32/x_font.c: free(obj) is called in otl_open(), not in
	  x_font_has_ot_layout_table().

	* hb.c: Fixes for win32gdi.

	* ml_line.[ch]:
	  - ml_set_use_ot_layout() and ml_is_using_ot_layout() are removed.
	  - Opentype layout is enabled if 'term' argument of ml_line_ctl_render()
	    is non-NULL value.

	* ml_term.[ch]:
	  - ml_term_set_use_ctl() is defined as a macro, not as a function.
	  - ml_term_set_use_ot_layout() and ml_term_is_using_ot_layout() are added.
	  - use_ot_layout is added to ml_term_t.

	* ml_term.c, ml_vt100_parser.c:
	  "use_ot_layout", "ot_script" and "ot_features" of OSC 5379-5381 are
	  moved from ml_vt100_parser.c.

	* ml_term.[ch], ml_term_manager.[ch]:
	  use_ot_layout is added to arguments of ml_term_new() and ml_create_term().

	* ml_vt100_parser.[ch]:
	  - CONVERT_UNICODE_TO_ISCII is added to ml_unicode_policy_t.
	  - Even if use_char_combining is false, is_comb attr of ml_char_t is set.
	  - use_ctl is removed from ml_vt100_parser_t, and the result of IS_ARABIC_CHAR()
	    is checked before ml_is_arabic_combining() is called.

	* ml_shape.h: IS_ARABIC_CHAR() is added.

	* ml_screen.h: use_dynamic_comb is removed.

2016-02-07  Araki Ken  <arakiken@users.sf.net>

	* README.cocoa, README.indic, doc/en/README.win32: Updated.

	* etc/font.cocoa: Added.

	* quartz/x_font.c: If a specified font family for us ascii is not found,
	  "Menlo" font is loaded instead.

	* quartz/x_window.c: x_window_set_normal_hints() calls view_set_normal_hints().

	* cocoa.[hm]: view_set_normal_hints() is added.

2016-02-06  Araki Ken  <arakiken@users.sf.net>

	* README.cocoa, README.indic: Updated.

	* x_draw_str.c:
	  If ch_cs == ISO10646_UCS4_1_V, ml_char_get_offset() of a combining char
	  whose ch_code is less than 0x100 is added to x.

	* quartz/x_font.c: fontsize_d of parse_from_name() is applied.

	* cocoa.m: (char*)str -> (u_char*)str in drawString().

	* hb.c: hb_ot_font_set_funcs() is called after hb_font_create() on MacOSX/Cocoa.

	* otl.h, otf.c, hb.c:
	  fontsize argument which is not used from otf.c for now is added to
	  otl_convert_text_to_glyphs().

	* mlconfig/main.c, mc_flags.[ch]:
	  "OpenType Layout" checkbox is added to "Encoding" tab.

	* ml_line.c: If dst->num_of_chars < src->num_of_filled_chars,
	  src->ctl_info is not copied to dst->ctl_info in case ml_line_shape(dst)
	  is called before ml_line_ctl_render(dst).

	* im_kbd.c: result->num_of_args and readable_args are fixed.

	* configure.in: libind is never built on MacOSX/Cocoa.

	* cocoa/install.sh: Linkage to libotf and libharfbuzz is adjusted.

2016-02-04  Araki Ken  <arakiken@users.sf.net>

	* quartz/x_font.c: font->use_ot_layout check in x_calculate_char_width()
	  is fixed.

	* ml_line_iscii.c: Processing a returned value of ml_iscii() is fixed again.

	* configure.in, libotl/hb.c: Hack to build libotl/hb.c with harfbuzz library
	  on quartz is added.

2016-02-03  Araki Ken  <arakiken@users.sf.net>

	* ml_line_iscii.c: Processing a returned value of ml_iscii() is fixed.

	* quartz/x_font.c:
	  - ISO10646_UCS4_1_V is supported.
	  - x_font_has_ot_layout_table() supports harfbuzz version of libotl.
	  - x_calculate_char_width() supports proportional fonts.

	* cocoa.[hm]:
	  - cocoa_font_get_advance() is added.
	  - drawUnistr supports proportional fonts.

	* hb.c: otl_{open|close}() support win32 and quartz.

	* cocoa/install.sh: libctl_iscii.so and libind_{hindi|bengali}.so are installed.

	* configure.in: libind is built on MacOSX/Cocoa.

2016-02-02  Araki Ken  <arakiken@users.sf.net>

	* win32/x_font.c:
	  - The address of GetTextExtentPointI is gotten dynamically in USE_WIN32API
	    because its symbol doesn't exist on mingw-i686-pc-mingw.
	  - ISO10646_UCS4_1_V is considered.
	  - Whether the width of full width characters is actually double or not
	    is checked by GetTextExtentPoint32W(0x3000).

	* libind/Makefile.in: tamil.o is added to TBL_OBJ.

	* kik_dlfcn_win32.c: LoadLibrary() -> LoadLibraryA()

	* ml_ot_layout.c, ml_shape.c: Minor fixes.

2016-02-01  Araki Ken  <arakiken@users.sf.net>

	* x_draw_str.c: calculate_char_width() which is separated from
	  x_calculate_mlchar_width is used internally.

	* fb/x_window.c: Combined ISO10646_UCS4_1_V characters whose
	  ml_char_get_offset() is minus is correctly drawn.

	* fb/x_display_linux.c:
	  - Not only /sys/class/input/inputN/name but also
	    /sys/class/input/eventN/device/name is checked to search keyboard and
	    mouse devices.
	  - /dev/input/mice and /dev/input/mouse0 are checked.
	  - EVIOCGABS(ABS_X) and EVIOCGABS(ABS_X) are checked when EV_ABS event is
	    received.

	* ml_vt100_parser.c, x_screen.c:
	  - {stop|start}_vt100_cmd() aren't called in set_mouse_report() in
	    ml_vt100_parser.c and x_stop_selecting() etc aren't called in
	    xterm_set_mouse_report() in x_screen.c in order to reduce the number
	    of calling ctl_render().
	  - {stop|start}_vt100_cmd() aren't called in request_locatator().
	  - 'visualize' is added to arguments of config_protocol_set_simple()
	    to control whether to call {stop|start}_vt100_cmd().

	* libctl/ml_line_iscii.c:
	  - ml_iscii() is called only if ml_line_is_real_modified() is true.
	  - Loop end in ml_line_iscii_convert_logical_char_index() is changed
	    from ml_line_end_char_index(line) to line->ctl_info.iscii->size.

	* libctl/ml_iscii.c, ml_ot_layout.c:
	  The allocated size of state->num_of_chars_array is minimized.

	* libctl/ml_line_bidi.c:
	  - ml_bidi() is called only if ml_line_is_real_modified() is true.
	  - set_visual_modified() which sets visual modified area from logical one
	    is called if visual_order is not changed.

	* libctl/ml_bidi.c:
	  visual_order is not changed => return 1
	  visual_order is changed => return 2

	* x_screen.c:
	  ml_line_has_ot_layout() -> ml_line_has_ot_substituting_glyphs().

	* ml_line.[ch]:
	  - line->is_modified = 2 (in set_real_modified() called internally) if it is really
	     modified while ml_line_set_modified*() called externally sets
	     line->is_modified = 1.
	  - ml_line_is_real_modified() is added.
	  - ml_ot_layout() is called only if ml_line_is_real_modified() is true.
	  - ml_line_has_ot_layout() -> ml_line_has_ot_substituting_glyphs().

	* ml_line.c, ml_line_shape.c, ml_ot_layout.[ch]:
	  line->ctl_info.ot_layout->has_ot_layout => line->ctl_info.ot_layout->substituted

2016-01-29  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.c:
	  - Unicode => ISCII conversion is enabled only if ml_is_using_ot_layout()
	    is false.
	  - "use_ot_layout" option is added to ml_vt100_parser_get_config().

	* ml_line.[ch]: ml_is_using_ot_layout() is added.

	* fb/x_font.c: Minor fixes.

	* otf.c, win32/x_font.c: Compiling error is fixed.

2016-01-28  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c: x_calculate_char_width() -> x_calculate_mlchar_width()

	* x_draw_str.[ch]: x_calculate_mlchar_width() is added.

	* x_font.h, xlib/x_font.c, fb/x_font.c, win32/x_font.c, quartz/x_font.c,
	  x_font_ft.c, otl.h, otf.c, hb.c:
	  offsets and widths arguments are added to x_convert_text_to_glyphs().

	* ml_line.c: ml_line_ot_layout_{visual|logical|convert_logical_char_index_to_visual}
	  are reverted.

	* ml_char_encoding.[ch], x_font_config.c, x_font_manager.c:
	  ML_ISCII_ROMAN and ML_ISCII_TAMIL are removed.

	* ml_char.[ch]:
	  - new_comb() is separated from ml_char_combine().
	  - ml_char_combine_simple() uses new_comb().
	  - ml_char_get_offset(), ml_char_get_width() and ml_char_set_position() are added.

	* mkf_8bit_conv.[ch], mkf_8bit_parser.[ch], mkf_charset.h, mkf_ucs4_iscii.[ch],
	  mkf_ucs4_map.c: Functions related to ISCII_ROMAN are removed.

	* mkf/lib/Makefile.in: 16.1 -> 17.0

	* libctl/ml_iscii.c: iscii_tamil_table is revived.

	* libind/tamil.c: Revived.

	* table/tamil.table: Revived with minimum.

2016-01-24  Araki Ken  <arakiken@users.sf.net>

	* doc/ja/README.ja, man/mlterm.1, etc/main, etc/main.ja, doc/en/README.indic:
	  Updated.

	* x_font_cache.c, x_font_manager.c:
	  ISO10646_UCS4_1_V font is treated as FONT_VAR_WIDTH forcibly in
	  x_font_cache_get_xfont() and x_get_font().

	* win32/x_font.c: GetTextExtentPointIW() is used for glyph index.

	* cocoa.[hm], quartz/x_font.c:
	  ot_font is created in x_font.c, not in cocoa.m
	  (cocoa_create_otf() is removed. cocoa_get_font_path() is added.)

	* */x_font.c, x_font_ft.c, */x_window.c, x_window_{cairo|xft}.c:
	  'if( font->ot_font && font->use_ot_layout)' => 'if( font->use_ot_layout)'
	  (font->ot_font can be NULL if its charset is ISO10646_UCS4_1_V)

	* x_window_cairo.c: Centering of the last glyph under font->use_ot_layout == 1
	  in show_text() is fixed.

	* fb/x_font.c:
	  A font for ISO10646_UCS4_1_V is treated as proportional.
	  (If XFontStruct for ISO10646_UCS4_1_V has been already used for ISO10646_UCS4_1
	  (fixed-pitch), loaded glyphs are cleared by clear_glyph_cache_ft() becauase
	  glyph_size is 3bytes different from fixed-pitch font to proportional one.)

	* */x_font.c, x_font_ft.c: libotl is used.

	* quartz/otfwrap.[ch], win32/otfwrap.[ch]: Removed.

	* libotl/: Added.

	* ml_vt100_parser.c: If USE_HARFBUZZ is defined, Unicode->ISCII conversion is
	  disabled.

	* ml_shape.c:
	  If src code is 0x900-0xd7f, ISO10646_UCS4_1_V is set.

	* ml_line.c, ml_shape.c:
	  The algorithm of ml_line_ot_visual(), ml_line_ot_logical() and
	  ml_shape_ot_layout() is changed.

	* x_main_config.c:
	  - "use_gsub", "gsub_script" and "gsub_features" => "use_ot_layout",
	    "ot_script" and "ot_features".
	  - use_ctl is forcibly enabled if use_gsub is true.

	* x_screen.c: The 3rd argument (use_ot_layout) of x_font_manager_set_attr()
	  is always false in draw_preedit_str().

	* ml_line[ch], ml_line_shape.c, ml_logical_visual.[ch], ml_shape.[ch],
	  ml_vt100_parser.c, x_font.h, */x_font.[ch], libtype/x_font_ft.c,
	  */x_window.c, x_window_{xft|cairo}.c, x_functbl_*.c, x_type_loader.h,
	  x_font_manager.c, x_screen.c:
	  - ml_gsub -> ml_ot_layout
	  - x_font_t::otf -> x_font_t::ot_font
	  - {xft|cairo}_set_otf -> {xft|cairo}_set_ot_font

	* ml_gsub.[ch]: Renamed to ml_ot_layout.[ch].

	* ml_char.[ch]:
	  Max number of unicode areas is changed from 511 to 255 and
	  1 bit is used for CS_REVISION_1. (ISO10646_UCS4_1_V)

	* ml_str_parser.c: Null character is skipped.

	* libctl/Makefile.in, libtype/Makefile.in: LMKF is removed.

	* libtbl/mkf_ucs4_iscii.c: 0xa00-a7f => ISCII_PUBJABI.

	* mkf_charset.h: ISO10646_UCS4_1_V is added to draw indic scripts
	  in variable column width all the time.

	* main/Makefile.in:
	  @GSUB_LIBS@ is removed from LIBS2_fb.

	* tamil.c, tamil.table, roman.c, roman.table, im_kbd.c, ml_iscii.c:
	  tamil and roman in libind are removed.

2016-01-17  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, README.ja: Updated.

	* x_font_ft.c: ":Percentage" in ~/.mlterm/aafont is enabled on cairo.

	* xlib/x_font.c, x_font_ft.c, win32/x_font.c:
	  x_font_t is created by calloc instead of malloc.

	* ml_logical_visual.[ch], ml_line.c, x_main_config.c: defined(USE_GSUB) is added.

2016-01-16  Araki Ken  <arakiken@users.sf.net>

	* ml_bidi.[ch], ml_gsub.c:
	  ml_load_ctl_bidi_func(ML_IS_RTL_CHAR) is moved from ml_bidi.c to ml_gsub.c
	  in order to link ml_gsub.o to libmlterm_core.so

	* mlterm/Makefile.in: ml_gsub.o is linked to libmlterm_core.so.

	* win32/x_window.c:
	  is_glyph argument is added to text_out().

	* win32/x_font.c:
	  - x_font_has_gsub_table() and x_convert_text_to_glyphs() are added.
	  - GetTextExtentPoint -> GetTextExtentPoint32
	  - font->width = w_sz.cx instead of tm.tmAveCharWidth because w_sz.cx of
	    PragmataPro is 1 pixel larger than tm.tmAveCharWidth.

	* win32/otfwrap.[ch]: Added.

2016-01-13  Araki Ken  <arakiken@users.sf.net>

	* quartz/otfwrap.[ch], quartz/x_font.c:
	  otf_check_table() is integrated to otf_open().

2016-01-11  Araki Ken  <arakiken@users.sf.net>

	* etc/main, etc/main.ja: Updated.

	* fb/x_window.c: Compiling error is fixed.

	* jni/Android.mk: OTF_SRC_FILES and OTF_CFLAGS are cleared once on every arch.

	* x_font_ft.c: XftGlyphExtents() is used if ch is glyph index.

	* main/Makefile.in: Mistake of the previous commit is reverted.

2016-01-10  Araki Ken  <arakiken@users.sf.net>

	* doc/ja/README.ja, man/mlterm.1: Updated.

	* x_main_config.c: "use_gsub", "gsub_script" and "gsub_features" options
	  are added.

	* x_screen.c: gsub_get_gsub_font() is added.

	* x_type_loader.[ch]:
	  - Moved to xwindow/xlib/.
	  - X_SET_OTF and X_CONVRET_TEXT_TO_GLYPHS are added to x_type_id_t.

	* xlib/x_font.c, libtype/x_font_ft.c:
	  - x_font_has_gsub_table(), x_convert_text_to_glyphs(),
	    {xft|cairo}_set_otf and {xft|cairo}_convert_text_to_glyphs() are added.

	* fb/x_font.c:
	  - load_char() -> load_glyph()
	  - get_glyph_index(), x_font_has_gsub_table() and x_convert_text_to_glyphs()
	    are added.
	  - get_ft_bitmap() accepts glyph index if use_gsub argument is true.

	* x_font_manager.[ch]:
	  - use_gsub is added to x_font_manager_t.
	  - x_font_manager_set_size_attr() is renamed to x_font_manager_set_attr().

	* x_font.h: otf, otf_not_found and use_gsub are added to x_font_t.

	* ml_vt100_parser.c:
	  - CSI33h / CSI33l are supported.
	  - "use_gsub" is added to OSC 5379.

	* ml_term_manager.c: ml_set_gsub_attr(NULL) is called in
	  ml_term_manager_final() to free memory.

	* ml_logical_visual.[ch]: ml_term_t is added to ml_logvis_ctl_new()
	  in order to pass it to ml_line_ctl_render().

	* ml_line_shape.c:
	  - ml_line_gsub_need_shape() is added.
	  - ml_line_shape() uses ml_shape_gsub().

	* ml_shape.[ch]: ml_shape_gsub() is added.

	* ml_line.[ch]:
	  - ml_gsub_state_t is added to ml_line_t.
	  - ml_set_use_gsub(), ml_line_set_use_gsub(), ml_line_gsub_render(),
	    ml_gsub_visual(), ml_line_gsub_logical(), ml_line_has_gsub() and
	    ml_line_gsub_convert_logical_char_index_to_visual() are added.
	  - ml_term_t is added to arguments of ml_line_ctl_render() in order
	    to pass it to ml_line_gsub_render().

	* ml_char.[ch]: ml_char_set_cs() is added.

	* libctl/ml_iscii.c, mlterm/ml_iscii.c:
	  ml_iscii_copy() doesn't copy ml_iscii_state_t if optimize argument
	  is true and source ml_iscii_state_t doesn't have rtl characters.

	* ml_ctl_loader.h: ML_IS_RTL_CHAR is added.

	* libctl/ml_bidi.c, mlterm/ml_bidi.c:
	  - ml_bidi() returns -1 if ISCII character is found.
	  - ml_bidi_copy() doesn't copy ml_bidi_state_t if optimize argument
	    is true and source ml_bidi_state_t doesn't have rtl characters.
	  - ml_is_rtl_char() is added.

	* ml_gsub.[ch]: Added.

	* main/Makefile.in, mlterm/Makefile.in, xwindow/Makefile.in:
	  @GSUB_CFLAGS@ and @GSUB_LIBS@ are added.

	* configure.in: libotf is checked.

	* Android.mk: libotf files are added to LOCAL_SRC_FILES and
	  USE_GSUB is added to LOCAL_CFLAGS.

	* im_uim.c: Experimental implementation of showing not only candidate screen
	  but also status one is added.

	* ml_normalize.m: Added.

2015-12-27  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.[ch]:
	  - ml_pty_hook_t is added to ml_vt100_parser_t.
	  - KAM(CSI2h, CSI2l), SRM (CSI12h, CSI12l), DECBKM(CSI?67h, CSI?67l),
	    DA3(CSI=c), DECDSR(CSI?n), OSC 104 and OSC 105 are supported.

	* ml_pty.[ch], ml_pty_intern.h:
	  ml_pty_set_hook() and ml_pty_hook_t are added.

	* ml_termcap.[ch]:
	  - ml_termcap_entry_t * => ml_termcap_ptr_t
	  - ml_termcap_get_{str|bool}_field() are removed.
	  - ml_termcap_bce_is_enabled() and ml_termcap_set_key_seq() are added.
	  - ml_termcap_{str|bool}_field is moved from ml_termcap.h to ml_termcap.c.

2015-12-23  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, README.ja, etc/main, etc/main.ja: Updated

	* mlconfig/main.c: "Select URI by double click" checkbox is added to "Others" tab.

	* mc_flags.[ch]: MC_FLAG_REGARDURIASWORD is added.

	* x_main_config.c: "regard_uri_as_word" / --uriword option is added.

	* ml_vt100_parser.c: "regard_uri_as_word" is added to OSC 5379-5383.

	* ml_screen.[ch]:
	  - ml_{set|get}_regard_uri_as_word() are added.
	  - If regard_uri_as_word is true, ml_screen_get_word_region() regards uri as word.

2015-12-20  Araki Ken  <arakiken@users.sf.net>

	* mc_radio.c: "sound|visual" value is added to bel_mode option.

	* quartz/x_window.c: x_window_bell() is implemented.

	* cocoa.[hm]: view_visual_bell() and cocoa_beep() are added.

	* win32/x_window.c: x_window_blank() is fixed.

2015-12-20  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, README.ja: Updated.

	* vte.c:
	  - vte_terminal_{set|get}_word_char_exceptions() are added.
	  - "child-exited" signal is triggered with exit status on vte-0.38 or later.

	* main-cocoa.m: LANG environmental variable is set.

	* x_main_config.c: The default value of "type_engine" option is changed
	  from xft to cairo on xlib.

	* ml_char.c: ml_char_combine() calls ml_normalize().

	* mlterm/Makefile.in, configure.in: ml_normalize.o is added to OBJ_CORE
	  on MacOSX.

	* ml_normalize.m: Added. (available on MacOSX alone.)

	* version.h.in: 3.6.1 -> 3.6.1post

2015-12-15  Araki Ken  <arakiken@users.sf.net>

	* 3.6.1 released.
	  (tag "rel-3_6_1")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.6.1.

2015-12-13  Araki Ken  <arakiken@users.sf.net>

	* gtk/Makefile.in: x_sb_screen.lo -> x_layout.lo

	* vte.c:
	  catch_child_exited() calls ml_close_dead_terms() via g_timeout_add()
	  because gnome-terminal() exits with segfault.

	* README.ja, man/mlterm.1: Updated.

	* mc_radio.c: "autohide" value of scrollbar_mode option is supported.

	* x_layout.[ch], x_screen.c:
	  If sb_mode is SBM_AUTOHIDE, scrollbar is hidden or unhidden according to
	  the position of the mouse pointer.

	* x_sb_mode.[ch]: SBM_AUTOHIDE is added.

	* cocoa.m: The position of the mouse pointer is fixed.

	* x_window.h, */x_window.c:
	  - x_window_init_event_mask() is removed.
	  - x_window_{add|remove}_event_mask() are fixed.

	* x_event_source.c: If need_resize() returns true, "use_local_echo" is
	  forcibly disabled.

	* jni/x_display.c: Pointer motion event is handled.

	* configure.in: utmp and ind options are disabled by default on MacOSX/Cocoa.

	* x_screen_manager.c:
	  - "mlclientx --serv ..." is available.
	  - WINDOWID environmental variable = window id of x_screen_t instead of a top window.

	* fb/x_connect_dialog.c: Inputting password is implemented.

	* fb/x_window.c: check_child_window_area() which was added at revision 2480
	  is removed.

2015-12-05  Araki Ken  <arakiken@users.sf.net>

	* x_draw_str.c: Minor fixes around draw_drcs().

	* win32/x_dnd.c: Minor fixes.

	* x_font_ft.c: font->compl_fonts and font->pattern is always initialized.

	* bengali.table, hindi.table: Minor fixes.

	* configure.in:
	  - 'extra' and 'pixmap_engine' scrollbars are built by default.
	  - Following options are enabled by default.
	    --enable-ind, --enable-ssh2, --enable-utmp, --enable-uim, --enable-m17nlib,
	    --enable-scim, --enable-ibus, --enable-fcitx, --enable-canna, --enable-wnn

2015-11-28  Araki Ken  <arakiken@users.sf.net>

	* x_draw_str.c: Fix a bug of draw_drcs().

	* quartz/x_window.c: x_window_t::button_pressing and prev_button_press_event
	  are set.

	* quartz/x_display.c: x_display_idling() uses static variable _disp.

	* cocoa.m: x_display_idling(NULL) is called at 0.1 sec intervals.

	* MLActivity.java: IME_FLAG_NO_FULLSCREEN is set.

	* android/jni/x_display.c: The area of the right bottom corner is expanded
	  according to the screen size.

2015-11-26  Araki Ken  <arakiken@users.sf.net>

	* quartz/x_window.c, quartz/x.h:
	  - x_window_{add|remove}_event_mask() calls window_accepts_mouse_moved_events()
	    if event_mask has PointerMotionMask.
	  - X_POINTER_MOTION event is processed in x_window_receive_event().

	* cocoa.[mh]:
	  - window_accepts_mouse_moved_events() is added.
	  - rightMouseUp, rightMouesDragged and mouesMoved are implemented.
	  - mev.state is correctly set in menuForEvent().

	* x_screen.c: Minor fixes.

2015-11-23  Araki Ken  <arakiken@users.sf.net>

	* x_draw_str.c: (bottom_margin + top_margin > 0 || xfont->size_attr >= DOUBLE_HEIGHT_TOP)
	  is replaced by (xfont->height != height).

	* ml_str_parser.c: ml_convert_drcs_to_unicode_pua() isn't called on Android.

	* ml_char.c: It is disabled to combine ISCII character to another charset.

	* tamil.table: Fix.

2015-11-23  Araki Ken  <arakiken@users.sf.net>

	* ml_font.h, x_font_cache.c: The position of size_attr in ml_font_t is changed.

2015-11-22  Araki Ken  <arakiken@users.sf.net>

	* x_font_cache.c: If size_attr > 0, x_font_cache_get_xfont() loads USASCII font
	  instead of a specified font which doesn't exist.

	* x_draw_str.c: draw_drcs() supports DOUBLE_{WIDTH|HEIGHT_TOP|HEIGHT_BOTTOM}.

	* ml_vt100_parser.c:
	  ESC - (designate CS96 single byte charset) is supported on utf8 encoding.

2015-11-21  Araki Ken  <arakiken@users.sf.net>

	* README.ja, man/mlterm.1: Updated.

	* doc/term: Removed.

2015-11-21  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.c: Mistake of revision 2510 commit is reverted.

2015-11-21  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c: x_font_manager_set_size_attr() is called before x_get_font().

	* x_draw_str.c:
	  - If xfont->size_attr >= DOUBLE_HEIGHT_TOP, x_window_draw_{image}_string*()
	    aren't used.
	  - Drawing height and ascent is modified according to font_man->size_attr
	    in x_draw_str() and x_draw_str_to_eol().

	* x_font_manager.[ch]: x_font_manager_set_size_attr() is added.

	* x_functbl_{cairo|xft}.c, x_window_{cairo|xft}.c:
	  {xft|cairo}_{un}set_clip() are added.

	* x_type_loader.h: X_WINDOW_SET_CLIP and XWINDOW_UNSET_CLIP are added.

	* cocoa.m:
	  - setClip and unsetClip are added to MLTermView.
	  - view_set_clip() and view_unset_clip() are added.
	  - Glyph size is transformed according to x_font_t::size_attr.

	* x_window.h, fb/x_window.c, win32/x_window.c, xlib/x_window.c, quartz/x_window.c:
	  x_window_set_clip() and x_window_unset_clip() are added.

	* x_font.h, fb/x_font.c, win32/x_font.c, xlib/x_font.c, quartz/x_font.c:
	  - size_attr is added to x_font_t and to arguments of x_font_new().
	  - Large fonts are loaded according to size_attr.

	* ml_font.h: DOUBLE_WIDTH, DOUBLE_HEIGHT_TOP and DOUBLE_HEIGHT_BOTTOM are added.

	* ml_screen.h: ml_screen_clear_size_attr() is added.

	* ml_screen.c: size_attr of newly scrolled in line is reset in
	  receive_scrolled_out_line().

	* ml_edit.[ch]: ml_edit_clear_size_attr() is added.

	* ml_line.[ch]:
	  - size_attr is added to ml_line_t.
	  - ml_line_set_size_attr() is added.

	* ml_vt100_parser.c:
	  - clear_line_all() and clear_display_all() doesn't change cursor position.
	  - DECDHL and DECDWL (ESC # 3 - 6) are supported.

	* cocoa/install.sh: mlterm and mlconfig are installed correctly.

2015-10-25  Araki Ken  <arakiken@users.sf.net>

	* x_layout.c: x_window_update_all() is called in reset_layout()
	  if true transparency is enabled on MacOSX/Cocoa because x_window_move()
	  clears screen.

	* cocoa/install.sh: mlconfig is installed if exits.

2015-10-25  Araki Ken  <arakiken@users.sf.net>

	* mlconfig/Makefile.in, mlterm-menu/Makefile.in:
	  "LIBS2_quartz = $(LKIK)" is added.

	* version.h.in: 3.6.0 -> 3.6.0post

2015-10-25  Araki Ken  <arakiken@users.sf.net>

	* 3.6.0 released.
	  (tag "rel-3_6_0")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h:
	  updated for 3.6.0.

2015-10-24  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c: x_screen_exec_cmd() supports "mlconfig" command.

	* cocoa.m: "Config" and "Paste" menu items are added to the main menu.

2015-10-22  Araki Ken  <arakiken@users.sf.net>

	* mlconfig/main.c: "Scrollbar" tab is revived on MacOSX/Cocoa.

	* mkf_utf16_parser.c: Unnecessary mkf_parser_n_increment() is removed.

	* gtk/vte.c: Illegal memory access is fixed.

	* gtk/INSTALL: Renamed to README.

	* libctl/dexport-fb.map: Removed.

	* gtk/dexport-sun.map, libctl/dexport-sun.map, libtype/dexport-sun.map: Added.

	* configure.in:
	  - mlimgloader is never built on MacOSX/Cocoa.
	  - dexport.map -> dexport-sun.map on Solaris.

2015-10-17  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c:
	  - cocoa_get_bundle_path() + "/Contents/MacOS/" is appended to mlconfig path
	    on quartz.

	* quartz/x_font.c:
	  - screen_get_user_space_scale_factor() is not used to determine width and height
	    by pixel.
	  - CGFontGetUnitsPerEm() and CGFontGetGlyphAdvances() are additionally used
	    to determine width and height by pixel.

	* cocoa.[ch]:
	  - screen_get_user_space_scale_factor() is removed.
	  - monitor_pty() is called only once.
	  - http://flex.phys.tohoku.ac.jp/~okuyama/mlterm-30ef99499785.patch is merged.
	    (Thanks to @LabDrunker)
	  - PANGO_LIBDIR is set for mlconfig bundled in mlterm.app.
	  - menuForEvent() event is handled.
	  - cocoa_get_bundle_path() is added.

	* mc_font.c: gtkxlfdsel.[ch] aren't used on quartz.

	* mlconfig/main.c:
	  - "Scrollbar" tab is disabled on quartz.
	  - gtk_window_set_keep_above(TRUE) is called on win32 or quartz.

2015-10-12  Araki Ken  <arakiken@users.sf.net>

	* cocoa.m: Alt+x isn't interpreted by NSView::interpretKeyEvents unless preediting.

	* mlconfig/main.c: "Columns" and "Rows" entries are added to "Others" tab.

	* mc_geometry.[ch]: Added.

	* mc_wordsep.c: Entry width is limited.

	* mc_ratio.c, mc_space.c: Constant value => macro (MAX_VALUE_LEN)

	* ml_vt100_parser.c: "geometry" is added to OSC 5379.

	* configure.in: Minor fixes.

	* kiklib/configure.in, kik_utmp_sysv.c: USE_UTMPX is defined if setutxline() exists.

2015-10-12  Araki Ken  <arakiken@users.sf.net>

	* cocoa.m, x_window.c: DnD is supported.

	* x.h: X_SELECTION_NOTIFIED and struct XSelectionNotifyEvent are added.

2015-10-12  Araki Ken  <arakiken@users.sf.net>

	* ml_iscii.c, ml_shape.c: __attribute__((weak)) is added to function declarations
	  on MacOS X because they are bounded to the same name symbols in
	  ml_ctl_{bidi|iscii}_func_table without it.

	* mlterm/Makefile.in: ml_shape.o is moved from libmlterm_core to libmlterm.

	* mlterm/ml_line_shape.c: Added. (ml_line_{bidi|iscii}_need_shape, ml_line_shape()
	  and ml_line_unshape() are moved from ml_line.c)

	* kik_dlfcn_dl.c: strstr(..., "mlterm/") is replaced by strcmp(..., "mlterm/")
	  because dirpath can contain multiple "mlterm/" strings.

	* configure.in: x_event_source.c, x_sb_view_factory.c, x_scrollbar.c
	  and x_simple_sb_view.c in $top_srcdir/xwindow are moved to xwindow/xlib/
	  on MacOS X in order to build those in xwindow/quartz/.

2015-10-11  Araki Ken  <arakiken@users.sf.net>

	* x.h: XK_BackSpace = NSDeleteCharacter instead of NSBackspaceCharacter.

	* ml_termcap.c: If $prefix/etc/mlterm/termcap is not found, default settings
	  are applied on macosx and android.

	* cocoa.m:
	  - 0x66(Eisu) and 0x68(Kana) keycodes are ignored in keyDown event.
	  - x_window_receive_event(KeyEvent) is called immediately in insertText(),
	    not in keyDown().

	* x_font.h, quartz/x_font.c, cocoa.m:
	  x_font_t:{height|ascent|width} are multiplied by NSScreen.userSpaceScaleFactor.

2015-10-05  Araki Ken  <arakiken@users.sf.net>

	* quartz/cocoa.m: [view release] is called in view_alloc() to decrement its
	  reference count.

2015-10-04  Araki Ken  <arakiken@users.sf.net>

	* quartz/x_window.c:
	  - view_update() is called in x_window_update_all() only if
	    win is x_screen_t.
	  - window_set_alpha() -> view_bg_color_changed() in x_window_set_bg_color().

	* quartz/x_imagelib.c: adjust_cgimage() is added to apply pic_mod to CGImage.

	* quartz/x_display.c: _disp.depth = 24 -> 32.

	* quartz/x_color.c: x_get_xcolor_rgba() is implemented.

	* cocoa.[mh]:
	  - window_set_alpha() is removed.
	  - view_bg_color_changed() and MLTermView::bgColorChanged() are added.
	  - True transparency is supported.

	* configure.in: Input method plugins are disabled on MacOSX/cocoa.

2015-10-04  Araki Ken  <arakiken@users.sf.net>

	* x_screen_manager.c:
	  - "login -fp $USER" is used instead of "$SHELL" environmental variable.
	  - Uncertainty of "disp = root->disp" in close_screen_intern() is fixed.
	    (Enbugged at 2015-10-02 commit)

2015-10-03  Araki Ken  <arakiken@users.sf.net>

	* doc/en/README.cocoa: Added.

	* quartz/x_xic.c: Control+space and Alt+x work on MacOSX/Cocoa.

	* x_screen.c: Delete key works on MacOSX/Cocoa.

	* cocoa.[mh]:
	  - view_resize() and view_move() are integrated to view_set_rect().
	  - Position and size of each subview is reset when a top window is resized.
	  - MLTermView::pasteboard() is implemented.

	* quartz/x_window.c, quartz/x_display.c, quartz/x_gc.c:
	  - x_window_t::gc is always NULL.

	* quartz/x_window.c:
	  win->wall_picture is drawn in x_window_clear() and clear_margin_area().

	* quartz/x_imagelib.c:
	  x_imagelib_load_file_for_background() is implemented.

2015-10-02  Araki Ken  <arakiken@users.sf.net>

	* Cocoa is supported. (experimental)

	* version.h.in: 3.5.1 -> 3.5.1post

2015-08-29  Araki Ken  <arakiken@users.sf.net>

	* 3.5.1 released.
	  (tag "rel-3_5_1")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h, doc/en/ReleaseNote:
	  updated for 3.5.1.

	* man/mlterm.1, etc/main, etc/main.ja, doc/ja/README.ja: Updated.

2015-08-29  Araki Ken  <arakiken@users.sf.net>

	* kik_utmp_sysv.c: Error of pututxline() is ignored if errno is ECHILD on NetBSD.

	* configure.in, x_font_ft.c: Minor fixes.

2015-08-26  Araki Ken  <arakiken@users.sf.net>

	* configure.in, java/Makefile.in: Minor fixes.

2015-08-25  Araki Ken  <arakiken@users.sf.net>

	* configure.in, gtk/Makefile.in:
	  - 'make VTE_ABI=(|2.90|2.91)' can change VTE ABI version to be built.
	  - libvte-2.91.so.9 -> libvte-2.91.so.0

	* vte.c: Failure of ioctl(slave, TIOCSCTTY) in vte_pty_child_setup() is fixed.

	* MLActivity.java, android/jni/x_event_source.c: Ambiguous method name is fixed.

2015-08-17  Araki Ken  <arakiken@users.sf.net>

	* mc_font.c: "Font width" buttons are added.

2015-08-15  Araki Ken  <arakiken@users.sf.net>

	* mkf_ucs_property.table: Updated to Unicode 8.0.0 (UnicodeData.txt and
	  EastAsianWidth.txt)

	* xlib/x_font.c: Fix typo.

2015-08-15  Araki Ken  <arakiken@users.sf.net>

	* win32/x_window.c: Improvement for an input method window.

	* x_screen.c, mlconfig/main.c, mc_flags.[ch]:
	  It is enabled to change the value of "use_extended_scroll_shortcut" option
	  dynamically, and a checkbox of it is added to mlconfig.

	* im_wnn.c: Ctrl+h works.

	* x_screen_manager.c: X11 forwarding of an opened ssh session isn't disabled.

2015-08-14  Araki Ken  <arakiken@users.sf.net>

	* */x_window.c, x_layout.[ch], x_main_config.[ch], x_screen.[ch],
	  x_screen_manager.c:
	  layout_inner_border/--lborder option which enables you to specify the number
	  of inner border pixels of a layout manager is added.

2015-08-02  Araki Ken  <arakiken@users.sf.net>

	* x_display_linux.c:
	  KBD_INUPT_NAME => KBD_INPUT_NUM
	  MOUSE_INUPT_NAME => MOUSE_INPUT_NUM

2015-08-02  Araki Ken  <arakiken@users.sf.net>

	* x_display_linux.c: Keyboard or mouse input device name is
	  configurable by "KBD_INPUT_NAME" or "MOUSE_INPUT_NAME" environmental
	  variable.

2015-08-01  Araki Ken  <arakiken@users.sf.net>

	* x_window_cairo.c, x_font_ft.c, x_font.h:
	  - user_data_t is removed.
	  - compl_fonts and pattern are added to x_font_t.
	  - compl_fonts and pattern are created only if charset isn't US_ASCII,
	    ISO8859_1_R or ISCII.

2015-07-25  Araki Ken  <arakiken@users.sf.net>

	* x_window_cairo.c: If a character code is not found in FC_CHARSET,
	  another font which contains it is searched and used automatically.

	* x_font_ft.c: FC_CHARSET is set to cairo_scaled_font_t as a user data.

	* im_wnn.c: Illegal memory access by pressing 'A' - 'Z' is fixed.

2015-06-13  Araki Ken  <arakiken@users.sf.net>

	* im_wnn.c:
	  - https://gist.github.com/tsutsui/1d4f9af3b4a53c906eb4 is merged.
	  - Small "tsu" is available.

2015-06-07  Araki Ken  <arakiken@users.sf.net>

	* Makefile.in: 'make install-fb' error is fixed.

	* version.h.in: 3.5.0 -> 3.5.0post

2015-06-07  Araki Ken  <arakiken@users.sf.net>

	* 3.5.0 released.
	  (tag "rel-3_5_0")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h, doc/en/ReleaseNote:
	  updated for 3.5.0.

2015-06-06  Araki Ken  <arakiken@users.sf.net>

	* fb/x_window.c: x_window_move() doesn't redraw screen if the area of
	  child windows fills less than 90% of a parent window.

	* fb/x_display.c: expose_window(all child winodws) in expose_display().

	* x_im_{candidate|status}_screen.c: The change at 2015/05/06 is reverted.

2015-05-31  Araki Ken  <arakiken@users.sf.net>

	* x_layout.c:
	  - If x_layout_t has multiple x_screen_t windows which have a wall picture,
	    x_layout_t plunders it.
	  - total_min_size() -> total_hint_size().

	* x_screen.[ch]: x_screen_reload_color_cache() is added.

	* x_window.h, */x_window.c:
	  - do_expose is added to arguments of x_window_(un)set_wall_picture().
	  - If wall picture is set to a root window, ParentRelative is set to
	    its child windows.
	  - configure_root is added to x_window_t for xlib.

2015-05-26  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, etc/README.ja: Updated.

	* x_screen.[ch], x_shortcut.[ch], x_screen_manager.c:
	  - HEXPAND_SCREEN and VEXPAND_SCREEN are added to shortcut keys.
	  - NEXT_SCREEN, PREV_SCREEN, CLOSE_SCREEN, HEXPAND_SCREEN, VEXPAND_SCREEN
	    shortcuts are ignored if screen isn't splited.

	* x_layout.c: The position of a separator is adjusted to cell width and height.

	* fb/x_window.c: x_window_update() and x_window_update_all() do nothing if
	  x_window_t::is_mapped is 0.

	* vte.c: "MLTERM=X.X.X" environmental variable is set in ml_term_open_pty_wrap().

	* ml_pty_unix.c: "goto return_pty" is called after putenv(), not before it.

2015-05-17  Araki Ken  <arakiken@users.sf.net>

	* README.ja: Updated.

2015-05-12  Araki Ken  <arakiken@users.sf.net>

	* x_layout.c:
	  x_window_fill() -> x_window_fill_with( x_layout_t::screen::window::fg_color)

2015-05-10  Araki Ken  <arakiken@users.sf.net>

	* x_main_config.[ch], x_screen_manager.c: use_scrollbar -> use_mdi

	* x_screen.c: "next_screen" is added to OSC 5379.

	* x_screen.c, x_screen_manager.c, x_layout.[ch], x_shortcut.[ch]:
	  - hsplit or hresize <=> vsplit or vresize
	  - PREV_SCREEN is added to shortcut key settings.

	* x_layout.c:
	  - Slightly broken screen in changing the position of a scrollbar is fixed.
	  - struct terminal::sb_mode is inherited from a current terminal in
	    x_layout_add_child().

	* win32/x_xic.c: If a specified window has focus, get_spot() returns cursor
	  position relative to it.

	* */x_window.c, x_window.h:
	  - x_window_move() returns 0 if both win->x and win->y aren't changed.
	  - x_window_t::has_input_focus -> inputtable.

	* win32/x_window.c: x_window_update_all() calls InvaidateRect(NULL).

	* ml_line_iscii.c: Compiling error is fixed.

2015-05-07  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, doc/ja/README.ja, etc/key: Updated.

	* jni/x_display.c: Henkan or Muhenkan keycode from Nihongo Full Keyboard
	  is supported.

	* x_layout.c: Minor fixes.

	* jni/x_event_source.c: Minor fixes.

2015-05-06  Araki Ken  <arakiken@users.sf.net>

	* doc/en/PROTOCOL, man/mlterm.1, ja/README.ja: Updated.

	* x_screen.[ch], x_screen_manager.c, x_shortcut.c:
	  - VRESIZE_SCREEN and HRESIZE_SCREEN shortcuts are supported.
	  - "vsplit_screen", "hsplit_screen", "vresize_screen" and "hresize_screen"
	    are added to OSC 5379.

	* x_shortcut.[ch]: The default shortcut keys are changed as follows.
	  VSPLIT_SCREEN: Ctrl+F5 -> Shift+F1
	  HSPLIT_SCREEN: Ctrl+F6 -> Shift+F2

	* x_layout.[ch]:
	  - x_layout_resize() and x_layout_get_next_screen() are added.
	  - sep_str is added to the arguments of x_layout_add_child().
	  - get_separator_x() round sep_x to multiples of 8 on 8 planes framebuffer.

	* fb/x_window.c, xlib/x_window.c, win32/x_window.c, x_window.h:
	  x_window_set_input_focus() is added.

	* fb/x_window.c: If x_window_move() moves a window outside of the display,
	  it doesn't try to redraw a window.

	* x_im_{candidate|status}_screen.c: adjust_window_position_by_size() adjusts
	  an input method window within x_screen_t::x_window_t::{x|y|width|height}
	  instead of x_display_t::{width|height} on framebuffer.

	* x_virtual_kbd.c: Compiling error is fixed.

2015-05-05  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.[ch]:
	  https://gist.github.com/saitoha/4b320b9cb6d637d14dbc is merged.

2015-05-03  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, doc/ja/README.ja: Updated.

	* MLActivity.java, jni/x_display.[ch], fb/x_window.c:
	  Copy&paste via clipboard is supported.

	* jni/x_event_source.c:
	  - update_ime_text_on_active_term() searches not only attached but also
	    focused window.
	  - ALooper_removeFds() is called everytime before closing fds in
	    x_event_source_process().

	* mkf_*_conv.c: mkf_parser_reset() -> mkf_parser_full_reset().

	* mkf_parser.c: mkf_parser_full_reset() which resets ml_parser_t::is_eos
	  is added.

	* mkf/lib/Makefile.in: 16.0 -> 16.1

	* win32/x_window.c:
	  - x_window_remove_child() is added.
	  - SetFocus() is called in receiving Button1 event.

	* x_im_{candidate|status}_screen.c: Compiling error is fixed.

	* x_shortcut.[ch], x_screen.c: CLOSE_SCREEN shortcut is supported.

	* x_layout.c: The size of a removed child window is reverted to the original
	  in x_layout_remove_child().

	* x_main_config.c: "exec_cmd" option is avalable in ~/.mlterm/main.

	* x_screen_manager.c: Fixes for win32.

2015-04-30  Araki Ken  <arakiken@users.sf.net>

	* x_sb_screen.[ch]: renamed to x_layout.[ch].

2015-04-29  Araki Ken  <arakiken@users.sf.net>

	* x_screen_manager.c: x_system_event_listener_t::split_screen is implemented.

	* x_screen.[ch], x_shortcut.[ch]:
	  - VSPLIT_SCREEN and HSPLIT_SCREEN shortcuts are supported.
	  - split_screen is added to x_system_event_listener_t.

	* x_sb_screen.[ch]: It is supported to manage multiple sets of screen
	  and scrollbar.

	* x_window.h, xlib/x_window.c:
	  - has_input_focus is added to x_window_t.
	  - x_window_t::is_focused is off except when x_window_t::has_input_focus is on.

	* fb/x_window.c:
	  - focus_window() which focuses a specified window is called when
	    mouse button is clicked on it and when x_window_map() is called.
	  - x_window_remove_child() is added.
	  - input_focus is added to arguments of x_window_init().

	* win32/x_window.c: input_focus is added to arguments of x_window_init().

	* fb/x_display.c: get_window() searches child windows recursively.

2015-04-18  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c: GetDC/ReleaseDC are called in draw_preedit_str().

	* im_wnn.c:
	  - Ctrl+c or Ctrl+g cancels preediting.
	  - Current mode (Kana or Kanji) is shown if there is no preedited text.

2015-04-13  Araki Ken  <arakiken@users.sf.net>

	* im_wnn.c:
	  - Preedit characters are fixed when a new character is inserted if
	    jcIsConverted() is true.
	  - Candidate window is changed correctly in changing a candidate word
	    by XK_Up.

2015-04-13  Araki Ken  <arakiken@users.sf.net>

	* im_wnn.c: Sign characters are converted to full width.

2015-04-12  Araki Ken  <arakiken@users.sf.net>

	* README, README.ja, man/mlterm.1: Updated.

	* configure.in: --enable-wnn is added.

	* input_method/wnn/*: Added.

	* im_canna.c: Cleanup.

	* mkf_parser.c: mkf_parser_reset() resets parser->is_eos.

2015-04-07  Araki Ken  <arakiken@users.sf.net>

	* configure.in: --enable-canna is added.

	* x_im_status_screen.[ch]:
	  - modified_beg is added to arguments of draw_screen().
	  - It is supported to draw multiple lines by '\n'.

	* inputmethod/canna/*: Added.

	* im_fcitx.c: Candidate or preedited text is converted to a terminal encoding.

2015-03-24  Araki Ken  <arakiken@users.sf.net>

	* im_fcitx.c, im_ibus.c: Minor fixes.

2015-03-22  Araki Ken  <arakiken@users.sf.net>

	* x_display_linux.c: Hack for HankakuZenkaku key is added.

	* im_ibus.c:
	  - The argument of next_engine() is changed from im_ibus_t * to IBusInputContext *.
	  - ibus->is_enabled is reversed in switch_mode() on IBus 1.5.x.

2015-03-21  Araki Ken  <arakiken@users.sf.net>

	* MLActivity.java: /sdcard/.mlterm/anim*.gif isn't splited any more.

2015-03-20  Araki Ken  <arakiken@users.sf.net>

	* x_picture.c: HAVE_PTHREAD is defined on android.

	* x_display.c, MLActivity.java: hashPath() -> convertToTmpPath() in order to
	  support not only /sdcard but also /mnt/sdcard and /extsdcard.

	* jni/Android.mk: -DBUILTIN_IMAGELIB is added.

2015-03-18  Araki Ken  <arakiken@users.sf.net>

	* kik_path.c, android/jni/x_display.c:
	  HOME directory on android is /sdcard, /mnt/sdcard or /extsdcard.

	* jni/Android.mk, build.sh: Minor fixes.

	* ml_screen.c, ml_vt100_parser.c: The previous commit is partially reverted.

2015-03-17  Araki Ken  <arakiken@users.sf.net>

	* x_event_source.c: If ml_pty_ssh_poll() > 0, ml_pty_ssh_send_recv_x11() and
	  ml_term_parse_vt100_sequence() are called immediately instead of 'break'
	  in order not to skip select().

	* ml_screen.[ch]:
	  - gettimeofday() is used instead of clock() in
	    ml_screen_enable_local_echo() and ml_screen_local_echo_wait().
	  - ml_stored_edit stores a current edit, not both normal and alt edits.
	  - ml_screen_is_local_echo_mode() is added.

	* kiklib/configure.in, kik_config.h.in, android/jni/kik_config.h:
	  Whether gettimeofday exists or not is checked. (HAVE_GETTIMEOFDAY macro)

	* xlib/x_connect_dialog.c: Memory leak is fixed.

	* libptyssh/ml_pty_ssh.c, ml_pty.c, ml_vt100_parser.c: Minor fixes.

2015-03-15  Araki Ken  <arakiken@users.sf.net>

	* x_display_wscons.c: WSDISPLAYIO_GET_FBINFO is supported.

	* Usage.win32: Updated.

	* version.h.in: 3.4.5 -> 3.4.5post

2015-03-14  Araki Ken  <arakiken@users.sf.net>

	* 3.4.5 released.
	  (tag "rel-3_4_5")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h, doc/en/ReleaseNote:
	  updated for 3.4.5.

	* ml_vt100_parser.c: to_menu = -1 (show key=value temporarily on the screen)
	  only if OSC 5380.

	* libptyssh/ml_pty_ssh.c:
	  - If waitpid() == config_menu.pid and kik_trigger_sig_child() is called,
	    lo_{read|write_to}_pty() returns without reading pty->master or writing
	    to pty->slave because kik_trigger_sig_child() disables loopback.
	  - libssh2_channel_request_auth_agent is called if its symbol is found in
	    cygssh2-1.dll on cygwin.

	* x_display_{linux|freebsd|wscons}.c: open(FRAMEBUFFER) is held between
	  kik_priv_restore_{euid|egid}() and kik_priv_change_{euid|egid}().

2015-03-10  Araki Kena  <arakiken@users.sf.net>

	* 3.4.4 released.
	  (tag "rel-3_4_4")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h, doc/en/ReleaseNote:
	  updated for 3.4.4.

	* x_shortcut.c: "Alt" which equals to "Mod" is available in ~/.mlterm/key.

2015-03-08  Araki Ken  <arakiken@users.sf.net>

	* mlclient/Makefile.in, mlclient/main.c:
	  - mlclient doesn't depend on kiklib.
	  - ~/.config/mlterm/socket is supported.

	* mlcc/data_entry_numeric.c: entry_numeric_reset() does nothing for "alpha".

	* mlcc/comm.c:
	  - ~/.config/mlterm/challenge is supported.
	  - OSC 5380 is sent without challenge if mlcc works on a remote host.

	* mlcc/comm.h: _COMM_H -> _COMM_H_

	* mlcc/Makefile, mlclient/Makefile: Added. (For building mlcc or mlclient alone.)

	* x_screen.c, MLTermPty.c: ml_pty_event_listener_t::show_config is implemented.

	* ml_vt100_parser.c:
	  - If OSC 5380 is received without challenge, to_menu = -1 which calls
	    ml_pty_event_listener_t::show_config.
	  - vt100_parser->cs is set before ml_convert_to_internal_ch().
	  - ml_vt100_parser_show_message() calls {start|stop}_vt100_cmd() with
	    trigger_xterm_event == 0.

	* ml_pty.[ch]: show_config is added to ml_pty_event_listener_t.

	* mkf_utf8_parser.c, mkf_utf8_conv.c, mkf_utf16_parser.c, mkf_utf16_conv.c,
	  mkf_utf32_parser.c, mkf_utf32_conv.c:
	  0x0 - 0x7f characters are treated as US_ASCII instead of ISO10646_UCS4_1.

	* mkf_iso8859_conv.c, mkf_ja_jp_map.c, mkf_ko_kr_map.c, mkf_ru_map.c,
	  mkf_tg_map.c, mkf_ucs4_jisx0201.c, mkf_ucs4_map.c, mkf_uk_map.c,
	  mkf_viet_map.c, mkf_zh_cn_map.c, mkf_zh_hk_map.c, mkf_zh_tw_map.c:
	  mkf_map_ucs4_to_us_ascii() and mkf_map_us_ascii_to_ucs4() are removed.

	* mkf_ucs4_usascii.[ch]: Removed.

	* configure.in: mlclient is not built on win32 mingw.

2015-03-06  Araki Ken  <arakiken@users.sf.net>

	* gtk/INSTALL: Updated.

	* gtk/reaper.c: Compiling error on vte-2.91 is fixed.

	* win32/x_window.c: Extra margin area at the right and bottom edges is cleared
	  in maximizing a window.

	* mc_combo.c: gtk_entry_set_width_chars() is used on GTK+-3.x instead of
	  gtk_widget_set_size_request().

	* mlconfig/main.c: Failure in compiling with GTK+-3.x and libssh2 is fixed.

	* x_screen_manager.c: The same command as the current screen is executed
	  in open_{screen|pty}().

	* ml_term.h: ml_term_get_cmd_line() is added.

	* ml_pty.[ch]: ml_pty_get_cmd_line() is added.

	* libptyssh/ml_pty_ssh.c: ml_pty_t::cmd_line is stored.

	* ml_pty_intern.h: cmd_line is added to ml_pty_t.

	* vte.c: vte_terminal_set_font_from_string() accepts "[FONT LIST] [FONT SIZE]" format.

	* configure.in:
	  - Both gtk+-2.0 and gtk+-3.0 are checked.
	  - The default value of --with-gtk option is changed from 2.0 to 3.0.

2015-03-03  Araki Ken  <arakiken@users.sf.net>

	* ml_edit_scroll.c: scroll_region_{beg|end} => vmargin_{beg|end}

	* mlclien/main.c, mlclient/Makefile.in:
	  https://gist.github.com/hattya/97df7df875d72d8030bb is merged.
	  (Thanks to @hattya)

2015-03-01  Araki Ken  <arakiken@users.sf.net>

	* ml_edit.c: Minor fix of copy_area().

	* ml_char.c: Arguments of COMPOUND_ATTR() are fixed.

2015-02-28  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.c: DECBI, DECFI, DECIC, DECDC, DECST8C, DECSACE,
	  DECRARA and DECCARA are supported.

	* ml_screen.c: 'scroll' argument is added to ml_screen_go_{forward|back}().

	* ml_edit.[ch]:
	  - ml_edit_scroll_{left|right}ward_from_cursor() are added.
	  - ml_edit_change_attr_area() is added.
	  - ml_edit_set_use_rect_attr_select() is added.
	  - {h|v}margins are applied in ml_edit_go_forward().
	  - scroll_region_{beg|end} => vmargin_{beg|end}
	    margin_{beg|end} => hmargin_{beg|end}

	* ml_line.c: ml_line_{overwrite|fill}() allows 'beg_char_index' argument
	  to exceed line->num_of_filled_chars.

	* ml_char.[ch]: ml_char_{change|reverse}_attr() are added.

2015-02-25  Araki Ken  <arakiken@users.sf.net>

	* gtk/INSTALL: Updated.

	* ml_term_manager.c, xlib/x_window.c: Minor fixes.

2015-02-22  Araki Ken  <arakiken@users.sf.net>

	* vte.c: vte_get_{major|minor|micro}_version() are implemented.

2015-02-22  Araki Ken  <arakiken@users.sf.net>

	* vte.c: gtk_widget_set_visual(toplevel window, rgba_visual) is called
	  in vte_terminal_hierarchy_changed() to enable true transparency forcibly
	  on vte-2.91.

2015-02-21  Araki Ken  <arakiken@users.sf.net>

	* configure.in:
	  LIBVTE_SUFFIX=2.91 -> LIBVTE_SUFFIX=-2.91

	* vte.c:
	  - Compiling error in vte_terminal_feed() is fixed.
	    (enbugged at the previous commit.)
	  - vte_terminal_get_geometry_hints() is implemented.
	  - vte_terminal_{set|get}_input_enabled() are added.
	  - vte_terminal_screen_changed() event handler is added.
	  - "inner-border" style is removed since vte 0.38.0.

	* vtetypebuiltins.c: vte-2.91 types are added.

2015-02-20  Araki Ken  <arakiken@users.sf.net>

	* gtk/INSTALL: Updated.

	* man/mlterm.1, doc/ja/README.ja, etc/main, etc/main.ja: Updated.

	* x_window.c, x_main_config.c: The default value of "use_clipboard" option is
	  changed from "false" to "true".

	* x_screen.c: "Config: key=value" is shown if configuration is changed by
	  "proto:" shortcut.

	* ml_vt100_parser.[ch], ml_term.h:
	  ml_{vt100_parser|term}_show_message() is added.

	* ml_term.h:
	  (term)->pty check is added to ml_term_write_{modified_key|special_key|loopback}().

2015-02-19  Araki Ken  <arakiken@users.sf.net>

	* xlib/x_window.c: size_hints.min_width and min_height are fixed.

	* gtk/INSTALL: Updated.

	* configure.in: vte-2.91 api functions are added partially.

	* vte.c:
	  - vte-2.91 is supported. (Experimental)
	  - Following functions are implemented.
	    vte_terminal_feed
	    vte_terminal_feed_child
	    vte_terminal_feed_child_binary
	    vte_terminal_set_scroll_on_output
	    vte_terminal_write_contents(_sync)
	  - window.width_inc,min_width,height_inc,min_height are reset in
	    vte_terminal_set_font_from_string().
	  - g_object_ref(terminal->pvt->pty) is replaced by g_object_ref(pty) in
	    vte_terminal_set_pty(_object)().

	* kik_pty_helper.c:
	  - kill(pty_helper_pid, SIGTERM) isn't called by child processes.
	  - setsid() and setpgid() are moved after reopening pty like vte-0.39.1/src/pty.c.

	* version.h.in: 3.4.3 -> 3.4.3post

2015-02-11  Araki Ken  <arakiken@users.sf.net>

	* 3.4.3 released.
	  (tag "rel-3_4_3")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h, doc/en/ReleaseNote:
	  updated for 3.4.3.

	* mlterm.1, doc/en/PROTOCOL: Updated.

	* fb/x_font.[ch], fb/x_window.c, fb/x.h, android/jni/x.h:
	  - USE_ANTI_ALIAS is removed and is_aa flag is added to XFontStruct.
	  - Fixes for rendering proportional fonts.

	* x_draw_str.c: If xfont->is_proportional is true (== ISCII),
	  x_window_draw_string() with x_window_clear() is used instead of
	  x_window_draw_image_string().

	* bengali.table: Add an entry.

2015-02-05  Araki Ken  <arakiken@users.sf.net>

	* jni/x_event_source.c: Minor fixes.

2015-02-04  Araki Ken  <arakiken@users.sf.net>

	* ml_pty_unix.c: kik_killpg(SIGWINCH) is used instead of kill(SIGWINCH).

	* jni/x_event_source.c: need_resize() is implemented and passed to x_display_resize().

	* android/jni/x_display.[ch]: need_resize is added to the arguments of x_display_resize().

	* kik_unistd.h: kik_killpg is added.

	* kik_config.h.in, android/jni/kik_config.h: HAVE_KILLPG is added.

	* kiklib/configure.in: killpg is added to AC_CHECK_FUNCS().

	* MLActivity.java: finishComposingText() is revived.

2015-02-02  Araki Ken  <arakiken@users.sf.net>

	* ml_screen.c: ml_str_bytes_equal() check is enabled in ml_screen_disable_local_echo().

	* android/jni/x_event_source.c: Current preediting text is restored
	  after ml_term_parse_vt100_sequence().

2015-02-01  Araki Ken  <arakiken@users.sf.net>

	* README.android: Updated.

	* MLActivity.java: forceAsciiInput() which x_xic_switch_mode() uses is added.

	* android/jni/x_xic.c: Added.

2015-01-31  Araki Ken  <arakiken@users.sf.net>

	* x_event_source.c:
	  - ml_term_set_config("use_local_echo", "false") is called before
	    ml_term_parse_vt100_sequence() if term->use_local_echo is true.
	  - Java_mlterm_native_1activity_MLActivity_{commit|preedit}Text()
	    calls update_ime_text() with the use of pthread_mutex_lock().

	* android/jni/x_display.[ch], x_event_source.c:
	  Java_mlterm_native_1activity_MLActivity_visibleFrameChanged() is moved to
	  x_event_source.c while its implementation is left as x_display_resize().

	* MLActivity.java: visibleFrameChanged() is called even if isPreediting is true.

2015-01-28  Araki Ken  <arakiken@users.sf.net>

	* README.ja, man/mlterm.1: Updated.

	* doc/ja/README.w3m: Removed.

	* MLActivity.java: visibleFrameChanged() is not called if isPreediting is true.

	* x_event_source.c: ALooper_wake() is removed and pthread_mutex_{un}lock()
	  are called before and after changing commit_text and preedit_text.

	* x_main_config.c:
	  - The default value of "only_use_unicode_font" is "true" on Android.
	  - The default value of "box_drawing_font" is "unicode" on Android.

2015-01-25  Araki Ken  <arakiken@users.sf.net>

	* fb/x_font.c: percent = 0 in x_font_new() on android.

	* etc/main, etc/main.ja: Updated.

	* ml_term.c: ml_logvis_ctl is created if terminal encoding is not only UTF-8
	  but also ISCII_XXX.

2015-01-24  Araki Ken  <arakiken@users.sf.net>

	* README, PROTOCOL, README.android, README.indic, README.ja, man/mlterm.1:
	  Updated.

	* android/jni/main.c, MLActivity.java: unifont.pcf is not saved in starting.

	* vte.c: Minor fixes.

	* mc_flags.[ch]: MC_FLAG_BIDI and MC_FLAG_IND are integrated to MC_FLAG_CTL.

	* mc_bidi.[ch]: Renamed to mc_ctl.[ch].

	* x_main_config.[ch], x_screen.c, x_screen_manager.c, ml_term.[ch],
	  ml_term_manager.[ch], ml_vt100_parser.[ch]:
	  "use_bidi" and "use_iscii" are integrated to "use_ctl".

	* ml_line.c:
	  - ml_line_unuse_ctl() and ml_line_ctl_{render|visual|logical}() are added.
	  - shape argument is remove from ml_line_shape().

	* ml_ctl_loader.h, ml_functbl_bidi.c:
	  - ml_logvis_bidi_new and ml_arabic_shape_new are removed and ml_shape_arabic
	    and ml_line_bidi_{render|visual|logical} are added.
	  - CTL_API_VERSION is changed from 0x01 to 0x02.

	* ml_logical_visual.[ch]: Add ml_ctl_logical_visual which is integrated from
	  ml_bidi_logical_visual and ml_iscii_logical_visual.

	* ml_logical_visual_{bidi|iscii}.c: Removed.

	* ml_shape_bidi.c, ml_shape_iscii.c, ml_shape.[ch]:
	  ml_shape_t is removed. ml_shape_{arabic|iscii}() are added.

	* libctl/ml_iscii.c, libctl/ml_line_iscii.c: If ISO10646_UCS4_1 charset is
	  found and ISCII_XXX charset is not found, ml_iscii() and ml_line_iscii_render()
	  return -1.

	* libctl/ml_bidi.c, libctl/ml_line_bidi.c: If ISCII_XXX charset is found,
	  ml_bidi() and ml_line_bidi_render() return -1.

	* ml_screen.c: ml_screen_resize() resizes ml_screen_t::stored_edits.

2015-01-20  Araki Ken  <arakiken@users.sf.net>

	* doc/en/README.indic: Updated.

	* etc/aafont: U+FF61-FF9F (Hankaku kana) is added.

	* etc/font-fb: ISCII fonts are added.

	* Android.mk: Files and options related to ISCII rendering are added.

	* libctl/ml_iscii.c: Indic tables are statically linked if STATIC_LINK_INDIC_TABLES
	  macro is defined. (for Android)

	* ml_iscii.c: If both NO_DYNAMIC_LOAD_CTL and USE_IND are defined,
	  #include "libctl/ml_iscii.c".

	* mc_font.c: "UNICODE (HANKAKU KANA)" is added to "Font name" combo box.

	* fb/x_font.c: Unexpected behavior in loading a ISCII font in multiple times
	  is fixed.

	* fb/x_window.c: Minor fixes.

	* x_screen.c: Not only png but also gif files are supported for emoji.

	* Makefile.in: Typo is fixed. (Thanks to @msmhrt)

2015-01-18  Araki Ken  <arakiken@users.sf.net>

	* doc/en/README.fb, doc/ja/README.fb, doc/en/README.android:
	  Updated.

	* im_fcitx.c: The position of a candidate window is fixed. (Thanks to @msmhrt)

	* fb/x_font.c, fb/x_window.c: ISCII fonts are supported with freetype.

2015-01-12  Araki Ken  <arakiken@users.sf.net>

	* doc/en/README.fb, doc/ja/README.fb, doc/en/README.android:
	  Updated.

	* x_font_config.c: The default value of "font_size_range" option is changed
	  from 6-30 to 10-40 on Android.

	* configure.in, main/Makefile.in, xwindow/Makefile.in:
	  --enable-anti-alias option of configure enables freetype on framebuffer.

	* Android.mk: freetype support is enabled.

	* fb/x_font.[ch], fb/x_window.c: freetype2 is supported.

	* fb/x_font.c: font->is_var_col_width works if multiple size fonts are used
	  at the same time.

	* fb/x.h, android/jni/x.h: FT_Face is stored in XFontStruct.

	* x_screen.c, x_font_manager.h: "USASCII" key is supported by OSC 5380 and
	  5381.

	* ml_vt100_parser.c: OSC 5380 and 5381 doesn't require ",<fontsize>" which
	  is automatically complemented by the current font size.

2015-01-07  Araki Ken  <arakiken@users.sf.net>

	* win32/x_imagelib.c:
	  - It is enabled to show regis without mlimgloader.exe.
	  - *mask = NULL after LoadImage() succeeds.

	* main_loop.c: Not only DEFAULT but also ISO10646_UCS4_1 font setting is
	  customized by --deffont option.

	* vte.c: Not only DEFAULT but also ISO10646_UCS4_1 font setting is
	  customized by vte_terminal_set_font_from_string().

	* c_regis.c: Separated from c_imagelib.c.

	* version.h.in: 3.4.2 -> 3.4.2post

2015-01-06  Araki Ken  <arakiken@users.sf.net>

	* 3.4.2 released.
	  (tag "rel-3_4_2")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h, doc/en/ReleaseNote:
	  updated for 3.4.2.

	* mlterm.1, doc/en/PROTOCOL: Updated.

	* ml_config_menu.c: On cygwin and msys menu programs exist in /bin
	  instead of LIBEXECDIR/mlterm directory.

2015-01-04  Araki Ken  <arakiken@users.sf.net>

	* ml_termcap.c, win32/x.h, win32/x_window.c, x_screen.c:
	  Compiling error is fixed.

2015-01-04  Araki Ken  <arakiken@users.sf.net>

	* gtk/vte.c: vte_terminal_set_scrollback_lines() is implemented.

	* mlconfig/main.c: mc_char_width_config_widget_new() and
	  mc_flag_config_widget_new(MC_FLAG_STATICBACKSCROLL) are used.

	* mc_font.c: "Unicode areas you won't convert to other charsets" entry is added.

	* mc_flags.[ch]: MC_FLAG_STATAICBACKSCROLL is added.

	* mc_unicode_areas.[ch], mc_char_width.[ch]: Added.

	* ml_vt100_parser.[ch]:
	  - "unicode_noconv_areas" and "unicode_full_width_areas" are added to
	    OSC 5380 or 5381.
	  - ml_get_backscroll_mode() is used for OSC 5380 or 5381 "static_backscroll_mode"
	    instead of ml_screen_is_backscrolling().
	  - ml_vt100_parser_{init|final}() are added.

	* ml_screen.h:
	  ml_get_backscroll_mode() is added.

	* ml_pty_ssh.c:
	  ml_pty_ssh_t::doing_scp is renamed to ml_pty_ssh_t::suspended, and
	  ml_pty_ssh_t::suspended = 1 in use_loopback().

	* ml_term.c:
	  - ml_term_final() is added.
	  - The order of arguments of ml_screen_new() is fixed.
	  - ml_search_ssh_session(host,port,user) -> ml_search_ssh_session(server,port,user)

2014-12-29  Araki Ken  <arakiken@users.sf.net>

	* x_font_ft.c, x_window_cairo.c: The performance of drawing proportional
	  font's glyphs is improved.

	* ml_char_encoding.c: ml_parse_unicode_area() parses not only "U+NNNN-NNNN"
	  but also "U+NNNN".

	* fb/x_window.c: Shift + Tab works.

	* win32/x_window.c, win32/x_xic.c: Ctrl or Shift + Tab works.

	* ml_vt100_parser.[ch]: CSI?8452h, CSI?8452l CSI?117h and CSI?117l are supported.

	* ml_screen.h, ml_edit.h: ml_{edit|screen}_set_use_bce() are added.

2014-12-27  Araki Ken  <arakiken@users.sf.net>

	* ml_pty_ssh.c:
	  - Compiling error when OPEN_PTY_ASYNC is not defined is fixed.
	  - libssh2_channel_open_ex(window_size = 64 * LIBSSH2_CHANNEL_PACKET_DEFAULT)
	    is called instead of libssh2_channel_open_session() in order to
	    improve performance.

	* win32/x_window.c, win32/x_xic.c:
	  Ctrl+0, Ctrl+1, Ctrl+9 and so on are processed for modify other keys.

	* MLTermPty.c, MLTerm.java, MLTermPty.java:
	  writeModifiedKey() and writeSpecialKey() are added to MLTermPty.
	  modifyOtherKeys feature is supported.

	* x_picture.c: Image files in ~/.mlterm/emoji are cachable.

	* ml_vt100_parser.[ch]:
	  - get_emoji_data() which is called in processing U+1F000-1F6FF is added
	    to ml_xterm_event_listener_t.
	  - tcap query is supported.
	  - DA2 response is changed from "1;96;0" to "1;277;0"
	  - DA response is changed from "1;2;4;7" to "1;2;3;4;7;29"
	  - ml_vt100_parser_write_modified_key() and ml_vt100_parser_write_special_key()
	    are added.

	* x_screen.[ch], x_screen_manager.c ml_term.[ch], ml_term_manager.c, vte.c:
	  x_termcap is replaced by ml_termcap.

	* ml_termcap.[ch]: Added.

	* x_termcap.[ch]: Removed.

2014-12-13  Araki Ken  <arakiken@users.sf.net>

	* mc_wordsep.c: Memory leak is fixed.

	* mc_bidi.[ch]: Added for "Separators" of BiDi.

	* ml_font.h: Fix FONT_STYLE_INDEX() macro. (Enbugged at 3.3.0)

	* kik_str.c: kik_str_replace() replaces multiple 'orig' strings by 'new'.

	* x_font_config.c, x_dnd.c: TEST_xxx functions are fixed.

	* kik_debug.h: KIK_TESTIT and KIK_TESTIT_ONCE are added.

	* kik_map.h: Minor fixes.

	* im_ibus.c, im_uim.c, kik_mem.c, kik_dlfcn_dyld.c:
	  Use kik_slist instead of kik_list.

	* kik_slist.h: Added.

	* kik_list.h, kik_iterator.h: Removed.

2014-12-07  Araki Ken  <arakiken@users.sf.net>

	* mlconfig/main.c: "Word separators" entry is added to "Others" tab.

	* mlconfig/mc_wordsep.[ch]: Added.

	* ml_term.c: "word_separators" is added to OSC 5380/5381.

	* ml_screen.[ch]: ml_get_word_separators() is added.

2014-12-04  Araki Ken  <arakiken@users.sf.net>

	* doc/en/ReleaseNote: Fix typo.

	* version.h.in: 3.4.1 -> 3.4.1post

2014-12-03  Araki Ken  <arakiken@users.sf.net>

	* 3.4.1 released.
	  (tag "rel-3_4_1")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h, doc/en/ReleaseNote:
	  updated for 3.4.1.

	* man/mlterm.1: Updated.

2014-12-02  Araki Ken  <arakiken@users.sf.net>

	* ml_pty_ssh.c: Minor fixes around handling error cases.

2014-11-30  Araki Ken  <arakiken@users.sf.net>

	* MLTerm.java: Null pointer exception in closing one of multiple opened
	  ptys is fixed.

	* c_sixel.c: Compiling error by g++ is fixed.

	* x_screen.c: SF Bug #72

2014-11-27  Araki Ken  <arakiken@users.sf.net>

	* mlconfig/main.c, mc_font.c: "Box drawing" and "Font policy" radio buttons
	  are moved from main.c to mc_font.c

	* mc_radio.[ch]:
	  - mc_is_vertical(), mc_always_unicode_font() and mc_never_unicode_font()
	    are removed.
	  - mc_radio_set_callback() and mc_radio_get_value() are added.

2014-11-25  Araki Ken  <arakiken@users.sf.net>

	* mc_im.c: "None" is removed from "Input Method" on win32.

	* x_xic.c: win->xic == NULL check is added.

2014-11-24  Araki Ken  <arakiken@users.sf.net>

	* ml_screen.c: line->num_of_filled_chars is reset by
	  ml_line_get_num_of_filled_chars_except_spaces_with_func(ml_char_equal)
	  instead of ml_line_get_num_of_filled_chars_except_spaces()
	  in receive_scrolled_out_line().

	* ml_line.[ch]: ml_line_get_num_of_filled_chars_except_spaces_with_func()
	  is added.

	* mc_im.c:
	  - get_kbd_info() which is implemented similarly to im_kbd_get_info()
	    is used if cygim-kbd.dll isn't found.
	  - If mlterm is built with win32gdi, "MS IME" is shown instead of "XIM".

	* mc_color.c: gdk_color_to_string() is added for gtk+ < 2.12.

	* mlconfig/main.c: mc_im_config_widget_new() is called if USE_WIN32GUI
	  is defined.

	* ml_term.h: ml_reset_pending_vt100_sequence() is called before
	  ml_start_config_menu().

	* ml_vt100_parser.c:
	  - ml_reset_pending_vt100_sequence() is called and sixel_scrolling is
	    set to 1 in OSC 5379 full_reset.
	  - Cursor position is not moved by soft_reset().

	* ml_edit.c: If use == -1, ml_edit_set_use_margin() resets states
	  except cursor position.

	* mlcc/comm.c: mlterm_get_color_param() is implemented.

	* im_kbd.c, im_uim.c, im_m17nlib.c: Fix memory leaks on error.

2014-11-23  Araki Ken  <arakiken@users.sf.net>

	* mc_color.[ch]: mc_{cursor|substitute}_color_config_widget_new(),
	  mc_vtcolor_config_widget_new(), mc_update_{cursor|substitute}_color()
	  and mc_update_vtcolor() are added.

	* mc_{letter|line}_space.[ch]: Integrated to mc_space.[ch].

	* mc_mod_meta.[ch], mc_vertical.[ch], mc_sb.[ch], mc_bel.[ch]:
	  Integrated to mc_radio.[ch].

	* mc_brightness.[ch], mc_contrast.[ch], mc_fade.[ch], mc_gamma.[ch],
	  mc_screen_ratio.[ch]: Integrated to mc_ratio.[ch].

	* mc_io.c: "font_policy" and "logging_vt_seq" wrappers are added to
	  mc_{set|get}_str_value().

	* ml_vt100_parser.[ch], x_screen.c: get_color is added to ml_config_event_listener_t.

	* ml_term.c, ml_vt100_parser.c: 'output' argument of ml_{term|vt100_parser}_get_config()
	  is NULL if term == output.

2014-11-19  Araki Ken  <arakiken@users.sf.net>

	* mc_font.c, mc_char_encoding.c: An appropriate character set is automatically
	  selected in selecting font on mlconfig according to a selected character
	  encoding.

	* ml_vt100_parser.c: ml_vt100_parser_t::is_auto_encoding is set in
	  ml_vt100_parser_new() and ml_vt100_parser_change_encoding().

	* mkf_ucs_property.table: Updated to Unicode 7.0.0 (UnicodeData.txt and
	  EastAsianWidth.txt)

2014-11-02  Araki Ken  <arakiken@users.sf.net>

	* ml_term.c, ml_vt100_parser.c: Pty to be responsed to by OSC 5381 is
	  fixed.

	* version.h.in: 3.4.0 -> 3.4.0post

2014-10-28  Araki Ken  <arakiken@users.sf.net>

	* 3.4.0 released.
	  (tag "rel-3_4_0")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h, doc/en/ReleaseNote:
	  updated for 3.4.0.

2014-10-28  Araki Ken  <arakiken@users.sf.net>

	* registobmp/main.c, Makefile.in: USE_WIN32API -> USE_WIN32GUI

2014-10-26  Araki Ken  <arakiken@users.sf.net>

	* etc/main, etc/main.ja, gtk/INSTALL, doc/ja/README.ja: Updated.

	* x_screen.c: change_true_transbg_alpha() is always called (except when
	  x_window_has_wall_picture() is true) even if screen->pic_mod.alpha == alpha.

	* vte.c:
	  - gdk_rgba_to_string() is replaced by gdk_rgba_to_string2() which returns
	    the format mlterm can recognize.
	  - vte_terminal_set_color_bold() and vte_terminal_set_color_bold_rgba() are
	    implemented.
	  - x_font_use_point_size_for_fc() -> x_font_use_point_size()
	    ml_term_set_winsize() is removed.

2014-10-25  Araki Ken  <arakiken@users.sf.net>

	* im_ibus.c: Cursor position passed to ibus_input_context_set_cursor_location()
	  is fixed.

2014-10-24  Araki Ken  <arakiken@users.sf.net>

	* c_sixel.c: Hue 120=Red, 240=Green, 0=Blue

	* man/mlterm.1: .TP was missing.

2014-10-19  Araki Ken  <arakiken@users.sf.net>

	* xlib/x_imagelib.c: kik_mem_malloc() etc are enabled if KIK_DEBUG is defined.

	* kik_mem.[ch]: kik_mem_remove() is added.

	* x_screen.c, x_screen_manager.c:
	  sixel_palette argument is added to get_picture_data().

	* ml_vt100_parser.[ch]:
	  - ml_vt100_parser_t::sixel_palette is added.
	  - sixel_palette argument is added to ml_xterm_event_listener_t::get_picture_data().

	* c_sixel.c, x_picture.h, fb/x_imagelib.c:
	  - "custom_palette" static variable is introduced and x_set_custom_sixel_palette()
	    is added.
	  - "#define color_tbl sixel_cmap" is removed.

2014-10-18  Araki Ken  <arakiken@users.sf.net>

	* c_sixel.c: HLS is supported.

	* im_ibus.c: Calling select(2) with an invalid file descriptor after
	  restarting ibus is fixed.

2014-10-17  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.[ch], x_screen.c: DECEFR is supported.

2014-10-13  Araki Ken  <arakiken@users.sf.net>

	* README, doc/ja/README.ja: Updated.

	* x_main_config.c: The default value of "type_engine" option is changed
	  from "xcore" to "xft".

	* configure.in: fribidi, xft and cairo are enabled by default.

	* im_ibus.c: "connected" and "disconnected" signals are handled.

2014-10-11  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c, x_picture.c: INLINEPIC_AVAIL_ROW is added.

2014-10-07  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c, x_picture.c: The previous fix is moved from x_picture.c
	  to x_screen.c.

2014-10-07  Araki Ken  <arakiken@users.sf.net>

	* x_picture.c: Inline pictures in back logs (except recent 1024 lines)
	  are removed.

2014-10-05  Araki Ken  <arakiken@users.sf.net>

	* ml_edit.c: Corrupt scrolling in Left-right margin which contains
	  full width characters is fixed.

2014-10-04  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c: event->state & ModMask => compare_key_state_with_modmap().

2014-10-02  Araki Ken  <arakiken@users.sf.net>

	* display.h, android/jni/x.h, fb/x.h, win32/x.h, win32/x_display.c,
	  xlib/x_display.c, x_scrollbar.c:
	  XC_sb_v_double_arrow is removed.

2014-09-28  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.c, ml_edit.h, ml_screen.h:
	  Auto wrap is disabled in putting sixel images to the screen.

2014-09-23  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.c: CSI>4p is changed to CSI>2p for Xsixel.

	* main_loop.c, x_font.h, win32/x_font.c, xlib/x_font.c:
	  - x_font_use_point_size_for_fc() is renamed to x_font_use_point_size().
	  - "use_point_size" option works on win32.

	* MLTermPty.c: Compiling error is fixed.

2014-09-22  Araki Ken  <arakiken@users.sf.net>

	* doc/ja/README.fb, doc/en/README.fb: Updated.

	* Makefile.in: Minor fix for install-fb target.

	* x_virtual_kbd.c, fb/x_display.c: Software keyboard area is correctly redrawn.

2014-09-22  Araki Ken  <arakiken@users.sf.net>

	* ml_term.c: Opening pty asynchronously is disabled in opening a new pty
	  channel on an exsiting session.

	* x_virtual_kbd.[ch], fb/x_display.c: Software keyboard is redrawn when
	  it is partially exposed.

	* fb/x_imagelib.c: Transparent pixels are replaced by the current background
	  color on 1bpp.

2014-09-21  Araki Ken  <arakiken@users.sf.net>

	* doc/en/README.fb, doc/ja/README.fb: Updated.

	* fb/x_display.c, fb/x_virtual_kbd.c: Software keyboard is available on
	  rotated display.

	* xlib/x_window.c: clear_margin_area() cleargs RIGHT_MARGIN and BOTTOM_MARGIN.

	* x_display_x68kgrf.c: _disp.height is replaced by _display.height to fix
	  segv in x68k_tvram_set_wall_picture().

	* ml_pty_ssh.c: libssh2_session_set_timeout(0) is called at the end of ssh_connect().

2014-09-20  Araki Ken  <arakiken@users.sf.net>

	* fb/x_window.c: x_window_bell() supports BEL_VISUAL.

	* xlib/x_window.c, fb/x_window.c:
	  x_window_blank() doesn't blank RIGHT_MARGIN and BOTTOM_MARGIN.

	* ml_pty_ssh.c: libssh2_session_set_timeout(10000) => libssh2_session_set_timeout(30000)

2014-09-18  Araki Ken  <arakiken@users.sf.net>

	* ml_pty.[ch], ml_pty_intern.h, ml_pty_ssh.c, ml_pty_pipewin32.c, ml_pty_unix.c,
	  ml_term.[ch], ml_term_manager.c, x_screen_manager.c:
	  width_pix and height_pix arguments are added to the functions opening pty.

	* ml_term.[ch]: ml_term_set_winsize() is removed.

	* ml_pty_ssh.c: libssh2_session_set_timeout(10000).

2014-09-14  Araki Ken  <arakiken@users.sf.net>

	* Makefile.in: "./configure;make install" executes "make all" automatically
	  before "make install".

	* ml_term_manager.c: Don't restart mlterm in segv twice or more times
	  if auto_restart=true.

2014-09-14  Araki Ken  <arakiken@users.sf.net>

	* ml_term_manager.c: Fix compiling error.

2014-09-13  Araki Ken  <arakiken@users.sf.net>

	* ml_pty.[ch], ml_pty_intern.h, ml_pty_unix.c, ml_term.[ch], ml_vt100_parser.c,
	  ml_screen.c, ml_screen_manager.c, ml_pty_ssh.c, MLTermPty.c, vte.c:
	  Window width and height by pixel are set to struct winsize::ws_{x|y}pixel.

2014-09-10  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c: ml_term_reset_pending_sequence() is called in pressing Pause key
	  instead of ESC key.

2014-09-07  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c: xterm_show_picture() is renamed to x_term_show_sixel()
	  and char_index, row and scrollable arguments are removed.

	* ml_vt100_parser.[ch]:
	  - ml_xterm_event_listener_t::show_picture is renamed to
	    ml_xterm_event_listener_t::show_sixel.
	  - ml_xterm_event_listener_t::show_sixel is called only if
	    sixel scrolling is off by OSC?80h.

2014-09-05  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.c: Clean up.

2014-09-03  Araki Ken  <arakiken@users.sf.net>

	* man/mlterm.1, doc/ja/README.ja: Updated.

	* main_loop.c: --point/use_point_size option is added.

	* mlterm/ml_vt100_parser.c:
	  - OSC>2p => OSC>4p
	  - show_picture() moves cursor in showing animation frames.

2014-09-02  Araki Ken  <arakiken@users.sf.net>

	* win32/x_display.h: Added.

	* win32/x_display.c: x_display_get_cursor() is added.

	* win32/x.h, fb/x.h: XC_sb_v_double_arrow and XC_left_ptr are defined
	  as the same value in X11/cursorfont.h.

	* xlib/x_window.c: x_window_set_cursor() calls XDefineCursor() in changing
	  the current cursor shape.

	* x_display.h: XC_nil which hides pointer is defined.

	* x_screen.c: xterm_show_picture() is added.

	* x_picture.[ch]: x_{load|delete}_tmp_picture() are added.

	* win32/x_window.c:
	  - x_window_copy_area() draws it directly without x_window_update().
	  - WM_SETCURSOR message is processed.

	* ml_vt100_parser.[ch]: Animation sixel frames are drawn by
	  ml_xterm_event_listener_t::show_picture instead of
	  ml_xterm_event_listener_t::get_picture_data.

	* ml_screen.[ch]: ml_screen_get_cursor_line(), ml_screen_go_horizontally()
	  and ml_screen_go_vertiacally() are changed from function to macro.

2014-08-26  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.c:
	  - DECLRP is returned by DECRQLP even if DECELR isn't sent.
	  - DECSLE accepts Pm instead of Ps.
	  - locator_mode is not reset by DECELR.

2014-08-24  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.c: vt100_parser->mouse_mode >= LOCATOR_CHARCELL_REPORT is
	  checked before responsing to the DECRQLP.

2014-08-24  Araki Ken  <arakiken@users.sf.net>

	* xlib/x_imagelib.c: load_sixel() is called regardless of BUILTIN_IMAGELIB.

	* x_screen.[ch], MLTermPty.c: The default value of prev_mouse_report_{col|row}
	  is changed from -1 to 0.

	* ml_vt100_parser.c: locator_mode is not checked if button == 0.

2014-08-23  Araki Ken  <arakiken@users.sf.net>

	* xlib/x_imagelib.c: Sixel graphics without any modifiers is processed in
	  mlterm instead of calling mlimgloader.

	* gdk-pixbuf.c: Compiling error with gdk-pixbuf-1.x is fixed.

	* x_screen.c, MLTermPty.c: ml_term_report_mouse_tracking() is used.

	* ml_term.h: ml_term_report_mouse_tracking() is added.

	* ml_vt100_parser.[ch]:
	  - DEC Locator is partially supported.
	  - ml_vt100_parser_report_mouse_tracking() is added.

	* version.h.in: 3.3.8 -> 3.3.8post

2014-08-16  Araki Ken  <arakiken@users.sf.net>

	* 3.3.8 released.
	  (tag "rel-3_3_8")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h, doc/en/ReleaseNote:
	  updated for 3.3.8.

	* etc/main, etc/main.ja: Updated.

2014-08-16  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.[ch]: Compiling error if mlterm is built without
	  --enable-ssh2 is fixed.

	* ml_pty_ssh.c: Hack for cygwin SIGCHLD is added.

	* win32/mlterm-msys_cygwin.bat, mlterm-win32.bat,
	  mlterm-xcygwin.bat, setup-cygwin.bat: Removed.

2014-08-12  Araki Ken  <arakiken@users.sf.net>

	* doc/ja/README.ja: Updated.

	* xlib/x_dnd.c, x_screen.c: DnD without Shift doesn't start scp.

	* fb/x_imagelib.c, win32/x_imagelib.c: Sixel parser is embeded instead of
	  using mlimgloader.

2014-08-09  Araki Ken  <arakiken@users.sf.net>

	* doc/ja/README.ja, man/mlterm.1: Updated.

	* x_screen.c: "scp" is executed in set_xdnd_config() if a local file is
	  dropped on ssh client window.

	* xlib/x_dnd.c: "text/uri-list" triggers set_xdnd_config("scp").

	* win32/x_dnd.c: Shift+DnD triggers set_xdnd_config("scp").

	* ml_term.h: ml_term_exec_cmd() and ml_term_scp() are added.

	* ml_vt100_parser.[ch]: ml_vt100_parser_exec_cmd() is added.

	* libptyssh/ml_pty_ssh.c, ml_pty_ssh.c:
	  - read/write on ssh session is blocked while scp thread is working.
	  - Outputting "SCP: src -> dst" message is moved from ml_pty_ssh.c to
	    libptyssh/ml_pty_ssh.c

2014-08-06  Araki Ken  <arakiken@users.sf.net>

	* win32/x_imagelib.c: CreateProcess() => CreateProcessW()

	* gdiplus.cpp:
	  - mbstowcs() => MultiByteToWideChar()
	  - CommandLineToArgvW(GetCommandLineW()) is used.

	* ml_pty_ssh.c:
	  - IS_RELATIVE_PATH() => IS_RELATIVE_PATH_UNIX().
	  - scp works fully from mlconfig even if use_scp_full = false.

	* kik_path.h: IS_RELATIVE_PATH_{DOS|UNIX}() are added.

	* mlconfig/main.c: gtk_window_set_keep_above() is removed.

	* ml_config_menu.c: close(STDERR_FILENO) is added.

	* mc_wall_pic.c, gdiplus.cpp: Change of mc_wall_pic.c at 2014-08-03 is reverted,
	  and strchr(path,'/') is checked before cygwin_conv_to_win32_path() in gdiplus.cpp.

2014-08-03  Araki Ken  <arakiken@users.sf.net>

	* mlconfig/po/*.po: Updated.

	* mlconfig/main.c, mc_flags.[ch]: "Local echo" checkbox is added to "Others" tab.

	* mc_bel.c, mc_mod_meta.c: The position of showing label is adjusted.

2014-08-03  Araki Ken  <arakiken@users.sf.net>

	* mc_wall_pic.c: escape_path() is added for win32.

	* doc/en/PROTOCOL: Updated.

	* MLTermPty.c, gtk/vte.c: Minor fixes.

	* win32/x_font.c, libtype/x_font_ft.c: Font name like "Hoge 0" is parsed
	  correctly and "0" is ignored.

	* x_screen.[ch]: x_system_event_listener_t::get_pty() and ::pty_list() are
	  removed and ml_get_term() and ml_get_pty_list() are called from x_screen.c
	  directly.

	* ml_vt100_parser.[ch], ml_term.[ch], ml_term_manager.[ch], x_screen.c:
	  - ml_{term|vt100_parser}_{set|get}_config() are added.
	  - {get|set}_config in x_screen.c calls ml_term_{set|get}_config().
	  - use_auto_detect and logging_vt_seq arguments are added to ml_create_term(),
	    ml_term_new() and ml_vt100_parser_new().

	* ml_pty.[ch], ml_pty_intern.h:
	  - ml_config_menu is managed by ml_pty instead of ml_term.
	  - ml_response_config() is added.

	* ml_config_proto.[ch]:
	  - ml_get_proto_challenge() is added.
	  - ml_parse_proto_prefix() returns 1 instead of 0 if dev is not found in
	    the sequence.

	* ml_edit.c: The result of https://gist.github.com/ttdoda/5798565
	  and https://gist.github.com/ttdoda/5902671 becomes the same as TeraTerm.
	  (Compatibility with VT525 is improved.)

2014-07-28  Araki Ken  <arakiken@users.sf.net>

	* x_event_source.c, x_screen.c: x_display_sync() is called in receive_next_event()
	  and interrupt_vt100_cmd().

	* x_display.[ch]: x_display_sync() is added.

2014-07-27  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.c: Minor fixes around ml_vt100_parser_t::yield.

2014-07-26  Araki Ken  <arakiken@users.sf.net>

	* doc/ja/README.ja, man/mlterm.1: Updated.

	* ml_vt100_parser.c: fclose(fp) and free(path) are called before return 0
	  in processing sixel sequence.

2014-07-26  Araki Ken  <arakiken@users.sf.net>

	* x_main_config.c, x_screen.c: --seqfmt/vt_seq_format option is added.

	* ml_vt100_parser.[ch]: ml_set_use_ttyrec_format() enables or disables to log
	  vt100 sequence by ttyrec format.

2014-07-25  Araki Ken  <arakiken@users.sf.net>

	* ml_bidi.c, x_picture.c: ml_get_picture_char() is used.

	* ml_char.[ch]: ml_get_picture_char() is added.

	* x_screen.c: interrupt_vt100_cmd() is added.

	* ml_vt100_parser.[ch]:
	  - interrupt event is added to ml_xterm_event_listener_t.
	  - ml_xterm_event_listener_t::interrupt is called if sixel graphics is drawn
	    by DECINVM.
	  - The amount of reading data from pty once is shrinked if buffered data
	    isn't DCS or OSC.
	  - new_len is added to ml_read_buffer_t, and only newly received data is
	    parsed in restarting to parse DCS or OSC in  parse_vt100_escape_sequence().

2014-07-23  Araki Ken  <arakiken@users.sf.net>

	* ml_drcs.[ch], ml_vt100_parser.[ch]: const is added to some arguments.

2014-07-21  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.c:
	  - hex_to_text() is optimized.
	  - define_macro() deletes specified entry if *data is '\0'.

2014-07-21  Araki Ken  <arakiken@users.sf.net>

	* x_picture.c, xlib/x_imagelib.c: ~/.mlterm/macro_*.six is cached.

	* ml_vt100_parser.[ch]:
	  - DECDMAC/DECINVM are supported.
	  - If DECDMAC defines sixel graphics data, store it in ~/.mlterm/macro_*.six and
	    show it by DECINVM.

2014-07-19  Araki Ken  <arakiken@users.sf.net>

	* MLTermPty.c:
	  - "use_auto_detect" and "auto_detect_encodings" are supported.
	  - replaceTextBuffering(0,0,null,null) is called in checkTextLimit().

	* x_screen.c, doc/en/PROTOCOL: "auto_detect_encodings" is added to OSC 5380 and 5381.

	* ml_vt100_parser.[ch]:
	  - ml_get_auto_detect_encodings() is added.
	  - ISO8859_6_R (arabic) and ISO8859_8_R (hebrew) are always converted to
	    unicode because they need bidi rendering.

	* mc_io.[ch]: 'const' is added.

	* mc_auto_detect.[ch]: Added.

	* mc_check.[ch]: Removed.

	* ml_pty.c: Parenthesis is added.

2014-07-15  Araki Ken  <arakiken@users.sf.net>

	* x_screen.c: ml_line_is_empty() in start_selection() and selecting_with_motion()
	  is removed.

	* ml_screen.c: convert_col_to_char_index() is fixed.

2014-07-14  Araki Ken  <arakiken@users.sf.net>

	* x_display_wscons.c: The null pointer bug of_display.color_cache in the case
	  of vinfo.depth >= 2 && _disp.depth == 1 is fixed.

2014-07-13  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.c: Compiling error is fixed.

	* ml_screen.c, x_screen.c:
	  ml_term_get_cols(screen->term) - line->num_of_chars
	  => ml_term_get_cols(screen->term) - ml_line_get_num_of_filled_cols(line)

	* x_selection.c: conved flag is added in update_sel_region() instead of
	  col != conved_col because it doesn't works if col == 0.

2014-07-13  Araki Ken  <arakiken@users.sf.net>

	* ml_screen.[ch], ml_term.h, x_screen.c, x_selection.[ch]:
	  Rectangle selection is supported.

	* win32/x_window.c: get_key_state() is set to XButtonEvent::state in
	  x_window_receive_event().

	* ml_line.c:
	  - ml_line_{reverse|restore}_color() calls ml_line_set_modified()
	    only if ml_char_{reverse|restore}_color() returns 1.
	  - BREAK_BOUNDARY works in ml_convert_char_index_to_col() works even if
	    specified line is empty.

	* ml_char.c: Minor fixes.

2014-07-10  Araki Ken  <arakiken@users.sf.net>

	* configure.in: "-lfontconfig -lfreetype" is added to CAIRO_LIBS and XFT_LIBS
	  because mlterm has undefined symbols if --disable-shared is specified on
	  some platforms where dependency_libs="" in libcairo.la.

2014-07-09  Araki Ken  <arakiken@users.sf.net>

	* x_display_freebsd.c: Duplicated capslock processing is fixed.

	* jni/x_display.c: Minor fixes.

2014-07-08  Araki Ken  <arakiken@users.sf.net>

	* x_display_x68kgrf.c:
	  - Keyboard events from /dev/kbd are processed instead of stdin.
	  - x68k_set_use_tvram_colors() and x68k_set_tvram_cmap() resets
	    _display.color_cache.

	* x.h: KS_Print -> KS_Print_Screen

	* x_display.c: Key squences on NetBSD/x68k are added to the table in
	  receive_stdin_key_event().

2014-07-08  Araki Ken  <arakiken@users.sf.net>

	* libtype/Makefile.in: Compiling error is fixed.

	* version.h.in: 3.3.7 -> 3.3.7post

2014-07-06  Araki Ken  <arakiken@users.sf.net>

	* 3.3.7 released.
	  (tag "rel-3_3_7")

	* configure.in, mlterm.spec, main/version.h.in,
	  MLTermPty.c, android/jni/version.h, doc/en/ReleaseNote:
	  updated for 3.3.7.

2014-07-06  Araki Ken  <arakiken@users.sf.net>

	* x_shortcut.c: Minor fixes.

	* gtk/vte.c: If cmd_path is omittted in argv, argv[0] = cmd_path.

2014-07-05  Araki Ken  <arakiken@users.sf.net>

	* kik_str.c: Illegal memory allocation is fixed.

	* x_shortcut.c: [operation]=[key] format is obsoleted.

2014-07-05  Araki Ken  <arakiken@users.sf.net>

	* kik_str.c, x_shortcut.c: kik_str_unescape() hack for x_shortcut.c is removed.

2014-07-05  Araki Ken  <arakiken@users.sf.net>

	* mlclient/main.c: Minor fixes.

	* main_loop.c: --deffont option is added.

	* README.ja, mlterm.1: Updated.

	* ml_bidi.c: U+2500-259f and DEC_SPECIAL characters are forcibly regarded as bidi
	  separator ones.

	* ml_term.c: kik_str_unescape(bidi_separators) is called.

	* ml_screen.c: kik_str_unescape(word_separators) is called.

2014-06-30  Araki Ken  <arakiken@users.sf.net>

	* ml_pty.[ch], ml_pty_inter.h, ml_pty_unix.c, ml_term.[ch], x_main_config.[ch],
	  x_screen_manager.c:
	  chdir(work_dir) if --work-directory option is specified.

	* mlterm.1, mlclient.1, README.ja, PROTOCOL, etc/main, etc/main.ja: Updated.

2014-06-29  Araki Ken  <arakiken@users.sf.net>

	* ml_bidi.c: Minor fixes.

2014-06-28  Araki Ken  <arakiken@users.sf.net>

	* x_main_config.c, x_screen.c: ml_set_bidi_separators() is changed to
	  ml_term_{get|set}_bidi_separators().

	* ml_term.[ch], ml_term_manager.[ch], x_screen_manager.c:
	  - bidi_separators variable is changed from static to the member of ml_term_t.
	  - ml_term_{get|set}_bidi_separators() are added.
	  - ml_set_bidi_separators() is removed.

	* vte.c, MLTermpty.c: Arguments of ml_create_term() is fixed.

	* ml_vt100_parser.[ch]: Minor fixes.

2014-06-28  Araki Ken  <arakiken@users.sf.net>

	* mlterm.1, README.ja: Updated.

	* libctl/ml_bidi.[ch], ml_line_bidi.[ch], ml_logical_visual_bidi.c,
	  mlterm/ml_bidi.[ch], ml_logical_visual.[ch], ml_term.[ch], x_screen.c,
	  x_main_config.c:
	  - bidi_separator option is added.
	  - "left" and "right" are available as the value of bidi_mode option.

	* libptyssh/ml_pty_ssh.c: Unread data in loopback pty isn't discarded.

	* mc_io.c: HOEMPATH environmental variable is used instead of HOME in win32.

2014-06-24  Araki Ken  <arakiken@users.sf.net>

	* x_draw_str.c: If ml_char_is_visible() is false, text is not drawn.

	* ml_char.[ch]:
	  - IS_CONCEALED => IS_VISIBLE
	  - ml_char_is_visible() is added.

2014-06-22  Araki Ken  <arakiken@users.sf.net>

	* MLTermPty.c, MLTerm.java, Style.java: SGR 9 and 29 are supported.

	* ml_screen.[ch], ml_term.h, x_screen.c: 'visible' argument is added to
	  ml_term_blink() and ml_screen_blink().

	* ml_char.[ch]: ml_char_blink() => ml_char_set_visible()

	* ml_vt100_parser.c: put_char() is fixed.

2014-06-21  Araki Ken  <arakiken@users.sf.net>

	* vte.c: set_colors() is fixed.

	* man/mlterm.1, doc/ja/README.ja: Updated.

	* x_main_config.[ch]: --it/it_color, --bl/bl_color, --co/co_color and
	  --itfont/use_italic_font options are added.

	* x_font_manager.[ch]: x_set_use_italic_font() is added.

	* vte.c, MLTermPty.c, ml_term_manager.[ch]: Fixes by the change of
	  the arguments of x_font_manager_new(), x_color_manager_new() and
	  ml_create_term().

	* x_draw_str.[ch]: adjust_bd_ul_color() is removed.

	* x_color_manager.[ch]:
	  - _ITALIC_COLOR, _BLINKING_COLOR and CROSSED_OUT_COLOR are managed in
	    x_color_manager_t::sys_colors.
	  - x_color_manager_{set|get}_{bd|ul}_color() ->
	    x_color_manager_{set|get}_alt_color().
	  - x_color_manager_adjust_{bd|ul}_color() are removed.

	* ml_term.[ch]: ml_term_{set|get}_alt_color_mode() are added.

	* ml_vt100_parser.[ch]:
	  - ml_alt_color_mode_t is added.
	  - ml_vt100_parser_{set|get}_alt_color_mode() are added.
	  - vt100_parser->alt_color_mode is checked in put_char().

	* ml_color.h: ML_BOLD_COLOR, ML_ITALIC_COLOR, ML_UNDERLINE_COLOR,
	  ML_BLINKING_COLOR, ML_CROSSED_OUT_COLOR are added.

2014-06-20  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.[ch], x_screen.[ch]: SGR 5 and 25 are supported.

	* ml_term.h: ml_term_blink() is added.

	* ml_screen.[ch]: ml_screen_blink() and ml_screen_enable_blinking() are added.

	* im_fcitx.c, im_ibus.c, im_m17nlib.c, im_scim_mod_if.c, im_uim.c,
	  ml_screen.[ch], x_im.h, x_im_{candidate|status}_screen.c:
	  Fixes by is_blinking of ml_char_{set|combine}().

	* ml_char.[ch]: is_blinking is added to ml_char_{set|combine}(), and
	  ml_char_is_blinking() and ml_char_blink() are added.

	* x_picture.c: ~/.mlterm/anim* are completely removed on exit.

	* fb/x_display.c, win32/x_display.c: x_picture_display_closed() is called in
	  x_display_close_all().

2014-06-16  Araki Ken  <arakiken@users.sf.net>

	* x_im.h, im_*.c: is_crossed_out argument is added to x_im_export_syms_t::ml_char_set
	  and ::ml_char_combine(), and IM_API_VERSION is changed from 0x09 to 0x0a.

	* x_font_config.c, ml_vt100_parser.c: ml_parse_unicode_area() is used.

	* ml_char_encoding.[ch]: ml_parse_unicode_area() is added.

2014-06-15  Araki Ken  <arakiken@users.sf.net>

	* doc/ja/README.ja, man/mlterm.1, doc/en/PROTOCOL: Updated.

	* ml_vt100_parser.[ch], x_main_config.c:
	  full_width_areas => unicode_full_width_areas

2014-06-15  Araki Ken  <arakiken@users.sf.net>

	* doc/ja/README.ja, man/mlterm.1: Updated.

	* x_font_config.c: "_HALFWIDTH" suffix is removed.

	* ml_vt100_parser.[ch], x_main_config.c:
	  "use_unicode_property" option is removed.

	* mc_font.c: "UNICODE (EMOJI)" is added.

	* ml_vt100_parser.[ch], x_main_config.c:
	  "full_width_areas" option which forces full width regardless of
	  EastAsianWidth.txt is added.

2014-06-13  Araki Ken  <arakiken@users.sf.net>

	* ml_edit.[ch], ml_screen.h, ml_vt100_parser.c:
	  ml_{edit|screen}_scroll_{left|right}ward() are added and used to process
	  SL and SR.

2014-06-10  Araki Ken  <arakiken@users.sf.net>

	* ml_char.[ch], ml_vt100_parser.[ch], x_draw_str.c:
	  is_underlined => underline_style

2014-06-09  Araki Ken  <arakiken@users.sf.net>

	* ml_vt100_parser.c: ML_BOLD_COLOR_MASK is not set to ML_{FG|BG}_COLOR.

	* xlib/x_color.c: Fix alloc_closest_xcolor_pseudo().

	* fb/x.h, fb/x_display.c: #ifdef LARGE_CACHE => #ifndef COLOR_CACHE_MINIMUM.

	* README.ja, man/mlterm.1: Updated.

2014-06-09  Araki Ken  <arakiken@users.sf.net>

	* fb/x.h, fb/x_display.c: LARGE_CACHE is added. (disabled by default.)

2014-06-09  Araki Ken  <arakiken@users.sf.net>

	* fb/x.h, fb/x_display.c: Caching in x_cmap_get_closest_color() is improved.

	* main_loop.c: Starting mlterm with -j option executes mlclient if daemon
	  process has already started.

	* daemon.[ch]:
	  - free(un_file) is called in daemon_final().
	  - daemon_get_fd() is removed.

	* x_screen_manager.c: mlclient permits unknown options.

	* kik_conf.[ch]: ignore_unknown_opt argument is added to kik_conf_parse_args().

